;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Count the number of records in an SQLite database
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.s CountRecords(TableField.s, TableName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s           + 

  "Select COUNT("         + 

  TableField.s            + 

  ") AS totalrecs FROM "  + 

  TableName.s             + 

  #Empty$
  
  ;------------------------------------------------------------------------------------------------
  ; Get the count of the records in the database
  ;------------------------------------------------------------------------------------------------

  If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
    
    If FirstDatabaseRow(Program\DatabaseHandle)

      NumberOfRecords.s = GetDatabaseString(Program\DatabaseHandle, 0)
      
    EndIf

    FinishDatabaseQuery(Program\DatabaseHandle)
  
  Else
    
    NumberOfRecords.s = "0"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn NumberOfRecords.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure



; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 6
; Folding = -
; DisableDebugger
; HideErrorLog
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant