;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Archive this stuff to permanent storage
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure ArchiveThisData()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected CurrentLine.i, CurrentCategory.s, CurrentRecord.s
  
  Protected FavouriteState.s, LockedState.s,  DeletedState.s, ArchivedState.s
  
  ;------------------------------------------------------------------------------------------------
  ; Get the number of the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i     = GetGadgetState(#Gadget_MyInfo_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentCategory.s = GetGadgetText(#Gadget_MyInfo_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current toggle states
    ;----------------------------------------------------------------------------------------------
    
    ArchivedState.s  = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #ArchivedColumn)

    FavouriteState.s = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #FavouriteColumn)
    
    LockedState.s    = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #LockedColumn)
    
    DeletedState.s   = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #DeletedColumn)
    
    CurrentRecord.s  = GetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If FavouriteState.s = "1"
      
      SetInfoBarArea("Headings", "Warn", "You cannot archive favourite stuff, you must unmark it first.", #PB_Compiler_Procedure)
      
      ProcedureReturn
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If LockedState.s = "1"
      
      SetInfoBarArea("Headings", "Warn", "You cannot archive locked stuff, unlock it first.", #PB_Compiler_Procedure)
      
      ProcedureReturn
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DeletedState.s = "1"
      
      SetInfoBarArea("Headings", "Warn", "You cannot archive deleted stuff, undelete it first.", #PB_Compiler_Procedure)
      
      ProcedureReturn
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If  ArchivedState.s      = "0"
      
      ArchivedState.s        = "1"
      
    ElseIf  ArchivedState.s = "1"
      
      ArchivedState.s        = "0"
      
    EndIf        
    
    ;----------------------------------------------------------------------------------------------
    ; Proceed if we got a record number
    ;----------------------------------------------------------------------------------------------
    
    If CurrentRecord.s  <> #Empty$
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      DatabaseQuery.s             +

      "UPDATE MyInfo "            + 

      "SET Archived = "           + 

      ArchivedState.s             + 
      
      " "                         + 

      "WHERE Recordid = '"        + 

      CurrentRecord.s             +

      "'"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseUpdate(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseUpdateFail
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Headings", "Info", "Record " + CurrentRecord.s + " has been updated", #PB_Compiler_Procedure)
        
        ;------------------------------------------------------------------------------------------
        ; Set the correct icon in the ListIcongadget for normal or favourite stuff
        ;------------------------------------------------------------------------------------------
        
        If ArchivedState <> "1"
          
          If LockedState.s = "1"
            
            SetGadgetItemImage(#Gadget_MyInfo_Titles, CurrentLine.i, ImageID(#Image_ListLocked))
            
          ElseIf  LockedState.s <> "1"
            
            If DeletedState.s = "1"
              
              SetGadgetItemData(#Gadget_MyInfo_Titles, CurrentLine.i, Val(DeletedState.s))
              
              SetGadgetItemImage(#Gadget_MyInfo_Titles, CurrentLine.i, ImageID(#Image_ListDeleted))
              
              RedrawWindow_(GadgetID(#Gadget_MyInfo_Titles), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
              
            ElseIf DeletedState.s <> "1"
              
              If FavouriteState.s = "1"
                
                SetGadgetItemImage(#Gadget_MyInfo_Titles, CurrentLine.i, ImageID(#Image_ListFavourite))
                
              ElseIf FavouriteState.s <> "1"
                
                SetGadgetItemImage(#Gadget_MyInfo_Titles, CurrentLine.i, ImageID(#Image_ListNormal))
                
              EndIf
              
            EndIf
            
          EndIf
          
        Else
          
          SetGadgetItemImage(#Gadget_MyInfo_Titles, CurrentLine.i, ImageID(#Image_ListArchived))            
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetItemText(#Gadget_MyInfo_Titles, CurrentLine.i, ArchivedState.s, #ArchivedColumn)
        
        ;------------------------------------------------------------------------------------------
        ; Remove the item from the current view if it doesn't match the shown category
        ;------------------------------------------------------------------------------------------
        
        If CurrentCategory.s = "All items" And ArchivedState.s = "1"
          
          RemoveGadgetItem(#Gadget_MyInfo_Titles, CurrentLine.i)
          
        ElseIf  CurrentCategory.s = "Archived" And ArchivedState.s = "0"
          
          RemoveGadgetItem(#Gadget_MyInfo_Titles, CurrentLine.i)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", "The database update query failed. " + DatabaseError(), #PB_Compiler_Procedure)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "There was no record number found on the current line.", #PB_Compiler_Procedure)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There was no current line selected.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
  
; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 214
; FirstLine = 190
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant