;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Handle all list display jobs from add, edit, list, import modes etc
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure DisplayTitleString(LineNumber.i, DisplayMode.s)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Select DisplayMode.s

    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case  "AddMode"
    
      ;--------------------------------------------------------------------------------------------
      ; Add MyInfo items to the list
      ;--------------------------------------------------------------------------------------------
      
      TitleString.s       = MyInfo\Title         +  " (" +   MyInfo\Attachments  + ")"  + #LF$
      
     ;InformationString.s = MyInfo\Information                                          + #LF$
      
      CategoryString.s    = MyInfo\Category                                             + #LF$
      
      ArchivedString.s    = MyInfo\Archived                                             + #LF$
      
      FavouriteString.s   = MyInfo\Favourite                                            + #LF$

      LockedString.s      = MyInfo\Locked                                               + #LF$
      
      DeletedString.s     = MyInfo\Deleted                                              + #LF$
      
      UpdatedString.s     = MyInfo\Updated                                              + #LF$
      
      OwnerString.s       = MyInfo\Owner                                                + #LF$
      
      AttachmentString.s  = MyInfo\Attachments                                          + #LF$
      
      RecordString.s      = MyInfo\Recordid

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ListString.s        = TitleString.s     + CategoryString.s    + ArchivedString.s
      
      ListString.s        + FavouriteString.s + LockedString.s      + DeletedString.s

      ListString.s        + UpdatedString.s   + OwnerString.s       + AttachmentString.s
      
      ListString.s        + RecordString.s

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      AddGadgetItem(#Gadget_MyInfo_Titles, #AtTheEndOfTheList,  KillQuote(ListString.s))
      
      ;--------------------------------------------------------------------------------------------
      ; Set a single colum to a different colour
      ;--------------------------------------------------------------------------------------------

      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $0000FF, #TitleColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $00FF00, #CategoryColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $00FFFF, #ArchivedColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $00FFFF, #FavouriteColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $FF0000, #LockedColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $FF00FF, #DeletedColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $FFFF00, #UpdatedColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $FF0000, #OwnerColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $000080, #AttachmentsColumn)
      
      SetGadgetItemColor(#Gadget_MyInfo_Titles, #PB_All, #PB_Gadget_FrontColor, $008000, #RecordColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ListString.s = #Empty$

      ;--------------------------------------------------------------------------------------------
      ; Update columns in the list for an edited record
      ;--------------------------------------------------------------------------------------------
      
    Case  "EditMode"
      
      ;--------------------------------------------------------------------------------------------
      ; Update the details in the list for the selected record
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i, KillQuote(MyInfo\Title) +  " (" +   MyInfo\Attachments  + ")", #TitleColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i, KillQuote(MyInfo\Category),                                    #CategoryColumn)
      
     ;SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i, KillQuote(MyInfo\Information),                                 #InformationColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i,           MyInfo\Archived,                                     #ArchivedColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i,           MyInfo\Favourite,                                    #FavouriteColumn)

      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i,           MyInfo\Locked,                                       #LockedColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i,           MyInfo\Deleted,                                      #DeletedColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i,           MyInfo\Updated,                                      #UpdatedColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i,           MyInfo\Owner,                                        #OwnerColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i,           MyInfo\Attachments,                                  #AttachmentsColumn)
      
      SetGadgetItemText(#Gadget_MyInfo_Titles, LineNumber.i,           MyInfo\Recordid,                                     #RecordColumn)

      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If MyInfo\Archived <> "1"
    
    If MyInfo\Locked = "1"
      
      SetGadgetItemImage(#Gadget_MyInfo_Titles, LineNumber.i, ImageID(#Image_ListLocked))
      
    ElseIf  MyInfo\Locked <> "1"
      
      If MyInfo\Deleted = "1"
        
        SetGadgetItemData(#Gadget_MyInfo_Titles,  LineNumber.i, Val(MyInfo\Deleted))
        
        RedrawWindow_(GadgetID(#Gadget_MyInfo_Titles), 0, 0, #RDW_INVALIDATE | #RDW_ERASE)
        
        SetGadgetItemImage(#Gadget_MyInfo_Titles, LineNumber.i, ImageID(#Image_ListDeleted))
        
      ElseIf MyInfo\Deleted <> "1"
        
        If MyInfo\Favourite = "1"
          
          SetGadgetItemImage(#Gadget_MyInfo_Titles, LineNumber.i, ImageID(#Image_ListFavourite))
          
        ElseIf MyInfo\Favourite <> "1"
          
          SetGadgetItemImage(#Gadget_MyInfo_Titles, LineNumber.i, ImageID(#Image_ListNormal))
          
        EndIf
        
      EndIf
      
    EndIf
    
  Else
    
    SetGadgetItemImage(#Gadget_MyInfo_Titles, LineNumber.i, ImageID(#Image_ListArchived))
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 124
; FirstLine = 120
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant