;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SearchDataForm()
  
  ;------------------------------------------------------------------------------------------------
  ; Try to open the data window
  ;------------------------------------------------------------------------------------------------
  
  If Window_Find()
    
    ;----------------------------------------------------------------------------------------------
    ; Prevent user input on the main window
    ;----------------------------------------------------------------------------------------------
    
    DisableWindow(#Window_Data, #True)
    
    ;----------------------------------------------------------------------------------------------
    ; Add keyboard shortcuts as backup to the buttons, Good for people with sore mouse wrists
    ;----------------------------------------------------------------------------------------------
    
    AddKeyboardShortcut(#Window_Find, #ShortcutValue_SearchDataForm,         #KeyboardShortcut_SearchDataForm)
    
    AddKeyboardShortcut(#Window_Find, #ShortcutValue_EscapeFind,             #KeyboardShortcut_EscapeFind)
    
    ;----------------------------------------------------------------------------------------------
    ; Set the window title with the common message and next record number
    ;----------------------------------------------------------------------------------------------
    
    SetWindowTitle(#Window_Find, "Search data form")
    
    ;----------------------------------------------------------------------------------------------
    ; Limit the number of search box characters and set the cue banner text. These variables are 
    ; set in the MyInfo_Myconstants file.
    ;----------------------------------------------------------------------------------------------
    
    SendMessage_(GadgetID(#Gadget_Find_Finddata), #EM_SETLIMITTEXT, 67, 0)
    
    SendMessage_(GadgetID(#Gadget_Find_Finddata), #EM_SETCUEBANNER,  1,  Cue\SearchCueText)
    
    ;----------------------------------------------------------------------------------------------
    ; Set initial search cue font
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetFont(#Gadget_Find_Finddata, FontID(Cue\SearchCueFont))
    
    ;----------------------------------------------------------------------------------------------
    ; Set focus on the appointment name field
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_Find_Finddata)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ;HideWindow(#Window_Find, #False)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "Could not open the [SearchDataForm] window.", #PB_Compiler_Procedure)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 59
; FirstLine = 32
; Folding = -
; EnableAsm
; EnableThread
; EnableXP
; EnableOnError
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant