﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SortCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected IconHandle.i, NumberOfItems.i, LoopCounter.i

  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_OwnerList_Owners)
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon. That is standard categories + two others
  ;------------------------------------------------------------------------------------------------
  
  If NumberOfItems.i > 1
    
    ;----------------------------------------------------------------------------------------------
    ; Get number items in ListIcon
    ;----------------------------------------------------------------------------------------------
    
    NewList Owner.OwnerData()
    
    ;----------------------------------------------------------------------------------------------
    ; Place each item text into the list. Must start at Zero
    ;----------------------------------------------------------------------------------------------
    
    For LoopCounter.i = 0 To NumberOfItems.i - 1
      
      AddElement(Owner())
      
      Owner()\Owner       = GetGadgetItemText(#Gadget_OwnerList_Owners, LoopCounter.i, #OwnerTitleColumn)
      
      Owner()\ItemCount   = GetGadgetItemText(#Gadget_OwnerList_Owners, LoopCounter.i, #OwnerItemsColumn)
      
      Owner()\Iconname    = GetGadgetItemText(#Gadget_OwnerList_Owners, LoopCounter.i, #OwnerIconColumn)
      
      Owner()\Ownerid     = GetGadgetItemText(#Gadget_OwnerList_Owners, LoopCounter.i, #OwnerRecordColumn)
      
    Next LoopCounter.i
    
    ;----------------------------------------------------------------------------------------------
    ; Sort the Array in ascending order
    ;----------------------------------------------------------------------------------------------
    
    SortStructuredList(Owner(), #PB_Sort_Ascending, OffsetOf(OwnerData\Owner), #PB_String)
    
    ;----------------------------------------------------------------------------------------------
    ; Now replace ListIcon Items from the sorted Array
    ;----------------------------------------------------------------------------------------------
    
    ForEach Owner()
      
      SetGadgetItemText(#Gadget_OwnerList_Owners, ListIndex(Owner()), Owner()\Owner,      #OwnerTitleColumn)
      
      SetGadgetItemText(#Gadget_OwnerList_Owners, ListIndex(Owner()), Owner()\ItemCount,  #OwnerItemsColumn)
      
      SetGadgetItemText(#Gadget_OwnerList_Owners, ListIndex(Owner()), Owner()\Iconname,   #OwnerIconColumn)
      
      SetGadgetItemText(#Gadget_OwnerList_Owners, ListIndex(Owner()), Owner()\Ownerid,    #OwnerRecordColumn)
      
      If Owner()\Iconname  <>  #Empty$
        
        If FileSize(Program\OwnerIcons  + Owner()\Iconname) <> #NoPictureFound
          
          IconHandle.i = LoadImage(#PB_Any, Program\OwnerIcons  + Owner()\Iconname)
          
          If IconHandle.i <> #NoPictureLoaded
            
            SetGadgetItemImage(#Gadget_OwnerList_Owners, ListIndex(Owner()), ImageID(IconHandle.i))
            
          Else
            
            SetGadgetItemImage(#Gadget_OwnerList_Owners, ListIndex(Owner()), ImageID(#Image_ListNoowner))
          
          EndIf
          
        EndIf
        
      EndIf
      
    Next Owner()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearList(Owner())
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableUnicode