;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Show a password lock screen at program start
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure StartPassWordWindow()
  
  ;------------------------------------------------------------------------------------------------
  ; Open the startup password window
  ;------------------------------------------------------------------------------------------------
  
  If Window_StartUpPassword()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Global QuitPasswordValue.i = #False
    
    ;----------------------------------------------------------------------------------------------
    ; Make sure password window stays on top of all else
    ;----------------------------------------------------------------------------------------------
    
    StickyWindow(#Window_StartUpPassword, #True)
    
    ;----------------------------------------------------------------------------------------------
    ; Setup statusbar and title message
    ;----------------------------------------------------------------------------------------------
    
    Program\LastWindow = "Program startup password"
    
    ;----------------------------------------------------------------------------------------------
    ; Add the window shortcuts
    ;----------------------------------------------------------------------------------------------
    
    AddKeyboardShortcut(#Window_StartUpPassword, #ShortcutValue_StartUpPassword_Return,   #KeyboardShortCut_StartUpPassword_Return)
    
    AddKeyboardShortcut(#Window_StartUpPassword, #ShortcutValue_StartUpPassword_Escape,   #KeyboardShortCut_StartUpPassword_Escape)
    
    ;----------------------------------------------------------------------------------------------
    ; Setup default window title
    ;----------------------------------------------------------------------------------------------
    
    SetWindowTitle(#Window_StartUpPassword, "Type " + #Program + " startup password.")
    
    ;----------------------------------------------------------------------------------------------
    ; Make this window active
    ;----------------------------------------------------------------------------------------------
    
    SetActiveWindow(#Window_StartUpPassword)
    
    ;----------------------------------------------------------------------------------------------
    ; Make the password field active
    ;----------------------------------------------------------------------------------------------
    
    SetActiveGadget(#Gadget_StartupPassword_UnlockPassWord)
    
    ;----------------------------------------------------------------------------------------------
    ; Make sure this window isn't hidden
    ;----------------------------------------------------------------------------------------------
    
    HideWindow(#Window_StartUpPassword, #False)
    
    ;----------------------------------------------------------------------------------------------
    ; Main event processing area
    ;----------------------------------------------------------------------------------------------
    
    Repeat
      
      EventID  =  WaitWindowEvent()
      MenuID   =  EventMenu()
      GadgetID =  EventGadget()
      WindowID =  EventWindow()
      
      ;------------------------------------------
      ; 
      ;------------------------------------------
      
      Select EventID
          
        Case #PB_Event_CloseWindow
          Select WindowID
            Case #Window_StartUpPassword                    : End
          EndSelect
          
        Case #PB_Event_Menu
          Select MenuID
            Case #KeyboardShortCut_StartUpPassword_Return   : CheckStartUpPassword()
            Case #KeyboardShortCut_StartUpPassword_Escape   : End
          EndSelect
          
      EndSelect
      
    Until QuitPasswordValue.i = #True
    
    CloseWindow(#Window_StartUpPassword)
    
  EndIf
  
  ;----------------------------------------------
  ; 
  ;----------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 89
; FirstLine = 63
; Folding = -
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0