﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

CompilerIf Defined(ENM_LINK, #PB_Constant)
CompilerElse
  #ENM_LINK = $04000000
CompilerEndIf

CompilerIf Defined(CFM_LINK, #PB_Constant)
CompilerElse
  #CFM_LINK = $00000020
CompilerEndIf

CompilerIf Defined(CFE_LINK, #PB_Constant)
CompilerElse
  #CFE_LINK = $0020
CompilerEndIf

CompilerIf Defined(CFE_SUBSCRIPT, #PB_Constant)
CompilerElse
  #CFE_SUBSCRIPT = $00010000
CompilerEndIf

CompilerIf Defined(CFE_SUPERSCRIPT, #PB_Constant)
CompilerElse
  #CFE_SUPERSCRIPT = $00020000
CompilerEndIf

CompilerIf Defined(CFM_SUBSCRIPT, #PB_Constant)
CompilerElse
  #CFM_SUBSCRIPT = #CFE_SUBSCRIPT | #CFE_SUPERSCRIPT
  #CFM_SUPERSCRIPT = #CFM_SUBSCRIPT
CompilerEndIf

CompilerIf Defined(CFM_BACKCOLOR, #PB_Constant)
CompilerElse
  #CFM_BACKCOLOR = $4000000
CompilerEndIf 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#PD_ALLPAGES                    = $00000000
#PD_COLLATE                     = $10
#PD_DISABLEPRINTTOFILE          = $80000
#PD_ENABLEPRINTHOOK             = $1000
#PD_ENABLEPRINTTEMPLATE         = $4000
#PD_ENABLEPRINTTEMPLATEHANDLE   = $10000
#PD_ENABLESETUPHOOK             = $2000
#PD_ENABLESETUPTEMPLATE         = $8000
#PD_ENABLESETUPTEMPLATEHANDLE   = $20000
#PD_HIDEPRINTTOFILE             = $100000
#PD_NONETWORKBUTTON             = $200000
#PD_NOPAGENUMS                  = $8
#PD_NOSELECTION                 = $4
#PD_NOWARNING                   = $80
#PD_PAGENUMS                    = $2
#PD_PRINTSETUP                  = $40
#PD_PRINTTOFILE                 = $20
#PD_RETURNDC                    = $100
#PD_RETURNDEFAULT               = $400
#PD_RETURNIC                    = $200
#PD_SELECTION                   = $1
#PD_SHOWHELP                    = $800
#PD_USEDEVMODECOPIES            = $40000
#PD_USEDEVMODECOPIESANDCOLLATE  = $40000

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; RTF structure data from Freak (Timo Harter)
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure CHARFORMAT2_
  cbSize.l
  dwMask.l 
  dwEffects.l 
  yHeight.l 
  yOffset.l 
  crTextColor.l 
  bCharSet.b 
  bPitchAndFamily.b 
  szFaceName.b[#LF_FACESIZE] 
  _wPad2.w 
  wWeight.w 
  sSpacing.w 
  crBackColor.l 
  lcid.l 
  dwReserved.l 
  sStyle.w 
  wKerning.w 
  bUnderlineType.b 
  bAnimation.b 
  bRevAuthor.b 
  bReserved1.b
EndStructure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global PrinterDC, EStream.EDITSTREAM

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Declare   SStreamCB(dwCookie, pbBuff, cb, pcb)
Declare   SetRtfMargin(Gad, PageW,PageH, LM, TM, RM, BM)
Declare   StartRtfPrint(Doc.s)
Declare   PrintRichText(hWnd, hInst, rtfEdit, LM, TM, RM, BM)
Declare   StreamFileInCallback(hFile, pbBuff, cb, pcb)
Declare   LoadRtfFile(pFilePath.s)

Declare   Editor_SearchText(GadgetNumber.i, SearchText.s, Flags.i)
Declare   Editor_ClearBackgroundColour(GadgetNumber.i)
Declare   Editor_BackgroundColour(GadgetNumber.i, BackgroundColour.i)

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SStreamCB(dwCookie, pbBuff, cb, pcb)
  ProcedureReturn WriteFile_(dwCookie, pbBuff, cb, pcb, 0) ! 1
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure SetRtfMargin(Gad, PageW,PageH, LM, TM, RM, BM)
  r.RECT
  r\left    = LM
  r\top     = TM
  r\right   = PageW - RM
  r\bottom  = PageH - BM
  SendMessage_(GadgetID(Gad), #EM_SETRECTNP, 0, r)
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure  StartRtfPrint(Doc.s)
  d.DOCINFO
  d\cbSize      = SizeOf(d)
  d\lpszDocName = @Doc
  d\lpszOutput  = 0
  StartDoc_(PrinterDC,  d)
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure PrintRichText(hWnd, hInst, rtfEdit, LM, TM, RM, BM)
  pd.PRINTDLG
 
  pd\lStructSize          = SizeOf(PRINTDLG)
  pd\hwndOwner            = hWnd
  pd\hDevMode             = 0
  pd\hDevNames            = 0
  pd\nFromPage            = 0
  pd\nToPage              = 0
  pd\nMinPage             = 0
  pd\nMaxPage             = 0
  pd\nCopies              = 0
  pd\hInstance            = hInst
  pd\Flags                = #PD_HIDEPRINTTOFILE | #PD_NONETWORKBUTTON |#PD_RETURNDC | #PD_PRINTSETUP
  pd\lpfnSetupHook        = 0
  pd\lpSetupTemplateName  = 0
  pd\lpfnPrintHook        = 0
  pd\lpPrintTemplateName  = 0
   
  If PrintDlg_(pd)
    PrinterDC = pd\hDC
  Else
    PrinterDC = DefaultPrinter()
  EndIf
 
  If PrinterDC
    cxPhysOffset = GetDeviceCaps_(PrinterDC, #PHYSICALOFFSETX)
    cyPhysOffset = GetDeviceCaps_(PrinterDC, #PHYSICALOFFSETY)
   
    cxPhys = GetDeviceCaps_(PrinterDC, #PHYSICALWIDTH)
    cyPhys = GetDeviceCaps_(PrinterDC, #PHYSICALHEIGHT)
    
    SendMessage_(rtfEdit, #EM_SETTARGETDEVICE, PrinterDC, cxPhys * 20)

    fr.FORMATRANGE       
    fr\hdc        = PrinterDC
    fr\hdcTarget  = PrinterDC
   
    fr\chrg\cpMin     = 0
    fr\chrg\cpMax     = -1
       
    fr\rcPage\left    = 0
    fr\rcPage\top     = 0
    fr\rcpage\right   = 0
    fr\rcPage\bottom  = 0
   
    fr\rc\left   = LM * 20
    fr\rc\top    = TM * 20
    fr\rc\right  = cxPhys * 1440 / GetDeviceCaps_(PrinterDC, #LOGPIXELSX)- RM * 20
    fr\rc\Bottom = cyPhys * 1440 / GetDeviceCaps_(PrinterDC, #LOGPIXELSY)- BM * 20
   
    StartRtfPrint("RTF Printing")
    StartPage_(PrinterDC)
   
    iTextOut = 0
    iTextAmt = SendMessage_(rtfEdit, #WM_GETTEXTLENGTH, 0, 0)
    While iTextOut<iTextAmt
      iTextOut = SendMessage_(rtfEdit, #EM_FORMATRANGE, 1, fr)           
      If iTextOut < iTextAmt                   
        EndPage_(PrinterDC)
        StartPage_(PrinterDC)
        fr\chrg\cpMin = iTextOut
        fr\chrg\cpMax = -1
        iTextAmt      = iTextAmt - iTextOut
        iTextOut      = 0
      EndIf
    Wend
    SendMessage_(rtfEdit, #EM_FORMATRANGE, 0, 0)
    EndPage_(PrinterDC)
    EndDoc_(PrinterDC)
    DeleteDC_(PrinterDC)
  EndIf
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure StreamFileInCallback(hFile, pbBuff, cb, pcb)
  ProcedureReturn ReadFile_(hFile, pbBuff, cb, pcb, 0)!1
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; Procedure LoadRtfFile(pFilePath.s)
;   If ReadFile(0, pFilePath)
;     If GetExtensionPart(pFilePath)  = "rtf"
;       uFormat = #SF_RTF
;     Else
;       uFormat = #SF_TEXT
;     EndIf
;     edstr.EDITSTREAM
;     edstr\dwCookie          = FileID(0)
;     edstr\dwError           = 0
;     edstr\pfnCallback       = @StreamFileInCallback()
;     SendMessage_(GadgetID(0), #EM_STREAMIN, uFormat, edstr)
;     CloseFile(0)
;   Else
;     MessageRequester("Error", "Error Occured While Opening File", #PB_MessageRequester_Ok)
;   EndIf
; EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Search for and select text inside an editorgadget. RASHAD
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_SearchText(GadgetNumber.i, SearchText.s, Flags.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Possible Flags
  ;------------------------------------------------------------------------------------------------
  
  ; #FT_SEARCH = 1 ; Searching Top to Bottom, not the whole Word and not Case sensitive
  ; #FT_SEARCH_Bottom_to_Top = 0
  ; #FT_WHOLEWORD = 2
  ; #FT_MATCHCASE = 4
  
  ;------------------------------------------------------------------------------------------------
  ; Get CurrentCursor Position
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(GadgetNumber.i), #EM_EXGETSEL, 0, Range.CHARRANGE)
  
  ;------------------------------------------------------------------------------------------------
  ; Flag for search direction
  ;------------------------------------------------------------------------------------------------
  
  Updown.i = Flags.i & 2147483647
  
  ;------------------------------------------------------------------------------------------------
  ; Structurvariable, Type FINDTEXTEX
  ;------------------------------------------------------------------------------------------------
  
  findtext.FINDTEXTEX
  
  ;------------------------------------------------------------------------------------------------
  ; If searchdirection Flag = 1, searching Top to Bottom
  ;------------------------------------------------------------------------------------------------
  
  If Updown.i
    
    findtext\chrg\cpMin = Range\cpMax                       ; Starting by the Current CurserRangeposition (Range cpMax)
    
    findtext\chrg\cpMax = - 1                               ; -1 stands for maximum Bufferlength {equal to Len(GetGadgetText(Gadget_ID))}
    
  Else                                                     ; 
    
    findtext\chrg\cpMin = Range\cpMin                       ; Starting by the Current Cursor Rangeposition (Range cpMin)
    
    findtext\chrg\cpMax = 0                                 ; Beginning of Buffer is the end to search
    
  EndIf                                                    ;
  
  ;------------------------------------------------------------------------------------------------
  ; Simple the Address of the String to search
  ;------------------------------------------------------------------------------------------------
  
  findtext\lpstrText = @SearchText.s
  
  ;------------------------------------------------------------------------------------------------
  ; If the Text is found
  ;------------------------------------------------------------------------------------------------
  
  If SendMessage_(GadgetID(GadgetNumber.i),  #EM_FINDTEXTEX, Flags.i, @findtext) <> -1
    
    SendMessage_(GadgetID(GadgetNumber.i),   #EM_EXSETSEL,   0,       @findtext\chrgText)   ; Select the Text
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Clear the background colour of selected items
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_ClearBackgroundColour(GadgetNumber.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected format.CHARFORMAT2
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  format\cbSize         = SizeOf(format)
  
  Range.CHARRANGE
  
  range.CHARRANGE\cpMin = 0
  
  range\cpMax           = -1
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(GadgetNumber.i), #EM_EXSETSEL, 0, @range)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  format\dwMask         = #CFM_BACKCOLOR
  
 ;format\crBackColor    = $DBDBDB
  
  format\crBackColor    = $F2F2F2
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(GadgetNumber.i), #EM_SETCHARFORMAT, #SCF_SELECTION, @format)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  range.CHARRANGE\cpMin = 0
  
  range\cpMax           = 0
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(GadgetNumber.i), #EM_EXSETSEL, 0,  @range)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Set the selected text background colour
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_BackgroundColour(GadgetNumber.i, BackgroundColour.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected format.CHARFORMAT2_
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  format\cbSize       = SizeOf(CHARFORMAT2_)
  
  format\dwMask       = #CFM_BACKCOLOR
  
  format\crBackColor  = BackgroundColour.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(GadgetNumber.i), #EM_SETCHARFORMAT, #SCF_SELECTION, @format)  
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; OpenWindow(0, 200, 50, 640, 400,"RTF Load,Save & Print", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
; CreateMenu(0, WindowID(0))
;   MenuTitle("&File")
;     MenuItem(0, "&Open")
;     OpenSubMenu("&Save As..")
;       MenuItem( 1, "RTF File")
;       MenuItem( 2, "Plain Text")
;     CloseSubMenu()
;     MenuItem(3, "&Print")
;     MenuItem(4, "&Quit")
; EditorGadget(0, 0, 0, WindowWidth(0), WindowHeight(0))
; SendMessage_(GadgetID(0), #EM_LIMITTEXT, -1, 0)
; 
; a.s="{\rtf1\ansi\ansicpg1252\deff0\deflang2057{\fonttbl{\f0\fswiss\fcharset0 Arial;}}{\colortbl ;\red255\green0\blue0;\red0\green0\blue0;}"
; a.s=a.s+"{\*\generator Msftedit 5.41.15.1503;}\viewkind4\uc1\pard\f0\fs20 Hello, this is \cf1\b\fs32 RTF\cf2\b0\fs20 direct!\cf0\par}"
; SetGadgetText(0,a)
; 
; SetRtfMargin(0,640,400,10,10,20,20)
; 
; Repeat
;   Select WaitWindowEvent()
;     Case #PB_Event_CloseWindow
;       Quit = 1
;      
;     Case #PB_Event_Menu
;       Select EventMenu()
;         Case 0
;           ClearGadgetItems(0)
;           FileName$ = OpenFileRequester("", "", "RTF (*.rtf|*.rtf|Text (*.txt)|*.txt;*.bat|All files (*.*)|*.*", 0)
;           If FileName$
;             LoadRtfFile(FileName$)
;           EndIf
;          
;         Case 1
;             If CreateFile(0, GetHomeDirectory()+"Document2.rtf")
;               EStream\dwCookie = FileID(0)
;               EStream\pfnCallback = @SStreamCB()
;               SendMessage_(GadgetID(0), #EM_STREAMOUT, #SF_RTF, EStream)             
;               CloseFile(0)
;             EndIf
;            
;         Case 2
;             If CreateFile(0, GetHomeDirectory()+"Document2.txt")
;               EStream\dwCookie = FileID(0)
;               EStream\pfnCallback = @SStreamCB()
;               SendMessage_(GadgetID(0), #EM_STREAMOUT, #SF_TEXT, EStream)             
;               CloseFile(0)
;             EndIf
;          
;         Case 3
;             PrintRichText(WindowID(0), GetModuleHandle_(0), GadgetID(0), 10, 10, 20, 20)
;          
;         Case 4
;             Quit = 1
;          
;       EndSelect
;   EndSelect
; Until Quit = 1
; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 523
; FirstLine = 480
; Folding = --
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 1
; EnableBuildCount = 0