﻿;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Needed RTF constants
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#FT_SEARCH                          = 1                                                               ; Searching Top to Bottom, not the whole Word and not Case sensitive
#FT_SEARCH_Bottom_to_Top            = 0                                                               ; 
#FT_WHOLEWORD                       = 2                                                               ; 
#FT_MATCHCASE                       = 4                                                               ; 

#CFM_BACKCOLOR                      = $4000000                                                        ; 
#CFE_AUTOBACKCOLOR                  = #CFM_BACKCOLOR                                                  ; 

#ENM_LINK                           = $04000000                                                       ; 

#CFM_LINK                           = $00000020                                                       ; 
#CFE_LINK                           = $0020                                                           ; 
#CFE_SUBSCRIPT                      = $00010000                                                       ; 
#CFE_SUPERSCRIPT                    = $00020000                                                       ; 
#CFM_SUBSCRIPT                      = #CFE_SUBSCRIPT | #CFE_SUPERSCRIPT                               ; 
#CFM_SUPERSCRIPT                    = #CFM_SUBSCRIPT                                                  ; 

#PFA_JUSTIFY                        = 4                                                               ; New paragraph-alignment option 2.0

#CFM_ALLCAPS                        = $80                                                             ; 
#CFE_ALLCAPS                        = #CFM_ALLCAPS                                                    ; 
#CFM_SMALLCAPS                      = $40                                                             ; 
#CFE_SMALLCAPS                      = #CFM_SMALLCAPS                                                  ; 

#ST_DEFAULT                         = 0                                                               ; 
#ST_KEEPUNDO                        = 1                                                               ; 
#ST_SELECTION                       = 2                                                               ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global RTFLength.i, FontSize.i                                                                        ; 
Global NewList FaceName.s()                                                                          ; 
Global RtfFile.i                                                                                      ; 

Define *Buffer, i                                                                                     ; 

Global  defaultFormat.CHARFORMAT                                                                      ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; All procedural declarations
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Declare.i CatchRTF(Gadget.i, MemoryAddress.i)
Declare   CatchRTF_Callback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)
Declare   GetRTF(Gadget.i, Address.i)
Declare.i GetRTFCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)
Declare.i GetRTFLen(Gadget.i)
Declare.i GetRTFLenCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)
Declare.s GetRtfData(Gadget.i)
Declare   Editor_Bulleted(Gadget.i)
Declare   Editor_Color(Gadget.i, Color.i)
Declare   Editor_FindTextn(Gadget.i, TextToFind.s, CaseFlag.i, Direction.i)
Declare   Editor_Font(Gadget.i, FontName.s)
Declare   Editor_FontSize(Gadget.i, Fontsize.i) 
Declare   Editor_Format(Gadget.i, Flags, Alternate = 0)
Declare   Editor_JustifyParagraph(Gadget.i, Justify)
Declare   Editor_Load(Gadget.i, FileName.s)
Declare   Editor_Save(Gadget.i, FileName.s)
Declare   Editor_StreamCallback(dwCookie, *pbBuff, cb, *pcb.LONG)
Declare   Editor_Wrap(Gadget.i, Flag.i) ; Activate the automatic word wrap for a EditorGadget. -1 = wrap

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Load an RTF text file from datasection and put it into the editorgadget (By Freak I think)
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.i CatchRTF(Gadget.i, MemoryAddress.i)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Shared CatchRTF_Address.i  
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CatchRTF_Address.i = MemoryAddress.i  
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  stream.EDITSTREAM\pfnCallback = @CatchRTF_Callback()  
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_STREAMIN, #SF_RTF, @stream)  
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure  

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Callback used by CatchRFT to stream an RTF text file fron datasection and put it into the editorgadget. Freak.
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure CatchRTF_Callback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Shared CatchRTF_Address  .i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CopyMemory(CatchRTF_Address.i, pbBuff.i, cb.i)  

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CatchRTF_Address.i + cb.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  *pcb\l = cb.i  

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn 0  

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Stream the RTF data from the requested gadget
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure GetRTF(Gadget.i, Address.i)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Stream.EDITSTREAM

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Stream\dwCookie = Address.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Stream\pfnCallback = @GetRTFCallback()

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  RTFLength.i = 0

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_STREAMOUT, #SF_RTF, @Stream)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Callback for the RTF stream requester
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.i GetRTFCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CopyMemory(pbBuff.i, dwCookie.i + RTFLength.i, cb.i)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  RTFLength.i + cb.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  *pcb\l = cb.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn 0 ; Result

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Get the length of RTF data in the requested gadget
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.i GetRTFLen(Gadget.i)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Stream.EDITSTREAM

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Stream\pfnCallback = @GetRTFLenCallback()

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  RTFLength.i = 0

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_STREAMOUT, #SF_RTF, @Stream)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn RTFLength.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.i GetRTFLenCallback(dwCookie.i, pbBuff.i, cb.i, *pcb.LONG)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  RTFLength.i + cb.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  *pcb\l = cb.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn 0

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure.s GetRtfData(Gadget.i)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If *Buffer

    FreeMemory(*Buffer)

  EndIf

  Bufferlen.i = GetRTFLen(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Bufferlen.i
  
    *Buffer = AllocateMemory(Bufferlen.i)
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If *Buffer

    GetRTF(Gadget.i, *Buffer)

    ; ProcedureReturn PeekS(*Buffer)
    
    ProcedureReturn PeekS(*Buffer, -1, #PB_Ascii) 
    
  Else
  
    ProcedureReturn GetGadgetText(Gadget.i)
  
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_Bulleted(Gadget.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  Format.PARAFORMAT

  Format\cbSize     = SizeOf(PARAFORMAT) 

  Format\dwMask     = #PFM_NUMBERING	

  Format\wnumbering = #PFN_BULLET

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_SETPARAFORMAT, 0, @Format) 

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Set the Text Color for the Selection in RGB format
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_Color(Gadget.i, Color.i)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Format.CHARFORMAT
  
  Format\cbSize       = SizeOf(CHARFORMAT)
  
  Format\dwMask       = #CFM_COLOR
  
  Format\crTextColor  = Color.i
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_SETCHARFORMAT, #SCF_SELECTION, @Format)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Find whole text strings with no splitting
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_FindTextn(Gadget.i, TextToFind.s, CaseFlag.i, Direction.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected.i FoundString.i, ExitProc.i
  
  Protected format.CHARFORMAT, Range.CHARRANGE
  
  Static editFind.FINDTEXTEX
  
  Static LastText.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If LastText.s <> TextToFind.s
    
    editFind\chrg\cpMin = 0
    
    LastText.s = TextToFind.s
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  editFind\chrg\cpMax = -1
  
  editFind\lpstrText  = @TextToFind
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Repeat
    
    If CaseFlag.i = 1
      
      FoundString.i = SendMessage_(GadgetID(Gadget.i), #EM_FINDTEXTEX, Direction.i | #FR_MATCHCASE, @editFind)
      
    Else
      
      FoundString.i = SendMessage_(GadgetID(Gadget.i), #EM_FINDTEXTEX, Direction.i, @editFind)
      
    EndIf
    
    If FoundString.i > - 1
      
      SendMessage_(GadgetID(Gadget.i), #EM_SETSEL, FoundString.i, FoundString.i + Len(TextToFind.s))
      
      editFind\chrg\cpMin = FoundString.i + 1
      
      ExitProc.i = #True
      
    Else
      
      If editFind\chrg\cpMin > 0
        
        editFind\chrg\cpMin = 0
        
      Else
        
        ExitProc.i = #True
        
      EndIf
      
    EndIf
  
  Until ExitProc.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
  
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Set Font for the Selection, You must specify a font name, the font doesn't need to be loaded
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_Font(Gadget.i, FontName.s)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Format.CHARFORMAT

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Format\cbSize = SizeOf(CHARFORMAT)

  Format\dwMask = #CFM_FACE

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  PokeS(@Format\szFaceName, FontName.s)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_SETCHARFORMAT, #SCF_SELECTION, @Format)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_FontSize(Gadget.i, Fontsize.i) 
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Format.CHARFORMAT
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Format\cbSize = SizeOf(CHARFORMAT)
  
  Format\dwMask = #CFM_SIZE
  
  Format\yHeight = FontSize.i * 20
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_SETCHARFORMAT, #SCF_SELECTION, @Format)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Cumulatively set various font effects to text in an EditorGadget
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_Format(Gadget.i, Flags, Alternate = 0)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Protected Format.CHARFORMAT2
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Format\cbSize = SizeOf(CHARFORMAT2)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Alternate
    
    SendMessage_(GadgetID(Gadget.i), #EM_GETCHARFORMAT, 1, @Format)
    
    Flags = Format\dwEffects ! Flags
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Format\dwMask = #CFM_ITALIC | #CFM_BOLD | #CFM_STRIKEOUT | #CFM_UNDERLINE | #CFM_LINK | #CFM_SUBSCRIPT | #CFM_SUPERSCRIPT
  
  Format\dwEffects = Flags
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_SETCHARFORMAT,  #SCF_SELECTION, @Format)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; Set paragraph justification.
; Can be one of the following values:
; #PFA_LEFT	
; #PFA_RIGHT	
; #PFA_CENTER	

Procedure Editor_JustifyParagraph(Gadget.i, Justify)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Format.PARAFORMAT

  Format\cbSize = SizeOf(PARAFORMAT) 

  Format\dwMask = #PFM_ALIGNMENT

  Format\wAlignment = justify

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(Gadget.i), #EM_SETPARAFORMAT, 0, @Format) 

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_Load(Gadget.i, FileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If FileName.s
    
    RtfFile.i = ReadFile(#PB_Any, FileName.s)
    
    If RtfFile.i
    
      stream.EDITSTREAM
      
      stream\dwCookie    = 0
      
      stream\pfnCallback = @Editor_StreamCallback()
      
      SendMessage_(GadgetID(Gadget.i), #EM_STREAMIN, #SF_RTF, @stream)
     
      CloseFile(RtfFile.i)
      
    Else
      
      ; Debug "No file handle found."
      
    EndIf
    
  Else
    
    ; Debug "Filename not specified."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_Save(Gadget.i, FileName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If FileName.s
    
    If LCase(GetExtensionPart(FileName.s)) <> "rtf"
      
      FileName.s + ".rtf"
      
    EndIf
      
    RtfFile.i = CreateFile(#PB_Any, FileName.s)
  
    If RtfFile.i
  
      stream.EDITSTREAM
  
      stream\dwCookie    = 1
  
      stream\pfnCallback = @Editor_StreamCallback()
  
      SendMessage_(GadgetID(Gadget.i), #EM_STREAMOUT, #SF_RTF, @stream)
     
      CloseFile(RtfFile.i)
  
    Else
      
      ; Debug "No file handle."
      
    EndIf
    
  Else
    
    ; Debug "No filename specified."
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_StreamCallback(dwCookie, *pbBuff, cb, *pcb.LONG)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If dwCookie = 1 ; Save   

    WriteData(RtfFile, *pbBuff, cb)

    *pcb\l = cb
 
  Else ; Load

    length = Lof(RtfFile) - Loc(RtfFile)

    If length > cb

      ReadData(RtfFile, *pbBuff, cb)

      *pcb\l = cb

    Else

      ReadData(RtfFile, *pbBuff, length)

      *pcb\l = length

    EndIf
 
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn 0

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Selects Text inside an EditorGadget
; Line numbers range from 0 to CountGadgetItems(#Gadget)-1
; Char numbers range from 1 to the length of a line
; Set Line numbers to -1 to indicate the last line, and Char
; numbers to -1 to indicate the end of a line
; selecting from 0,1 to -1, -1 selects all.
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Procedure Editor_Wrap(Gadget.i, Flag.i) ; Activate the automatic word wrap for a EditorGadget. -1 = wrap

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  GID = GadgetID(Gadget.i)

  dc = GetWindowDC_(GID)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GID, #EM_SETTARGETDEVICE ,dc, Flag.i)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ReleaseDC_(GID, dc)

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 47
; FirstLine = 43
; Folding = ----
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0