;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Copyright:    MGB Technical Services, 2018.
; 
; License:      Freeware. Do what you want with it EXCEPT SELL IT which is expressly forbidden, acknowledge the source 
;               please. License for the expat XML parser is in the distribution directory. 'Expat XML parser license.txt'
; 
; Code format:  Purebasic, v5.63x X86 source code project.
; 
; Dependancies: None.
; 
; Graphics:     Most graphics came from the Mattahan's BUUF sets
; 
; Thanks:       My wife Susan!!! InfraTec, ElectroChrisso, Rashad, NetMaestro and a cast of thousands
;
; Notes:        I've tried to comment wherever I could but there are just so many hours in the day. The code is 100% finished
;               as far as I am concerned. I you want more, ask me or code it in yourself, you have the source code.
; 
;               I've tried to overload the options available to users. Menu options are duplicated by keyboard shortcuts.
;
; Addendum:     Before you complain that this program has destroyed something or did something you didn't like, have the 
;               decency and intelligence to actually read through the code and NOT TEST IT on LIVE DATA but copies. It is
;               NOT MY JOB to rescue you from your own laziness or obdurate stupidity. I have slaved my hairy ass off for
;               for this program. You are a coder and presumably know what you are doing.
; 
; Changes:      Error log module and assembly error catcher in case debug doesn't always work properly. It doesn't here.
; 
; Notes:        The error log is rewritten every time you start the program, to the same name as the program name and version.
;               No dated logs as I didn't want tons of temp log files to follow. And it is also flushed to disk every 50
;               entries or at program end to minimise disk writes in case you are running on a USB key.
; 
;               I've tried to minimise database queries for the same reason as well.
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Check if doofus has turned thread safety on
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

CompilerIf Not #PB_Compiler_Thread
  CompilerError "Enable ThreadSafe!"
CompilerEndIf

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Load a registered user's name above the search bar. For the heck of it.
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

ParameterCount.i = CountProgramParameters()                                                               ; 

If ParameterCount.i <>  0                                                                                 ; 
  If ProgramParameter(0) = "/Register"                                                                    ; 
    FirstName.s = ProgramParameter(1)                                                                     ; 
    LastName.s  = ProgramParameter(2)                                                                     ; 
  EndIf                                                                                                   ; 
EndIf                                                                                                     ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Prevent multiple instances of MyInfo from starting
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "MyInfo_Startup.pbi"                                                                         ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Don't use this while in the IDE as internal debugger may not work right
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Generic\_ErrorHandler.pbi"                                                          ; A generic error handler for reporting crashes.

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Add the external error handler if needed
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

OnErrorCall(@ErrorHandler())                                                                              ; Handle errors properly

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "MyInfo_Constants.pb"                                                                        ; Visual designer created constants
XIncludeFile "MyInfo_Windows.pb"                                                                          ; Visual designer created window code
XIncludeFile "MyInfo_MyDeclarations.pb"                                                                   ; My procedural declarations
XIncludeFile "MyInfo_MyConstants.pb"                                                                      ; My personal constants
XIncludeFile "MyInfo_TwainImport.pb"                                                                      ; Import information from a scanner (Harkon)

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Third party routines
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\ThirdParty\_BM_DisableImageGadget.pbi"                                             ; Make a properly disabled imagegadget in appearance (Breeze4me) 
XIncludeFile "Modules\ThirdParty\_EB_MessageRequester.pbi"                                               ; User your own fonts and sizes on messagerequesters (Ebs)
XIncludeFile "Modules\ThirdParty\_HK_PurePDF 2_25.pbi"                                                   ; Save documents and images as PDF files (Harkon)
XIncludeFile "Modules\ThirdParty\_NM_MouseHover.pbi"                                                     ; Mouse Hover library (NetMaestro)
XIncludeFile "Modules\ThirdParty\_RS_PrintRtfGadget.pbi"                                                 ; Print from the RTF gadget. Also other routines, Load, save etc (RASHAD)
XIncludeFile "Modules\ThirdParty\_TH_RtfTools.pbi"                                                       ; Richedit handling (Freak (Timo Harter), Srod (Stephen Rodriguez), Sparkie (Mark Budny), others)
XIncludeFile "Modules\ThirdParty\_SG_WebgadgetPrint.pbi"                                                 ; Print without prompts from the web gadget (Siggi (Sigfried Rings))

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Generic routines
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Generic\_FormatField.pbi"                                                           ; Format the passed string to the correct field length for printing/copying to clipboard etc
XIncludeFile "Modules\Generic\_FormatMenu.pbi"                                                            ; Format menu text and shortcut strings to a predefined length
XIncludeFile "Modules\Generic\_GetShortcutText.pbi"                                                       ; Get the text of the associated shortcut constant
XIncludeFile "Modules\Generic\_KillQuote.pbi"                                                             ; Kill double quotes in strings for display purposes
XIncludeFile "Modules\Generic\_LastLine.pbi"                                                              ; Go to the last line of a ListIconGadget
XIncludeFile "Modules\Generic\_MakeString.pbi"                                                            ; Create a string of spaces or other characters. Pass it any number of characters and watch it grow!
XIncludeFile "Modules\Generic\_MakeSureDirectoryPathExists.pbi"                                           ; Need a unicode aware version of the API directory creator
XIncludeFile "Modules\Generic\_MixedComboCaseEx.pbi"                                                      ; First letter uppercase in a combo box. srod!.
XIncludeFile "Modules\Generic\_MixedStringCase.pbi"                                                       ; Uppercase the first letter of each word
XIncludeFile "Modules\Generic\_ProperCaseString.pbi"                                                      ; Flip a mixed string into all proper case
XIncludeFile "Modules\Generic\_RepQuote.pbi"                                                              ; Uncle Berikco's routine to properly replace single quotes with double for SQL passing
XIncludeFile "Modules\Generic\_RemoveBorders.pbi"                                                         ; Remove borders from various gadgets
XIncludeFile "Modules\Generic\_SetSearchQuery.pbi"                                                        ; Alias the Search type text to SQLite operators
XIncludeFile "Modules\Generic\_StringFirstUpper.pbi"                                                      ; Convert the first character of a string to uppercase
XIncludeFile "Modules\Generic\_TextToXML.pbi"                                                             ; Replace bad characters with XML compatible ones. Thorsten Hoeppner
XIncludeFile "Modules\Generic\_xcm.pbi"                                                                   ; Calculate x axis movement for printer dimensions
XIncludeFile "Modules\Generic\_XMLToText.pbi"                                                             ; Strip illegal characters from text strings
XIncludeFile "Modules\Generic\_ycm.pbi"                                                                   ; Calculate y axis movement for printer dimensions

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Custom form and information handling
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Custom\_BalloonToolTip.pbi"                                                         ; Add balloon tooltips with individual fonts and icons
XIncludeFile "Modules\Custom\_CheckEnterGadget.pbi"                                                       ; Check which gadget had the focus at the time ENTER was pressed
XIncludeFile "Modules\Custom\_CloseMyWindow.pbi"                                                          ; Fade the window out gently, close it and reset the mutex
XIncludeFile "Modules\Custom\_GetBalloonColour.pbi"                                                       ; Set a random or prechosen balloon tooltip colour
XIncludeFile "Modules\Custom\_GetIconHandle.pbi"                                                          ; Copy the icon into memory while deleting the original image copied from
XIncludeFile "Modules\Custom\_GetPartBetweenBrackets.pbi"                                                 ; Extract the text between pointy brackets
XIncludeFile "Modules\Custom\_IsoDate.pbi"                                                                ; Convert an ISO format date to Australian and back
XIncludeFile "Modules\Custom\_SetInfoBarArea.pbi"                                                         ; Send messages and error reports to the fake status bar area
XIncludeFile "Modules\Custom\_SetHoverIcons.pbi"                                               ; TODO     ; Set the correct icons to the selected hoverable gadget
XIncludeFile "Modules\Custom\_SortTitleStrings.pbi"                                                       ; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
XIncludeFile "Modules\Custom\_StatusBarButtonTip.pbi"                                                     ; Custom statusbar tooltip messages
XIncludeFile "Modules\Custom\_TitleBarClock.pbi"                                                          ; Run an asynchronous clock in the window title bar
XIncludeFile "Modules\Custom\_WriteErrorLog.pbi"                                                          ; Write the error log to disk in the temporary directory
XIncludeFile "Modules\Custom\_WordWrapString.pbi"                                                         ; Wrap a string to a specified boundary

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Custom form callbacks
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Callbacks\_MainWindowCallback.pbi"                                                  ; Window snap, strikeoutfont and more

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Database functions
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Database\_CountRecords.pbi"                                                         ; Count the number of records in an SQLite database
XIncludeFile "Modules\Database\_DatabaseLastInsertRowId.pbi"                                              ; Get the ID of the last inserted record
XIncludeFile "Modules\Database\_FillCombo.pbi"                                                            ; Fill a combobox gadget from a linked list, SQLite version
XIncludeFile "Modules\Database\_FillComboBoxImage.pbi"                                                    ; Fill a combobox with items and their stored images
XIncludeFile "Modules\Database\_LastRecord.pbi"                                                           ; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
XIncludeFile "Modules\Database\_OpenSystemDatabase.pbi"                                       ; EBS       ; Try to open the system database and create missing tables

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Export and import routines, File menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Filemenu\_BackupDatabase.pbi"                                                       ; Backup the current database to the named day of the week
XIncludeFile "Modules\Filemenu\_ExportDatabase.pbi"                                                       ; Export data data to a standard XML file
XIncludeFile "Modules\Filemenu\_ImportDatabase.pbi"                                                       ; Import an XML file of MyInfo entries
XIncludeFile "Modules\Filemenu\_OpenAdatabase.pbi"                                                        ; Open up a database other than the default
XIncludeFile "Modules\Filemenu\_ProcessMyInfoNode.pbi"                                                    ; Decode MyInfo node data
XIncludeFile "Modules\Filemenu\_VacuumDeletedData.pbi"                                                    ; Clean all deleted items from the database immediately

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Categories management, Category menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Categorymenu\_AddCategory.pbi"                      ; *** Window ***    ; EBS       ; Add a new category to the database
XIncludeFile "Modules\Categorymenu\_ChangeCategory.pbi"                                                   ; Change the category of the title that was dropped to what it was dropped on
XIncludeFile "Modules\Categorymenu\_CopyCategory.pbi"                                                     ; Copy the current category to the clipboard
XIncludeFile "Modules\Categorymenu\_DeleteCategory.pbi"                                                   ; Delete the selected category
XIncludeFile "Modules\Categorymenu\_DragToCategory.pbi"                                                   ; Change the category of a title by dragging and dropping it onto the category bar
XIncludeFile "Modules\Categorymenu\_EditCategory.pbi"                     ; *** Window ***    ; EBS       ; Edit the selected category
XIncludeFile "Modules\Categorymenu\_ExportCategories.pbi"                                                 ; Export the list of categories to disk
XIncludeFile "Modules\Categorymenu\_ImportCategories.pbi"                                                 ; Import a text file list of categories from disk
XIncludeFile "Modules\Categorymenu\_LoadCategories.pbi"                                                   ; Load all the categories into the category bar
XIncludeFile "Modules\Categorymenu\_SaveCategory.pbi"                                         ; EBS       ; Save the changed category data to the database
XIncludeFile "Modules\Categorymenu\_ShowCategory.pbi"                                                     ; Show the items that belong to a particular category
XIncludeFile "Modules\Categorymenu\_SortCategoryEntries.pbi"                                              ; Sort the category list after an add or edit
XIncludeFile "Modules\CategoryMenu\_SyncCategories.pbi"                                                   ; Update category item count in category list
XIncludeFile "Modules\Categorymenu\_UpdateCategoryItemCount.pbi"                                          ; Update the category itemcount field each time we add, change or delete addresses or categories

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; All data handling, Data menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Datamenu\_AddNewData.pbi"                           ; *** Window ***    ; EBS       ; Add a new MyInfo item
XIncludeFile "Modules\Datamenu\_ArchiveThisData.pbi"                                                      ; Archive this stuff to permanent storage
XIncludeFile "Modules\Datamenu\_AttachItemToData.pbi"                                                     ; Attach a document or file to the current record
XIncludeFile "Modules\Datamenu\_CopyDataToClipboard.pbi"                                                  ; Copy highlighted data to the system clipboard
XIncludeFile "Modules\Datamenu\_DataFormTemplate.pbi"                                                     ; Standard data form template for convenience
XIncludeFile "Modules\Datamenu\_DeleteCurrentData.pbi"                                                    ; Mark the selected item as deleted
XIncludeFile "Modules\Datamenu\_DisplayTitleString.pbi"                                                   ; Display MyInfo title in the list
XIncludeFile "Modules\Datamenu\_DragnewData.pbi"                                                          ; Enable importing data by dropping a text file
XIncludeFile "Modules\Datamenu\_EditOldData.pbi"                          ; *** Window ***    ; EBS       ; Edit the old MyInfo data
XIncludeFile "Modules\Datamenu\_ExportItemToDisk.pbi"                                                     ; Export the currently selected item to disk
XIncludeFile "Modules\Datamenu\_ImportItemFromDisk.pbi"                                                   ; Import a preformatted text file from disk
XIncludeFile "Modules\Datamenu\_KillCurrentData.pbi"                                                      ; Lock the current record against deletion and editing
XIncludeFile "Modules\Datamenu\_LockCurrentData.pbi"                                                      ; Lock the current record against deletion and editing
XIncludeFile "Modules\Datamenu\_MarkAsFavourite.pbi"                                                      ; Mark this entry as a favourite item
XIncludeFile "Modules\Datamenu\_PrintThisData.pbi"                                                        ; Print all or selected records    ; 
XIncludeFile "Modules\Datamenu\_SaveThisData.pbi"                                                         ; Save the new or edited MyInfo data
XIncludeFile "Modules\Datamenu\_SearchDataForm.pbi"                       ; *** Window ***                ; Data form search window
XIncludeFile "Modules\Datamenu\_SearchDataFormNow.pbi"                                                    ; Search within the data form itself
XIncludeFile "Modules\Datamenu\_SearchDatabase.pbi"                                                       ; Search for items in the database
XIncludeFile "Modules\Datamenu\_ShowMyInfoData.pbi"                                                       ; Show the data string for MyInfo on the screen
XIncludeFile "Modules\Datamenu\_UpdateTitleAttachmentCount.pbi"                                           ; Update the attachment counter in the title list

; Scan document from TWAIN source

XIncludeFile "Modules\Datamenu\Scanning\_ScanDocument.pbi"               ; *** Window ***      ; TODO     ; Scan a document into the current record
XIncludeFile "Modules\Datamenu\Scanning\_AquireDocument.pbi"                                              ; Aquire a document image from the scanner
XIncludeFile "Modules\Datamenu\Scanning\_ScanNextDocumentPage.pbi"                                        ; Scan the next document page
XIncludeFile "Modules\Datamenu\Scanning\_SaveScannedDocumentPages.pbi"                                    ; Save the scanned document pages to PDF

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Utilities menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Utilitymenu\_AdvancedSearch.pbi"                    ; *** Window ***                ; Search MyInfo's database with advanced SQL tools and limits
XIncludeFile "Modules\Utilitymenu\_AdvancedSearchNow.pbi"                                                 ; Perform the extended SQL search now
XIncludeFile "Modules\Utilitymenu\_SelectAllItems.pbi"                                                    ; Select all the data in the list for some operations

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Utilities menu, Owner management
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Owners\_ManageOwners.pbi"                           ; *** Window ***                ; Manage the owner list table
XIncludeFile "Modules\Owners\_AddOwner.pbi"                               ; *** Window ***                ; Add a new Owner to the Owner bar
XIncludeFile "Modules\Owners\_CopyOwner.pbi"                                                              ; Copy the current owner to the clipboard
XIncludeFile "Modules\Owners\_DeleteOwner.pbi"                                                            ; Delete an existing Owner from the owner bar
XIncludeFile "Modules\Owners\_EditOwner.pbi"                              ; *** Window ***                ; Edit the old owner in the database
XIncludeFile "Modules\Owners\_SaveOwner.pbi"                                                              ; Save the new or changed Owner information
XIncludeFile "Modules\Owners\_SortOwners.pbi"                                                             ; Sort ListIconGadget as you need it. Based on Reg Venaglia's routine.
XIncludeFile "Modules\Owners\_SyncOwnerlist.pbi"                                                          ; Update category item count in owner list and create the list of owners list
XIncludeFile "Modules\Owners\_UpdateOwnerItemCount.pbi"                                                   ; Update the Owner itemcount field each time we add, change or delete owners

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Program toggles, Options menu  
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Optionsmenu\_ToggleBalloonToolTips.pbi"                                             ; Turn balloon tooltips on or off
XIncludeFile "Modules\Optionsmenu\_ToggleBalloonColour.pbi"                                               ; Turn balloon tooltips on or off
XIncludeFile "Modules\Optionsmenu\_ToggleColourBand.pbi"                                                  ; Turn alternate row colour banding on and off
XIncludeFile "Modules\Optionsmenu\_ToggleHideDetail.pbi"                                                  ; Turn the hiding of the detail pane on or off
XIncludeFile "Modules\Optionsmenu\_ToggleMessageSave.pbi"                                                 ; Turn on or off messages after saving
XIncludeFile "Modules\Optionsmenu\_ToggleWindowToolBars.pbi"                                              ; Turn on or off the showing of the main toolbar
XIncludeFile "Modules\Optionsmenu\_ToggleScreenSnap.pbi"                                                  ; Turn snapping to screen borders on and off
XIncludeFile "Modules\Optionsmenu\_ToggleStickyWindow.pbi"                                                ; Set this window on top of others or alarm window will not show
XIncludeFile "Modules\Optionsmenu\_ToggleTitleBarClock.pbi"                                               ; Turn time updating on in the title bar

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Program help, Help menu
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Helpmenu\_AboutMyInfo.pbi"                          ; *** Window ***                ; A quick 'about me' blurb
XIncludeFile "Modules\Helpmenu\_Keyboardshortcuts.pbi"                    ; *** Window ***                ; Show a list of all the keyboard shortcuts
XIncludeFile "Modules\Helpmenu\_ViewErrorLog.pbi"                         ; *** Window ***                ; View the system error log file

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Help modules
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Helpscreens\_EditHelp.pbi"                                                          ; Change the current read only state of the current help page
XIncludeFile "Modules\Helpscreens\_LoadHelp.pbi"                                                          ; Load an Rtf text file into the help area
XIncludeFile "Modules\Helpscreens\_SaveHelp.pbi"                                                          ; Save the current help contents to an Rtf text file on disk
XIncludeFile "Modules\Helpscreens\_SearchHelp.pbi"                                                        ; Search the MyInfo help file and highlight text. RASHAD
XIncludeFile "Modules\Helpscreens\_ShowHelp.pbi"                          ; *** Window ***                ; Adaptable help file that loads RTF from datasection
XIncludeFile "Modules\Helpscreens\_PrintHelp.pbi"                                                         ; Print the contents of the current help page

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Create a new password if there wasn't one previously
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Security\_NewPassWordWindow.pbi"                                                    ; Open the new password window
XIncludeFile "Modules\Security\_CheckNewPassWord.pbi"                     ; *** Window ***                ; Check that there is a new password

; Security password check on program startup

XIncludeFile "Modules\Security\_StartPassWordWindow.pbi"                  ; *** Window ***                ; Show a password lock screen at program start
XIncludeFile "Modules\Security\_CheckStartUpPassWord.pbi"                                                 ; Check the startup unlocking password

; Edit an existing password

XIncludeFile "Modules\Security\_EditpassWordWindow.pbi"                   ; *** Window ***                ; Open the edit password window
XIncludeFile "Modules\Security\_CheckpassWords.pbi"                                                       ; Check that the old password and confirmation passwords match

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Lock and unlock the program window
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Security\_LockProgramWindow.pbi"                                                    ; Lock the program window now
XIncludeFile "Modules\Security\_CheckUnlockPassWord.pbi"                                                  ; Check the unlocking password
XIncludeFile "Modules\Security\_UnLockProgramWindow.pbi"                  ; *** Window                    ; UnLock the program window now

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Minimising and maximising the program window
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

XIncludeFile "Modules\Security\_HideProgramWindow.pbi"                                                    ; Hide the program window
XIncludeFile "Modules\Security\_ShowProgramWindow.pbi"                                                    ; Show the program window

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Modules required to run only once for various database changes
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;XIncludeFile "Modules\Onetime\_OneTimeMakeOwners.pbi"                                                     ; Create the new owners table on startup and insert them
;XIncludeFile "Modules\Onetime\_OneTimeConvertRtfDatabase.pbi"                                             ; Convert the rtf data in the info field to normal text

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Vosual designer resizing event. 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; Procedure SizeWindowHandler()
;   PVDynamic_Resize(WindowID(EventWindow())) 
; EndProcedure
; 
; BindEvent(#PB_Event_SizeWindow, @SizeWindowHandler())

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Main program event handlers
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

If Window_MyInfo()
  
  ;------------------------------------------------------------------------------------------------
  ; Check for executable being run more than once
  ;------------------------------------------------------------------------------------------------
  
  If Instance_Running(VersionFileName.s)
    StickyWindow(#Window_MyInfo, #True)
    ErrorMessage.s                    + 
    VersionFileName.s                 + 
    " is already running."  + #CRLF$  + 
    "Cannot start another instance!"
    MessageRequesterEBS("Program running", ErrorMessage.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
    ;MessageRequester("Program already running", ErrorMessage.s,  #MB_ICONWARNING)
    End
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Open the master database from which we also pull the setup data.
  ;------------------------------------------------------------------------------------------------

  OpenSystemDatabase()                                                                                       ; Open the system database
  
  ;------------------------------------------------------------------------------------------------
  ; Let the user know in first and subsequent runs that at least one of the two important tables
  ; need maintenance
  ;------------------------------------------------------------------------------------------------
  
  CategoryCount.s = CountRecords("Recordid", "Categories")
  OwnerCount.s    = CountRecords("Recordid", "Owners")
  
  If CategoryCount.s = "0" And OwnerCount.s = "0"
    
    TableMessage.s + 

    "Welcome to the " + #Program  + Program\CompileCounters + " store" + #CRLF$ +  #CRLF$ + 

    "This may be a newly setup database "     + #CRLF$ + 
    "and there seems to be no Categories "    + #CRLF$ + 
    "Or Owners setup as yet."                 + #CRLF$ +  #CRLF$ + 

    "Please spend time setting these up"      + #CRLF$ + 
    "as this cannot be done during "          + #CRLF$ + 
    "the creation of a new record."           + #CRLF$ +  #CRLF$ + 

    "This can also be done during the normal" + #CRLF$ + 
    "running of the program"

    MessageRequesterEBS("Table Maintenance Required", TableMessage.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
    
  ElseIf CategoryCount.s = "0" And OwnerCount.s <> "0"
    
    TableMessage.s + 

    "Welcome to the " + #Program  + Program\CompileCounters + " store" + #CRLF$ +  #CRLF$ + 

    "The Categories list requires attention," + #CRLF$ + 
    "there seems to be no Categories yet"     + #CRLF$ + 
    "Please spend time setting this up"       + #CRLF$ +  #CRLF$ + 

    "as this cannot be done during "          + #CRLF$ + 
    "the creation of a new record."           + #CRLF$ +  #CRLF$ + 

    "This can also be done during the normal" + #CRLF$ + 
    "running of the program"
    
    ;MessageRequester("Category Table Maintenance Required", TableMessage.s,  #MB_ICONEXCLAMATION)
    
    MessageRequesterEBS("Category Table Maintenance Required", TableMessage.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
    
  ElseIf CategoryCount.s <> "0" And OwnerCount.s = "0"
    
    TableMessage.s + 

    "Welcome to the " + #Program  + Program\CompileCounters + " store" + #CRLF$ +  #CRLF$ + 

    "The Owners table requires attention, "   + #CRLF$ + 
    "there seems to be no owners yet."        + #CRLF$ +  #CRLF$ + 

    "Please spend time setting this up"       + #CRLF$ + 
    "as this cannot be done during "          + #CRLF$ + 
    "the creation of a new record."           + #CRLF$ +  #CRLF$ + 

    "This can also be done during the normal" + #CRLF$ + 
    "running of the program"
    
    ;MessageRequester("Owner Table Maintenance Required", TableMessage.s,  #MB_ICONEXCLAMATION)
    
    MessageRequesterEBS("Owner Table Maintenance Required", TableMessage.s, #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Read the program startup preferences
  ;------------------------------------------------------------------------------------------------
  
  PreferencesQueryString.s  + 
  "SELECT "                 + 
  "* "                      + 
  "FROM Preferences "       + 
  "WHERE Recordid = '1'"
  
  If DatabaseQuery(Program\DatabaseHandle, PreferencesQueryString.s) <> #DatabaseQueryFail
    While NextDatabaseRow(Program\DatabaseHandle)
      ;------------------------------------------
      Program\MD5FingerPrint                =           GetDatabaseString(Program\DatabaseHandle,    0)   ;: Debug  "Password fingerprint:                          " +   Program\MD5FingerPrint
      ;------------------------------------------      
      Program\ChangeFont                    =           GetDatabaseString(Program\DatabaseHandle,    1)   ;: Debug  "Current font:                                  " +   Program\ChangeFont
      ;------------------------------------------      
      Program\SearchLimit                   =           GetDatabaseString(Program\DatabaseHandle,    2)   ;: Debug  "Search limit:                                  " +   Program\SearchLimit
      Program\LastSearch                    = KillQuote(GetDatabaseString(Program\DatabaseHandle,    3))  ;: Debug  "Last search:                                   " +   Program\LastSearch
      ;------------------------------------------
      Toggle\BalloonTooltips                =       Val(GetDatabaseString(Program\DatabaseHandle,    4))  ;: Debug  "Balloon tooltips state:                        " +   Str(Toggle\BalloonTooltips)
      Toggle\BalloonColour                  =       Val(GetDatabaseString(Program\DatabaseHandle,    5))  ;: Debug  "Balloon colour state:                          " +   Str(Toggle\BalloonColour))
      Toggle\ColourBand                     =       Val(GetDatabaseString(Program\DatabaseHandle,    6))  ;: Debug  "Colour banding state:                          " +   Str(Toggle\ColourBand)
      Toggle\HideDetail                     =       Val(GetDatabaseString(Program\DatabaseHandle,    7))  ;: Debug  "Hide details state:                            " +   Str(Toggle\HideDetail)
      Toggle\MessageSave                    =       Val(GetDatabaseString(Program\DatabaseHandle,    8))  ;: Debug  "Message save state:                            " +   Str(Toggle\MessageSave)
      Toggle\ShowToolbar                    =       Val(GetDatabaseString(Program\DatabaseHandle,    9))  ;: Debug  "Show toolbar state:                            " +   Str(Toggle\ShowToolbar)
      Toggle\ScreenSnap                     =       Val(GetDatabaseString(Program\DatabaseHandle,   10))  ;: Debug  "Screen snap state:                             " +   Str(Toggle\ScreenSnap)
      Toggle\StickyWindow                   =       Val(GetDatabaseString(Program\DatabaseHandle,   11))  ;: Debug  "Sticky window state:                           " +   Str(Toggle\StickyWindow)
      Toggle\TitleClock                     =       Val(GetDatabaseString(Program\DatabaseHandle,   12))  ;: Debug  "Title clock state:                             " +   Str(Toggle\TitleClock)
      ;------------------------------------------
    Wend
    FinishDatabaseQuery(Program\DatabaseHandle)
  Else
    MessageRequesterEBS("Options Read Error", "Could not read the options from the database. " + DatabaseError(), #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
    ;MessageRequester("Options Read Error", "Could not read the options from the database. " + DatabaseError(), #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; If no password, get a new one or open the password window if one exists
  ;------------------------------------------------------------------------------------------------
  
  If Program\MD5FingerPrint = #Empty$
    NewPassWordWindow()
  ElseIf  Program\MD5FingerPrint <> #Empty$
    StartPassWordWindow()
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Show the registered user name above the search bars.
  ;------------------------------------------------------------------------------------------------
  
  ;   If FirstName.s <> #Empty$ And LastName.s <> #Empty$
  ;     SetGadgetText(#Gadget_MyInfo_lRegistration, #Fish + ", Program: ["  + #Basename + #Version + Program\CompileCounters  + "], Status:  [Freeware], Registered To: " + FirstName.s + " "  + LastName.s)
  ;   Else
  ;     SetGadgetText(#Gadget_MyInfo_lRegistration, #Fish + ", Program: ["  + #Basename + #Version + Program\CompileCounters  + "], Status:  [Freeware], Registered to: [No registration name found]")
  ;   EndIf
  
  If FirstName.s <> #Empty$ And LastName.s <> #Empty$
    SetGadgetText(#Gadget_MyInfo_lRegistration, #Fish + "   "  + #Basename + #Version + Program\CompileCounters  + ", Freeware, Registered To: " + FirstName.s + " "  + LastName.s)
  Else
    SetGadgetText(#Gadget_MyInfo_lRegistration, #Fish + "   "  + #Basename + #Version + Program\CompileCounters  + ", Freeware, Registered to: [No registration name found]")
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Fix the ItemCount field in the category table on database changes
  ;------------------------------------------------------------------------------------------------
  
  ; OneTimeCategoryUpdate()
  
  ;------------------------------------------------------------------------------------------------
  ; Create the owners table because it's not in the old MyInfo format
  ;------------------------------------------------------------------------------------------------
  
  ; OneTimeMakeOwners()
  
  ;------------------------------------------------------------------------------------------------
  ; Convert the rtf data in the info field to normal text as it looks bad printed
  ;------------------------------------------------------------------------------------------------
  
  ; OneTimeConvertRtfDatabase()
  
  ;------------------------------------------------------------------------------------------------
  ; Deleted font, screen snapping and more
  ;------------------------------------------------------------------------------------------------
  
  SetWindowCallback(@MainWindowCallback())
  
  ;------------------------------------------------------------------------------------------------
  ; Create the main program menu
  ;------------------------------------------------------------------------------------------------
  
  If CreateImageMenu(#MenuBar_MyInfo, WindowID(#Window_MyInfo))
    MenuTitle("Files")
    MenuItem(#MenuBar_MyInfo_BackupDatabase,        ShortTooltip\BackupDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_BackupDatabase),    ImageID(#MenuBarIcon_MyInfo_BackupDatabase))
    MenuItem(#MenuBar_MyInfo_ExportDatabase,        ShortTooltip\ExportDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_ExportDatabase),    ImageID(#MenuBarIcon_MyInfo_ExportDatabase))
    MenuItem(#MenuBar_MyInfo_ImportDatabase,        ShortTooltip\ImportDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_ImportDatabase),    ImageID(#MenuBarIcon_MyInfo_ImportDatabase))
    MenuItem(#MenuBar_MyInfo_OpenAdatabase,         ShortTooltip\OpenAdatabase     + #TAB$ + GetShortcutText(#ShortcutValue_OpenADatabase),     ImageID(#MenuBarIcon_MyInfo_OpenADatabase)) 
    MenuItem(#MenuBar_MyInfo_VacuumDatabase,        ShortTooltip\VacuumDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_VacuumDatabase),    ImageID(#MenuBarIcon_MyInfo_VacuumDatabase))
    MenuBar()
    MenuItem(#MenuBar_MyInfo_ExitProgram,           ShortTooltip\ExitProgram       + #TAB$ + GetShortcutText(#ShortcutValue_ExitProgram),       ImageID(#MenuBarIcon_MyInfo_ExitProgram))
    MenuTitle("Categories")
    MenuItem(#MenuBar_MyInfo_AddCategory,           ShortTooltip\AddCategory       + #TAB$ + GetShortcutText(#ShortcutValue_AddCategory),       ImageID(#MenuBarIcon_MyInfo_AddCategory))
    MenuItem(#MenuBar_MyInfo_CopyCategory,          ShortTooltip\CopyCategory      + #TAB$ + GetShortcutText(#ShortcutValue_CopyCategory),      ImageID(#MenuBarIcon_MyInfo_CopyCategory))
    MenuItem(#MenuBar_MyInfo_DeleteCategory,        ShortTooltip\DeleteCategory    + #TAB$ + GetShortcutText(#ShortcutValue_DeleteCategory),    ImageID(#MenuBarIcon_MyInfo_DeleteCategory))
    MenuItem(#MenuBar_MyInfo_EditCategory,          ShortTooltip\EditCategory      + #TAB$ + GetShortcutText(#ShortcutValue_EditCategory),      ImageID(#MenuBarIcon_MyInfo_EditCategory))
    MenuBar()
    MenuItem(#MenuBar_MyInfo_ExportCategories,      ShortTooltip\ExportCategories  + #TAB$ + GetShortcutText(#ShortcutValue_ExportCategories),  ImageID(#MenuBarIcon_MyInfo_ExportCategories))
    MenuItem(#MenuBar_MyInfo_ImportCategories,      ShortTooltip\ImportCategories  + #TAB$ + GetShortcutText(#ShortcutValue_ImportCategories),  ImageID(#MenuBarIcon_MyInfo_ImportCategories))
    MenuBar()
    MenuItem(#MenuBar_MyInfo_SyncCategories,        ShortTooltip\SyncCategories    + #TAB$ + GetShortcutText(#ShortcutValue_SyncCategories),    ImageID(#MenuBarIcon_MyInfo_SyncCategories))
    MenuTitle("Data")
    MenuItem(#MenuBar_MyInfo_AddItem,               ShortTooltip\AddItem           + #TAB$ + GetShortcutText(#ShortcutValue_AddItem),           ImageID(#MenuBarIcon_MyInfo_AddItem))
    MenuItem(#MenuBar_MyInfo_ArchiveItem,           ShortTooltip\ArchiveItem       + #TAB$ + GetShortcutText(#ShortcutValue_ArchiveItem),       ImageID(#MenuBarIcon_MyInfo_ArchiveItem))
    MenuItem(#MenuBar_MyInfo_AttachItem,            ShortTooltip\AttachItem        + #TAB$ + GetShortcutText(#ShortcutValue_AttachItem),        ImageID(#MenuBarIcon_MyInfo_AttachItem))
    MenuItem(#MenuBar_MyInfo_CopyItem,              ShortTooltip\CopyItem          + #TAB$ + GetShortcutText(#ShortcutValue_CopyItem),          ImageID(#MenuBarIcon_MyInfo_CopyItem))
    MenuItem(#MenuBar_MyInfo_DeleteItem,            ShortTooltip\DeleteItem        + #TAB$ + GetShortcutText(#ShortcutValue_DeleteItem),        ImageID(#MenuBarIcon_MyInfo_DeleteItem))
    MenuItem(#MenuBar_MyInfo_EditItem,              ShortTooltip\EditItem          + #TAB$ + GetShortcutText(#ShortcutValue_EditItem),          ImageID(#MenuBarIcon_MyInfo_EditItem))
    MenuItem(#MenuBar_MyInfo_ExportItem,            ShortTooltip\Exportitem        + #TAB$ + GetShortcutText(#ShortcutValue_ExportItem),        ImageID(#MenuBarIcon_MyInfo_ExportItem))
    MenuItem(#MenuBar_MyInfo_FavouriteItem,         ShortTooltip\FavouriteItem     + #TAB$ + GetShortcutText(#ShortcutValue_FavouriteItem),     ImageID(#MenuBarIcon_MyInfo_FavouriteItem))
    MenuItem(#MenuBar_MyInfo_ImportItem,            ShortTooltip\ImportItem        + #TAB$ + GetShortcutText(#ShortcutValue_ImportItem),        ImageID(#MenuBarIcon_MyInfo_ImportItem))
    MenuItem(#MenuBar_MyInfo_KillItem,              ShortTooltip\KillItem          + #TAB$ + GetShortcutText(#ShortcutValue_KillItem),          ImageID(#MenuBarIcon_MyInfo_KillItem))
    MenuItem(#MenuBar_MyInfo_LockItem,              ShortTooltip\LockItem          + #TAB$ + GetShortcutText(#ShortcutValue_LockItem),          ImageID(#MenuBarIcon_MyInfo_LockItem))
    MenuItem(#MenuBar_MyInfo_PrintItem,             ShortTooltip\PrintItem         + #TAB$ + GetShortcutText(#ShortcutValue_PrintItem),         ImageID(#MenuBarIcon_MyInfo_PrintItem))
    MenuItem(#MenuBar_MyInfo_Scanitem,              ShortTooltip\Scanitem          + #TAB$ + GetShortcutText(#ShortcutValue_Scanitem),          ImageID(#MenuBarIcon_MyInfo_Scanitem))
    MenuTitle("Utilities")
    MenuItem(#MenuBar_MyInfo_AdvancedSearch,        ShortTooltip\AdvancedSearch    + #TAB$ + GetShortcutText(#ShortcutValue_AdvancedSearch),    ImageID(#MenuBarIcon_MyInfo_AdvancedSearch))
    MenuItem(#MenuBar_MyInfo_SelectAllItems,        ShortTooltip\SelectAllItems    + #TAB$ + GetShortcutText(#ShortcutValue_SelectAllItems),    ImageID(#MenuBarIcon_MyInfo_SelectAllItems))
    MenuBar()
    MenuItem(#MenuBar_MyInfo_OwnerManagement,       ShortTooltip\OwnerManagement   + #TAB$ + GetShortcutText(#ShortcutValue_OwnerManagement),   ImageID(#MenuBarIcon_MyInfo_OwnerManagement))
    MenuBar()
    MenuItem(#MenuBar_MyInfo_EditPassword,          ShortTooltip\EditPassword      + #TAB$ + GetShortcutText(#ShortcutValue_EditPassword),      ImageID(#MenuBarIcon_MyInfo_EditPassword))
    MenuItem(#MenuBar_MyInfo_LockProgram,           ShortTooltip\LockProgram       + #TAB$ + GetShortcutText(#ShortcutValue_LockProgram),       ImageID(#MenuBarIcon_MyInfo_LockProgram))
    MenuBar()
    MenuItem(#MenuBar_MyInfo_ChangeFont,            ShortTooltip\ChangeFont        + #TAB$ + GetShortcutText(#ShortcutValue_ChangeFont),        ImageID(#MenuBarIcon_MyInfo_ChangeFont))
    MenuTitle("Options")
    MenuItem(#MenuBar_MyInfo_BalloonTooltips,       ShortTooltip\BalloonTooltips   + #TAB$ + GetShortcutText(#ShortcutValue_BalloonTooltips))
    MenuItem(#MenuBar_MyInfo_BalloonColour,         ShortTooltip\BalloonColour     + #TAB$ + GetShortcutText(#ShortcutValue_BalloonColour))
    MenuItem(#MenuBar_MyInfo_ColourBand,            ShortTooltip\ColourBand        + #TAB$ + GetShortcutText(#ShortcutValue_ColourBand))
    MenuItem(#MenuBar_MyInfo_HideDetail,            ShortTooltip\HideDetail        + #TAB$ + GetShortcutText(#ShortcutValue_HideDetail))
    MenuItem(#MenuBar_MyInfo_MessageSave,           ShortTooltip\MessageSave       + #TAB$ + GetShortcutText(#ShortcutValue_MessageSave))
    MenuItem(#MenuBar_MyInfo_ShowToolbar,           ShortTooltip\ShowToolbar       + #TAB$ + GetShortcutText(#ShortcutValue_ShowToolbar))
    MenuItem(#MenuBar_MyInfo_ScreenSnap,            ShortTooltip\Screensnap        + #TAB$ + GetShortcutText(#ShortcutValue_Screensnap))
    MenuItem(#MenuBar_MyInfo_StickyWindow,          ShortTooltip\Stickywindow      + #TAB$ + GetShortcutText(#ShortcutValue_Stickywindow))
    MenuItem(#MenuBar_MyInfo_TitleClock,            ShortTooltip\Titleclock        + #TAB$ + GetShortcutText(#ShortcutValue_Titleclock))
    MenuTitle("Help")
    MenuItem(#MenuBar_MyInfo_AboutProgram,          ShortTooltip\AboutProgram      + #TAB$ + GetShortcutText(#ShortcutValue_AboutProgram),      ImageID(#MenuBarIcon_MyInfo_AboutProgram))
    MenuItem(#MenuBar_MyInfo_KeyboardShortcuts,     ShortTooltip\KeyboardShortcuts + #TAB$ + GetShortcutText(#ShortcutValue_KeyboardShortcuts), ImageID(#MenuBarIcon_MyInfo_KeyboardShortcuts))
    MenuItem(#MenuBar_MyInfo_ProgramHelp,           ShortTooltip\ProgramHelp       + #TAB$ + GetShortcutText(#ShortcutValue_ProgramHelp),       ImageID(#MenuBarIcon_MyInfo_ProgramHelp))
    MenuItem(#MenuBar_MyInfo_ViewLog,               ShortTooltip\ViewLog           + #TAB$ + GetShortcutText(#ShortcutValue_ViewLog),           ImageID(#MenuBarIcon_MyInfo_ViewLog))
  Else
    MessageRequester("Menu Creation Error", "Could not create the main system menu, program error, must abort.", #PB_MessageRequester_Ok)
    Program\QuitValue = #True
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; Create the Category bar popup menu
  ;------------------------------------------------------------------------------------------------

  If CreatePopupImageMenu(#PopMenuBar_Category)
    MenuItem(#PopMenuBar_Category_AddCategory,      ShortTooltip\AddCategory      + #TAB$ + GetShortcutText(#ShortcutValue_AddCategory),       ImageID(#MenuBarIcon_MyInfo_AddCategory))
    MenuItem(#PopMenuBar_Category_CopyCategory,     ShortTooltip\CopyCategory     + #TAB$ + GetShortcutText(#ShortcutValue_CopyCategory),      ImageID(#MenuBarIcon_MyInfo_CopyCategory))
    MenuItem(#PopMenuBar_Category_DeleteCategory,   ShortTooltip\DeleteCategory   + #TAB$ + GetShortcutText(#ShortcutValue_DeleteCategory),    ImageID(#MenuBarIcon_MyInfo_DeleteCategory))
    MenuItem(#PopMenuBar_Category_EditCategory,     ShortTooltip\EditCategory     + #TAB$ + GetShortcutText(#ShortcutValue_EditCategory),      ImageID(#MenuBarIcon_MyInfo_EditCategory))
    MenuBar()
    MenuItem(#PopMenuBar_Category_ExportCategories, ShortTooltip\ExportCategories + #TAB$ + GetShortcutText(#ShortcutValue_ExportCategories),  ImageID(#MenuBarIcon_MyInfo_ExportCategories))
    MenuItem(#PopMenuBar_Category_ImportCategories, ShortTooltip\ImportCategories + #TAB$ + GetShortcutText(#ShortcutValue_ImportCategories),  ImageID(#MenuBarIcon_MyInfo_ImportCategories))
    MenuBar()
    MenuItem(#PopMenuBar_Category_SyncCategories,   ShortTooltip\SyncCategories   + #TAB$ + GetShortcutText(#ShortcutValue_SyncCategories),    ImageID(#MenuBarIcon_MyInfo_SyncCategories))
  Else
    MessageRequester("Category menu", "Could not create the category popup menu, program error, must abort.", #PB_MessageRequester_Ok)
    Program\QuitValue = #True
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Create the main program popupmenu
  ;------------------------------------------------------------------------------------------------
  
  If CreatePopupImageMenu(#PopMenuBar_MyInfo)
    ;MenuTitle("Files")
    MenuItem(#PopMenuBar_MyInfo_BackupDatabase,    ShortTooltip\BackupDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_BackupDatabase),    ImageID(#MenuBarIcon_MyInfo_BackupDatabase))
    MenuItem(#PopMenuBar_MyInfo_ExportDatabase,    ShortTooltip\ExportDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_ExportDatabase),    ImageID(#MenuBarIcon_MyInfo_ExportDatabase))
    MenuItem(#PopMenuBar_MyInfo_ImportDatabase,    ShortTooltip\ImportDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_ImportDatabase),    ImageID(#MenuBarIcon_MyInfo_ImportDatabase))
    MenuItem(#PopMenuBar_MyInfo_OpenAdatabase,     ShortTooltip\OpenAdatabase     + #TAB$ + GetShortcutText(#ShortcutValue_OpenADatabase),     ImageID(#MenuBarIcon_MyInfo_OpenADatabase)) 
    MenuItem(#PopMenuBar_MyInfo_VacuumDatabase,    ShortTooltip\VacuumDatabase    + #TAB$ + GetShortcutText(#ShortcutValue_VacuumDatabase),    ImageID(#MenuBarIcon_MyInfo_VacuumDatabase))
    MenuItem(#PopMenuBar_MyInfo_ExitProgram,       ShortTooltip\ExitProgram       + #TAB$ + GetShortcutText(#ShortcutValue_ExitProgram),       ImageID(#MenuBarIcon_MyInfo_ExitProgram))
    ;MenuTitle("Data")
    MenuBar()
    MenuItem(#PopMenuBar_MyInfo_AddItem,           ShortTooltip\AddItem           + #TAB$ + GetShortcutText(#ShortcutValue_AddItem),           ImageID(#MenuBarIcon_MyInfo_AddItem))
    MenuItem(#PopMenuBar_MyInfo_ArchiveItem,       ShortTooltip\ArchiveItem       + #TAB$ + GetShortcutText(#ShortcutValue_ArchiveItem),       ImageID(#MenuBarIcon_MyInfo_ArchiveItem))
    MenuItem(#PopMenuBar_MyInfo_AttachItem,        ShortTooltip\AttachItem        + #TAB$ + GetShortcutText(#ShortcutValue_AttachItem),        ImageID(#MenuBarIcon_MyInfo_AttachItem))
    MenuItem(#PopMenuBar_MyInfo_CopyItem,          ShortTooltip\CopyItem          + #TAB$ + GetShortcutText(#ShortcutValue_CopyItem),          ImageID(#MenuBarIcon_MyInfo_CopyItem))
    MenuItem(#PopMenuBar_MyInfo_DeleteItem,        ShortTooltip\DeleteItem        + #TAB$ + GetShortcutText(#ShortcutValue_DeleteItem),        ImageID(#MenuBarIcon_MyInfo_DeleteItem))
    MenuItem(#PopMenuBar_MyInfo_EditItem,          ShortTooltip\EditItem          + #TAB$ + GetShortcutText(#ShortcutValue_EditItem),          ImageID(#MenuBarIcon_MyInfo_EditItem))
    MenuItem(#PopMenuBar_MyInfo_ExportItem,        ShortTooltip\Exportitem        + #TAB$ + GetShortcutText(#ShortcutValue_ExportItem),        ImageID(#MenuBarIcon_MyInfo_ExportItem))
    MenuItem(#PopMenuBar_MyInfo_FavouriteItem,     ShortTooltip\FavouriteItem     + #TAB$ + GetShortcutText(#ShortcutValue_FavouriteItem),     ImageID(#MenuBarIcon_MyInfo_FavouriteItem))
    MenuItem(#PopMenuBar_MyInfo_ImportItem,        ShortTooltip\ImportItem        + #TAB$ + GetShortcutText(#ShortcutValue_ImportItem),        ImageID(#MenuBarIcon_MyInfo_ImportItem))
    MenuItem(#PopMenuBar_MyInfo_KillItem,          ShortTooltip\KillItem          + #TAB$ + GetShortcutText(#ShortcutValue_KillItem),          ImageID(#MenuBarIcon_MyInfo_KillItem))
    MenuItem(#PopMenuBar_MyInfo_LockItem,          ShortTooltip\LockItem          + #TAB$ + GetShortcutText(#ShortcutValue_LockItem),          ImageID(#MenuBarIcon_MyInfo_LockItem))
    MenuItem(#PopMenuBar_MyInfo_PrintItem,         ShortTooltip\PrintItem         + #TAB$ + GetShortcutText(#ShortcutValue_PrintItem),         ImageID(#MenuBarIcon_MyInfo_PrintItem))
    MenuItem(#PopMenuBar_MyInfo_Scanitem,          ShortTooltip\Scanitem          + #TAB$ + GetShortcutText(#ShortcutValue_Scanitem),          ImageID(#MenuBarIcon_MyInfo_Scanitem))
    ;MenuTitle("Utilities")
    MenuBar()
    MenuItem(#PopMenuBar_MyInfo_AdvancedSearch,    ShortTooltip\AdvancedSearch    + #TAB$ + GetShortcutText(#ShortcutValue_AdvancedSearch),    ImageID(#MenuBarIcon_MyInfo_AdvancedSearch))
    MenuItem(#PopMenuBar_MyInfo_SelectAllItems,    ShortTooltip\SelectAllItems    + #TAB$ + GetShortcutText(#ShortcutValue_SelectAllItems),    ImageID(#MenuBarIcon_MyInfo_SelectAllItems))
    MenuItem(#PopMenuBar_MyInfo_OwnerManagement,   ShortTooltip\OwnerManagement   + #TAB$ + GetShortcutText(#ShortcutValue_OwnerManagement),   ImageID(#MenuBarIcon_MyInfo_OwnerManagement))
    MenuItem(#PopMenuBar_MyInfo_EditPassword,      ShortTooltip\EditPassword      + #TAB$ + GetShortcutText(#ShortcutValue_EditPassword),      ImageID(#MenuBarIcon_MyInfo_EditPassword))
    MenuItem(#PopMenuBar_MyInfo_LockProgram,       ShortTooltip\LockProgram       + #TAB$ + GetShortcutText(#ShortcutValue_LockProgram),       ImageID(#MenuBarIcon_MyInfo_LockProgram))
    MenuItem(#PopMenuBar_MyInfo_ChangeFont,        ShortTooltip\ChangeFont        + #TAB$ + GetShortcutText(#ShortcutValue_ChangeFont),        ImageID(#MenuBarIcon_MyInfo_ChangeFont))
    ;MenuTitle("Options")
    MenuBar()
    MenuItem(#PopMenuBar_MyInfo_BalloonTooltips,   ShortTooltip\BalloonTooltips   + #TAB$ + GetShortcutText(#ShortcutValue_BalloonTooltips))
    MenuItem(#PopMenuBar_MyInfo_BalloonColour,     ShortTooltip\BalloonColour     + #TAB$ + GetShortcutText(#ShortcutValue_BalloonColour))
    MenuItem(#PopMenuBar_MyInfo_ColourBand,        ShortTooltip\ColourBand        + #TAB$ + GetShortcutText(#ShortcutValue_ColourBand))
    MenuItem(#PopMenuBar_MyInfo_HideDetail,        ShortTooltip\HideDetail        + #TAB$ + GetShortcutText(#ShortcutValue_HideDetail))
    MenuItem(#PopMenuBar_MyInfo_MessageSave,       ShortTooltip\MessageSave       + #TAB$ + GetShortcutText(#ShortcutValue_MessageSave))
    MenuItem(#PopMenuBar_MyInfo_ShowToolbar,       ShortTooltip\ShowToolbar       + #TAB$ + GetShortcutText(#ShortcutValue_ShowToolbar))
    MenuItem(#PopMenuBar_MyInfo_ScreenSnap,        ShortTooltip\Screensnap        + #TAB$ + GetShortcutText(#ShortcutValue_Screensnap))
    MenuItem(#PopMenuBar_MyInfo_StickyWindow,      ShortTooltip\Stickywindow      + #TAB$ + GetShortcutText(#ShortcutValue_Stickywindow))
    MenuItem(#PopMenuBar_MyInfo_TitleClock,        ShortTooltip\Titleclock        + #TAB$ + GetShortcutText(#ShortcutValue_Titleclock))
    ;MenuTitle("Help")
    MenuBar()
    MenuItem(#PopMenuBar_MyInfo_AboutProgram,      ShortTooltip\AboutProgram      + #TAB$ + GetShortcutText(#ShortcutValue_AboutProgram),      ImageID(#MenuBarIcon_MyInfo_AboutProgram))
    MenuItem(#PopMenuBar_MyInfo_KeyboardShortcuts, ShortTooltip\KeyboardShortcuts + #TAB$ + GetShortcutText(#ShortcutValue_KeyboardShortcuts), ImageID(#MenuBarIcon_MyInfo_KeyboardShortcuts))
    MenuItem(#PopMenuBar_MyInfo_ProgramHelp,       ShortTooltip\ProgramHelp       + #TAB$ + GetShortcutText(#ShortcutValue_ProgramHelp),       ImageID(#MenuBarIcon_MyInfo_ProgramHelp))
    MenuItem(#PopMenuBar_MyInfo_ViewLog,           ShortTooltip\ViewLog           + #TAB$ + GetShortcutText(#ShortcutValue_ViewLog),           ImageID(#MenuBarIcon_MyInfo_ViewLog))
  Else
    MessageRequester("Popup Menu Creation Error", "Could not create the main system popup menu, only form buttons will be available.", #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Popup menu for the editor gadget on the data form
  ;------------------------------------------------------------------------------------------------
  
  If CreatePopupImageMenu(#PopMenubar_Details)
    MenuItem(#PopMenubar_Details_CopyItem,          ShortTooltip\CopyItem         + #TAB$ + GetShortcutText(#ShortcutValue_CopyItem),         ImageID(#MenuBarIcon_MyInfo_CopyItem))
    MenuItem(#PopMenuBar_Details_EditItem,          ShortTooltip\EditItem         + #TAB$ + GetShortcutText(#ShortcutValue_EditItem),         ImageID(#MenuBarIcon_MyInfo_EditItem))
    MenuItem(#PopMenuBar_Details_PrintItem,         ShortTooltip\PrintItem        + #TAB$ + GetShortcutText(#ShortcutValue_PrintItem),        ImageID(#MenuBarIcon_MyInfo_PrintItem))
  Else
    MessageRequester("Main menu", "Could not create image popup menu for detail pane, no menu functions will be available.", #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Add all keyboard shortcuts to the main form
  ;------------------------------------------------------------------------------------------------
  
  ; Files
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_BackupDatabase,    #KeyboardShortcut_BackupDatabase)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ExportDatabase,    #KeyboardShortcut_ExportDatabase)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ImportDatabase,    #KeyboardShortcut_ImportDatabase)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_OpenAdatabase,     #KeyboardShortcut_OpenAdatabase)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_VacuumDatabase,    #KeyboardShortcut_VacuumDatabase)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ExitProgram,       #KeyboardShortcut_ExitProgram)
  ; Categories
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_AddCategory,       #KeyboardShortcut_AddCategory)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_CopyCategory,      #KeyboardShortcut_CopyCategory)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_DeleteCategory,    #KeyboardShortcut_DeleteCategory)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_EditCategory,      #KeyboardShortcut_EditCategory)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ExportCategories,  #KeyboardShortcut_ExportCategories)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ImportCategories,  #KeyboardShortcut_ImportCategories)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_SyncCategories,    #KeyboardShortcut_SyncCategories)
  ; Data
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_AddItem,           #KeyboardShortcut_AddItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ArchiveItem,       #KeyboardShortcut_ArchiveItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_AttachItem,        #KeyboardShortcut_AttachItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_CopyItem,          #KeyboardShortcut_CopyItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_DeleteItem,        #KeyboardShortcut_DeleteItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_EditItem,          #KeyboardShortcut_EditItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ExportItem,        #KeyboardShortcut_ExportItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_FavouriteItem,     #KeyboardShortcut_FavouriteItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ImportItem,        #KeyboardShortcut_ImportItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_KillItem,          #KeyboardShortcut_KillItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_LockItem,          #KeyboardShortcut_LockItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_PrintItem,         #KeyboardShortcut_PrintItem)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ScanItem,          #KeyboardShortcut_ScanItem)
  ; Utilities
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_AdvancedSearch,    #KeyboardShortcut_AdvancedSearch)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_SelectAllItems,    #KeyboardShortcut_SelectAllItems)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_OwnerManagement,   #KeyboardShortcut_OwnerManagement)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ChangeFont,        #KeyboardShortcut_ChangeFont)
  ; Options
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_BalloonColour,     #KeyboardShortcut_BalloonColour)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_BalloonTooltips,   #KeyboardShortcut_BalloonTooltips)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ColourBand,        #KeyboardShortcut_ColourBand)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_HideDetail,        #KeyboardShortcut_HideDetail)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_MessageSave,       #KeyboardShortcut_MessageSave)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ShowToolbar,       #KeyboardShortcut_ShowToolbar)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ScreenSnap,        #KeyboardShortcut_ScreenSnap)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_StickyWindow,      #KeyboardShortcut_StickyWindow)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_TitleClock,        #KeyboardShortcut_TitleClock)
  ; Help
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_AboutProgram,      #KeyboardShortcut_AboutProgram)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_KeyboardShortcuts, #KeyboardShortcut_KeyboardShortcuts)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ProgramHelp,       #KeyboardShortcut_ProgramHelp)
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_ViewLog,           #KeyboardShortcut_ViewLog)
  ; Basic searching
  AddKeyboardShortcut(#Window_MyInfo, #ShortcutValue_CheckEnter,        #KeyboardShortcut_CheckEnter)
  
  ;------------------------------------------------------------------------------------------------
  ; Remove borders from gadgets. Not everyone likes this
  ;------------------------------------------------------------------------------------------------
  
  ;   RemoveBorders(#Gadget_MyInfo_Category)
  ;   RemoveBorders(#Gadget_MyInfo_Titles)
  ;   RemoveBorders(#Gadget_MyInfo_Information)
  
  ;------------------------------------------------------------------------------------------------
  ; Turn on mouse event hover testing, this is NetMaestro's code.
  ;------------------------------------------------------------------------------------------------
  
  InitHoverEvents(#Window_MyInfo)
  
  ;------------------------------------------------------------------------------------------------
  ; Add main form gadgets to the hoverable list
  ;------------------------------------------------------------------------------------------------
  
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Add))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Archive))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Attach))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Copy))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Delete))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Edit))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Export))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Favourite))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Import))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Kill))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Lock))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Print))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Search))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Help))
  AddHoverGadget(GadgetID(#Gadget_MyInfo_Exit))
  
  ;------------------------------------------------------------------------------------------------
  ; Balloon tooltips with keyboard shortcut display
  ;------------------------------------------------------------------------------------------------
  
  If Program\BalloonFontId
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Add,        Program\BalloonFontId, GetBalloonColour(), ShortTooltip\AddItem,         #CRLF$ + GetShortCutText(#ShortcutValue_AddItem)        + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\AddItem,        30),  GetIconHandle(#Image_MyInfo_Add))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Archive,    Program\BalloonFontId, GetBalloonColour(), ShortTooltip\ArchiveItem,     #CRLF$ + GetShortCutText(#ShortcutValue_ArchiveItem)    + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ArchiveItem,    30),  GetIconHandle(#Image_MyInfo_Archive))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Attach,     Program\BalloonFontId, GetBalloonColour(), ShortTooltip\AttachItem,      #CRLF$ + GetShortCutText(#ShortcutValue_AttachItem)     + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\AttachItem,     30),  GetIconHandle(#Image_MyInfo_Attach))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Copy,       Program\BalloonFontId, GetBalloonColour(), ShortTooltip\CopyItem,        #CRLF$ + GetShortCutText(#ShortcutValue_CopyItem)       + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\CopyItem,       30),  GetIconHandle(#Image_MyInfo_Copy))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Delete,     Program\BalloonFontId, GetBalloonColour(), ShortTooltip\DeleteItem,      #CRLF$ + GetShortCutText(#ShortcutValue_DeleteItem)     + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\DeleteItem,     30),  GetIconHandle(#Image_MyInfo_Delete))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Edit,       Program\BalloonFontId, GetBalloonColour(), ShortTooltip\EditItem,        #CRLF$ + GetShortCutText(#ShortcutValue_EditItem)       + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\EditItem,       30),  GetIconHandle(#Image_MyInfo_Edit))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Export,     Program\BalloonFontId, GetBalloonColour(), ShortTooltip\ExportItem,      #CRLF$ + GetShortCutText(#ShortcutValue_ExportItem)     + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ExportItem,     30),  GetIconHandle(#Image_MyInfo_Export))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Favourite,  Program\BalloonFontId, GetBalloonColour(), ShortTooltip\FavouriteItem,   #CRLF$ + GetShortCutText(#ShortcutValue_FavouriteItem)  + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\FavouriteItem,  30),  GetIconHandle(#Image_MyInfo_Favourite))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Import,     Program\BalloonFontId, GetBalloonColour(), ShortTooltip\ImportItem,      #CRLF$ + GetShortCutText(#ShortcutValue_ImportItem)     + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ImportItem,     30),  GetIconHandle(#Image_MyInfo_Import))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Kill,       Program\BalloonFontId, GetBalloonColour(), ShortTooltip\KillItem,        #CRLF$ + GetShortCutText(#ShortcutValue_KillItem)       + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\KillItem,       30),  GetIconHandle(#Image_MyInfo_Kill))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Lock,       Program\BalloonFontId, GetBalloonColour(), ShortTooltip\LockItem,        #CRLF$ + GetShortCutText(#ShortcutValue_LockItem)       + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\LockItem,       30),  GetIconHandle(#Image_MyInfo_Lock))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Print,      Program\BalloonFontId, GetBalloonColour(), ShortTooltip\PrintItem,       #CRLF$ + GetShortCutText(#ShortcutValue_PrintItem)      + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\PrintItem,      30),  GetIconHandle(#Image_MyInfo_Print))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Search,     Program\BalloonFontId, GetBalloonColour(), ShortTooltip\AdvancedSearch,  #CRLF$ + GetShortCutText(#ShortcutValue_AdvancedSearch) + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\AdvancedSearch, 30),  GetIconHandle(#Image_MyInfo_Search))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Help,       Program\BalloonFontId, GetBalloonColour(), ShortTooltip\ProgramHelp,     #CRLF$ + GetShortCutText(#ShortcutValue_ProgramHelp)    + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ProgramHelp,    30),  GetIconHandle(#Image_MyInfo_Help))
    BalloonToolTip(#Window_MyInfo, #Gadget_MyInfo_Exit,       Program\BalloonFontId, GetBalloonColour(), ShortTooltip\ExitProgram,     #CRLF$ + GetShortCutText(#ShortcutValue_ExitProgram)    + #CRLF$ + #CRLF$ + WordWrapString(LongTooltip\ExitProgram,    30),  GetIconHandle(#Image_MyInfo_Exit))
  Else
    MessageRequester("Balloon font load error", "Could not load the ballon font so no tooltips will be loaded", #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Load a strikeout font to be used on the item list when an item is marked as deleted
  ;------------------------------------------------------------------------------------------------
  
  CurrentFont.i     = GetGadgetFont(#Gadget_MyInfo_Titles)                          ; Get current font
  GetObject_(CurrentFont.i, SizeOf(LOGFONT), @logf.LOGFONT)
  mFontName.s       = PeekS(@logf\lfFacename[0])
  hDEviceContext    = CreateDC_(@"DISPLAY", 0, 0, 0)
  LogPixSY          = GetDeviceCaps_(hDEviceContext, #LOGPIXELSY)
  DeleteDC_(hDEviceContext)
  mFontsize.F       = - (logf\lfHeight * 72) / LogPixSY
  LoadFont(#FontStrikeoutYes, mFontName.s, mFontsize.F, #PB_Font_StrikeOut | #PB_Font_Italic | #PB_Font_HighQuality)  ; Load current font And add strikeout attribute
  LoadFont(#FontStrikeoutNo,  mFontName.s, mFontsize.F, #PB_Font_HighQuality)
  
  ;------------------------------------------------------------------------------------------------
  ; Enable category changing by drag and drop
  ;------------------------------------------------------------------------------------------------
  
  EnableGadgetDrop(#Gadget_MyInfo_Category, #PB_Drop_Text, #PB_Drag_Copy)
  
  ;------------------------------------------------------------------------------------------------
  ; Enable importing data by dropping a file on the titles list
  ;------------------------------------------------------------------------------------------------
  
  EnableGadgetDrop(#Gadget_MyInfo_Titles, #PB_Drop_Files, #PB_Drag_Copy)
  
  ;------------------------------------------------------------------------------------------------
  ; Set initial search cue font
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetFont(#Gadget_MyInfo_Searchstring, FontID(Cue\SearchCueFont))
  
  ;------------------------------------------------------------------------------------------------
  ; Limit the number of search box characters and set the cue banner text. These variables are set
  ; in the MyInfo_Myconstants file.
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(#Gadget_MyInfo_Searchstring), #EM_SETLIMITTEXT, 67, 0)
  SendMessage_(GadgetID(#Gadget_MyInfo_Searchstring), #EM_SETCUEBANNER,  1,  Cue\SearchCueText)
  
  ;------------------------------------------------------------------------------------------------
  ; Add the search type operators
  ;------------------------------------------------------------------------------------------------
  
  Restore BeginSearchTypes
  
  While TempString.s <> "_EndSearchTypes_"
    Read.s TempString.s
     If TempString.s <> "_EndSearchTypes_"
       AddGadgetItem(#Gadget_MyInfo_Searchtype, #AtTheEndOfTheList, TempString.s, ImageID(#Image_ComboSql))
     EndIf
   Wend

   TempString.s = "<>"

  SetGadgetState(#Gadget_MyInfo_Searchtype, #FirstItem)

  ;------------------------------------------------------------------------------------------------
  ; Add the field selector combo box
  ;------------------------------------------------------------------------------------------------
  
  AddGadgetItem(#Gadget_MyInfo_Searchfield, #AtTheEndOfTheList, "All fields",   ImageID(#Image_DataFields))
  
  Restore BeginSqlFields
  
  While TempSqlFields.s <> "_EndSqlFields_"
    Read.s TempSqlFields.s
    If TempSqlFields.s <> "_EndSqlFields_"
      AddGadgetItem(#Gadget_MyInfo_Searchfield, #AtTheEndOfTheList, TempSqlFields.s,  ImageID(#Image_DataFields))
    EndIf
  Wend
  
  TempSqlFields.s    = "<>"
  
  SetGadgetState(#Gadget_MyInfo_Searchfield, #FirstItem)  
  
  ;------------------------------------------------------------------------------------------------
  ; Update the last opened date field. ISO date standard date used
  ;------------------------------------------------------------------------------------------------
  
  VersionUpdate.s                       + 
  "UPDATE Version "                     + 
  "SET LastUpdate = '"                  + 
  FormatDate("%yyyy-%mm-%dd", Date())   + 
  "' "                                  + 
  "WHERE Recordid = '1'"
  
  If DatabaseUpdate(Program\DatabaseHandle, VersionUpdate.s) <> #DatabaseUpdateFail
    ; Database update version succeeded
  Else
    MessageRequester("Version Update Error", "Could not update the program version number into the database. " + DatabaseError(), #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 1   Turn balloon colours to random or fixed, on or off for the main form and others
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\BalloonColour = #False
    Toggle\BalloonColour = #True
  ElseIf Toggle\BalloonColour = #True
    Toggle\BalloonColour = #False
  EndIf
  
  ToggleBalloonColour()
  
  ;------------------------------------------------------------------------------------------------
  ; 2   Turn balloon tooltips on or off for the main form and others
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\BalloonTooltips = #False
    Toggle\BalloonTooltips = #True
  ElseIf Toggle\BalloonTooltips = #True
    Toggle\BalloonTooltips = #False
  EndIf
  
  ToggleBalloonToolTips()
  
  ;------------------------------------------------------------------------------------------------
  ; 3   Turn on or off alternate row colouring in the title list
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\ColourBand = #False
    Toggle\ColourBand = #True
  ElseIf Toggle\ColourBand = #True
    Toggle\ColourBand = #False
  EndIf
  
  ToggleColourBand()
  
  ;------------------------------------------------------------------------------------------------
  ; 4   Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\HideDetail = #False
    Toggle\HideDetail = #True
  ElseIf Toggle\HideDetail = #True
    Toggle\HideDetail = #False
  EndIf
  
  ToggleHideDetail()
  
  ;------------------------------------------------------------------------------------------------
  ; 5   Choose to show messages after saving data
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\MessageSave = #False
    Toggle\MessageSave = #True
  ElseIf Toggle\MessageSave = #True
    Toggle\MessageSave = #False
  EndIf
  
  ToggleMessageSave()
  
  ;------------------------------------------------------------------------------------------------
  ; 6   Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\ShowToolbar = #False
    Toggle\ShowToolbar = #True
  ElseIf Toggle\ShowToolbar = #True
    Toggle\ShowToolbar = #False
  EndIf
  
  ToggleWindowToolBars()
  
  ;------------------------------------------------------------------------------------------------
  ; 7   Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\ScreenSnap = #False
    Toggle\ScreenSnap = #True
  ElseIf Toggle\ScreenSnap = #True
    Toggle\ScreenSnap = #False
  EndIf
  
  ToggleScreenSnap()
  
  ;------------------------------------------------------------------------------------------------
  ; 8   Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\StickyWindow = #False
    Toggle\StickyWindow = #True
  ElseIf Toggle\StickyWindow = #True
    Toggle\StickyWindow = #False
  EndIf
  
  ToggleStickyWindow()
  
  ;------------------------------------------------------------------------------------------------
  ; 9   Create the permanent title bar clock timer
  ;------------------------------------------------------------------------------------------------
  
  If Toggle\TitleClock = #False
    Toggle\TitleClock = #True
  ElseIf Toggle\TitleClock = #True
    Toggle\TitleClock = #False
  EndIf
  
  ToggleTitleBarClock()
  
  ;------------------------------------------------------------------------------------------------
  ; Setup the various semaphores and switches that are not database dependant
  ;------------------------------------------------------------------------------------------------
  
  If Not TWAIN_IsAvailable()
    ;MessageRequester("Scan functions", "TWAIN scanner interface is not available Scanner will not work.")
    MessageRequesterEBS("Scan functions", "TWAIN scanner interface is not available, scan functions will not work.", #MB_ICONINFORMATION | #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Set the initial program quit flag
  ;------------------------------------------------------------------------------------------------
  
  Program\QuitValue = #False
  
  ;------------------------------------------------------------------------------------------------
  ; Set a marker for first time only operations
  ;------------------------------------------------------------------------------------------------
  
  Program\FirstTime = #False
  
  ;------------------------------------------------------------------------------------------------
  ; Set the last used display search limit
  ;------------------------------------------------------------------------------------------------
  
  If Program\SearchLimit  <>  #Empty$
    SetGadgetText(#Gadget_MyInfo_SearchLimit, Program\SearchLimit)
  Else
    SetGadgetText(#Gadget_MyInfo_SearchLimit, "25")
    Program\SearchLimit = "25"
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; Set the last used search string
  ;------------------------------------------------------------------------------------------------
  
  SetGadgetText(#Gadget_MyInfo_Searchstring, Program\LastSearch)
  
  ;------------------------------------------------------------------------------------------------
  ; Now display all the categories available
  ;------------------------------------------------------------------------------------------------
  
  LoadCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; Set the fake statusbar heading appropriate for the run time of the program
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.s = CountRecords("Record", "MyInfo")
  
  If NumberOfItems.s = "0"
    SetInfoBarArea("Headings",  "Welcome",  "Program " + #Program + " is ready to go.", "MainModule")
    SetInfoBarArea("Number",    "",         "?", "MainModule")
    SetInfoBarArea("Records",   "",         "0", "MainModule")
  ElseIf NumberOfItems.s <> "0"
    SetGadgetState(#Gadget_MyInfo_Titles, 0)
    PostEvent(#PB_Event_Gadget, #Window_MyInfo, #Gadget_MyInfo_Titles, #PB_EventType_Change)
    SetInfoBarArea("Headings",  "Welcome",  "Welcome to MyInfo " + #Image_ProgramIcon, "MainModule")
    SetInfoBarArea("Records",   "",         NumberOfItems.s, "MainModule")
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Set focus on the search bar
  ;------------------------------------------------------------------------------------------------
  
  SetActiveGadget(#Gadget_MyInfo_Searchstring)
  
  ;------------------------------------------------------------------------------------------------
  ; Unhide the main program window
  ;------------------------------------------------------------------------------------------------
  
  HideWindow(#Window_MyInfo, #False)
  
  ;------------------------------------------------------------------------------------------------
  ; Start main form event processing
  ;------------------------------------------------------------------------------------------------
  
  Repeat
    
    EventID  = WaitWindowEvent()
    MenuID   = EventMenu()
    GadgetID = EventGadget()
    WindowID = EventWindow()
    
    ;----------------------------------------------------------------------------------------------
    ; All window closing events
    ;----------------------------------------------------------------------------------------------
    
    Select EventID
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
        
      Case #PB_Event_CloseWindow
        
        Select WindowID
            
          ;----------------------------------------------------------------------------------------
          ; Security windows
          ;----------------------------------------------------------------------------------------

          Case #Window_StartUpPassword                                                                                                    : Program\QuitValue = #True
          Case #Window_EditPassword                                                                                                       : CloseMyWindow(#Window_EditPassword)
          Case #Window_UnlockPassword                                                                                                     : Program\QuitValue = #True
          Case #Window_NewPassword                                                                                                        : Program\QuitValue = #True
            
          ;----------------------------------------------------------------------------------------
          ; Normal windows
          ;----------------------------------------------------------------------------------------
            
          Case #Window_MyInfo                                                                                                             : Program\QuitValue.i = #True
          Case #Window_Category                                                                                                           : CloseMyWindow(#Window_Category)
          Case #Window_Data                                                                                                               : CloseMyWindow(#Window_Data)
          Case #Window_Search                                                                                                             : CloseMyWindow(#Window_Search)
          Case #Window_OwnerList                                                                                                          : CloseMyWindow(#Window_OwnerList)
          Case #Window_Owner                                                                                                              : CloseMyWindow(#Window_Owner)
          Case #Window_Print                                                                                                              : CloseMyWindow(#Window_Print)
          Case #Window_About                                                                                                              : CloseMyWindow(#Window_About)
          Case #Window_Help                                                                                                               : CloseMyWindow(#Window_Help)
          Case #Window_Shortcuts                                                                                                          : CloseMyWindow(#Window_Shortcuts)
          Case #Window_Errorlog                                                                                                           : CloseMyWindow(#Window_Errorlog)
          Case #Window_Find                                                                                                               : CloseMyWindow(#Window_Find)
          Case #Window_Scan                                                                                                               : CloseMyWindow(#Window_Scan)
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; Minimise the program to the windows tray and set icon and tooltip
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_MinimizeWindow
        
        Select EventWindow()
          Case #Window_MyInfo                                                                                                             : HideProgramWindow()
        EndSelect

        ;------------------------------------------------------------------------------------------
        ; Wife says banner looks childish (Heheheh)
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_SizeWindow
        Select WindowID
          Case #Window_MyInfo                                                                                                             : 
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_GadgetDrop
        Select EventDropType()
          Case #PB_Drop_Text
            Select GadgetID
              Case #Gadget_MyInfo_Category                                                                                                : ChangeCategory()
            EndSelect
          Case #PB_Drop_Files
            Select GadgetID
              Case #Gadget_MyInfo_Titles                                                                                                  : DragnewData()
            EndSelect
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; All menu and keyboard shortcut events
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_Menu
        
        Select MenuID

          ; Password editing
          
          Case #KeyboardShortCut_EditPassword_Return                                                                                      : CheckPassWords()
          Case #KeyboardShortCut_EditPassword_Escape                                                                                      : CloseMyWindow(#Window_EditPassword)

          ; Program unlocking

          Case #KeyboardShortCut_UnlockPassword_Return                                                                                    : CheckUnlockPassWord()
          Case #KeyboardShortCut_UnlockPassword_Escape                                                                                    : Program\QuitValue.i = #True
            
          Case #PopMenuBar_MyInfo_EditPassword,         #MenuBar_MyInfo_EditPassword                                                      : EditPassWordWindow()
          Case #PopMenuBar_MyInfo_LockProgram,          #MenuBar_MyInfo_LockProgram                                                       : LockProgramWindow()
          
          ; Files menu

          Case #PopMenuBar_MyInfo_BackupDatabase,       #MenuBar_MyInfo_BackupDatabase,         #KeyboardShortcut_BackupDatabase          : BackupDatabase()
          Case #PopMenuBar_MyInfo_ExportDatabase,       #MenuBar_MyInfo_ExportDatabase,         #KeyboardShortcut_ExportDatabase          : ExportDatabase()
          Case #PopMenuBar_MyInfo_ImportDatabase,       #MenuBar_MyInfo_ImportDatabase,         #KeyboardShortcut_ImportDatabase          : ImportDatabase()
          Case #PopMenuBar_MyInfo_OpenAdatabase,        #MenuBar_MyInfo_OpenAdatabase,          #KeyboardShortcut_OpenAdatabase           : OpenAdatabase()
          Case #PopMenuBar_MyInfo_VacuumDatabase,       #MenuBar_MyInfo_VacuumDatabase,         #KeyboardShortcut_VacuumDatabase          : VacuumDeletedData()
          Case #PopMenuBar_MyInfo_ExitProgram,          #MenuBar_MyInfo_ExitProgram,            #KeyboardShortcut_ExitProgram             : Program\QuitValue.i = #True
            
          ; Categories menu
            
          Case #PopMenuBar_Category_AddCategory,        #MenuBar_MyInfo_AddCategory,           #KeyboardShortcut_AddCategory              : AddCategory()
          Case #PopMenuBar_Category_CopyCategory,       #MenuBar_MyInfo_CopyCategory,          #KeyboardShortcut_CopyCategory             : CopyCategory()
          Case #PopMenuBar_Category_DeleteCategory,     #MenuBar_MyInfo_DeleteCategory,        #KeyboardShortcut_DeleteCategory           : DeleteCategory()
          Case #PopMenuBar_Category_EditCategory,       #MenuBar_MyInfo_EditCategory,          #KeyboardShortcut_EditCategory             : EditCategory()
          Case #PopMenuBar_Category_ExportCategories,   #MenuBar_MyInfo_ExportCategories,      #KeyboardShortcut_ExportCategories         : ExportCategories()
          Case #PopMenuBar_Category_ImportCategories,   #MenuBar_MyInfo_ImportCategories,      #KeyboardShortcut_ImportCategories         : ImportCategories()
          Case #PopMenuBar_Category_SyncCategories,     #MenuBar_MyInfo_SyncCategories,        #KeyboardShortcut_SyncCategories           : SyncCategories()
            
          ; Data menu
            
          Case #PopMenuBar_MyInfo_AddItem,              #MenuBar_MyInfo_AddItem,              #KeyboardShortcut_AddItem                   : AddNewData()
          Case #PopMenuBar_MyInfo_ArchiveItem,          #MenuBar_MyInfo_ArchiveItem,          #KeyboardShortcut_ArchiveItem               : ArchiveThisData()
          Case #PopMenuBar_MyInfo_AttachItem,           #MenuBar_MyInfo_AttachItem,           #KeyboardShortcut_AttachItem                : AttachItemToData()
          Case #PopMenuBar_MyInfo_CopyItem,             #MenuBar_MyInfo_CopyItem,             #KeyboardShortcut_CopyItem                  : CopyDataToClipboard()
          Case #PopMenuBar_MyInfo_DeleteItem,           #MenuBar_MyInfo_DeleteItem,           #KeyboardShortcut_DeleteItem                : DeleteCurrentData()
          Case #PopMenuBar_MyInfo_EditItem,             #MenuBar_MyInfo_EditItem,             #KeyboardShortcut_EditItem                  : EditOldData()
          Case #PopMenuBar_MyInfo_ExportItem,           #MenuBar_MyInfo_ExportItem,           #KeyboardShortcut_ExportItem                : ExportItemToDisk()
          Case #PopMenuBar_MyInfo_FavouriteItem,        #MenuBar_MyInfo_FavouriteItem,        #KeyboardShortcut_FavouriteItem             : MarkAsFavourite()
          Case #PopMenuBar_MyInfo_ImportItem,           #MenuBar_MyInfo_ImportItem,           #KeyboardShortcut_ImportItem                : ImportItemFromDisk()
          Case #PopMenuBar_MyInfo_KillItem,             #MenuBar_MyInfo_KillItem,             #KeyboardShortcut_KillItem                  : KillCurrentData()
          Case #PopMenuBar_MyInfo_LockItem,             #MenuBar_MyInfo_LockItem,             #KeyboardShortcut_LockItem                  : LockCurrentData()
          Case #PopMenuBar_MyInfo_PrintItem,            #MenuBar_MyInfo_PrintItem,            #KeyboardShortcut_PrintItem                 : PrintThisData()
          Case #PopMenuBar_MyInfo_ScanItem,             #MenuBar_MyInfo_ScanItem,             #KeyboardShortcut_ScanItem                  : ScanDocument()
            
          ; Utilities menu
            
          Case #PopMenuBar_MyInfo_AdvancedSearch,       #MenuBar_MyInfo_AdvancedSearch,       #KeyboardShortcut_AdvancedSearch            : AdvancedSearch()
          Case #PopMenuBar_MyInfo_SelectAllItems,       #MenuBar_MyInfo_SelectAllItems,       #KeyboardShortcut_SelectAllItems            : SelectAllItems() 
          Case #PopMenuBar_MyInfo_OwnerManagement,      #MenuBar_MyInfo_OwnerManagement,      #KeyboardShortcut_OwnerManagement           : ManageOwners()
          Case #PopMenuBar_MyInfo_ChangeFont,           #MenuBar_MyInfo_ChangeFont,           #KeyboardShortcut_ChangeFont                : ;ChangeFont()               ; TODO
            
          ; Options menu
            
          Case #PopMenuBar_MyInfo_BalloonTooltips,      #MenuBar_MyInfo_BalloonTooltips,      #KeyboardShortcut_BalloonTooltips           : ToggleBalloonToolTips()
          Case #PopMenuBar_MyInfo_BalloonColour,        #MenuBar_MyInfo_BalloonColour,        #KeyboardShortcut_BalloonColour             : ToggleBalloonColour()
          Case #PopMenuBar_MyInfo_ColourBand,           #MenuBar_MyInfo_ColourBand,           #KeyboardShortcut_ColourBand                : ToggleColourBand()
          Case #PopMenuBar_MyInfo_HideDetail,           #MenuBar_MyInfo_HideDetail,           #KeyboardShortcut_HideDetail                : ToggleHideDetail()
          Case #PopMenuBar_MyInfo_MessageSave,          #MenuBar_MyInfo_MessageSave,          #KeyboardShortcut_MessageSave               : ToggleMessageSave()
          Case #PopMenuBar_MyInfo_ShowToolbar,          #MenuBar_MyInfo_ShowToolBar,          #KeyboardShortcut_ShowToolbar               : ToggleWindowToolbars()
          Case #PopMenuBar_MyInfo_ScreenSnap,           #MenuBar_MyInfo_ScreenSnap,           #KeyboardShortcut_ScreenSnap                : ToggleScreenSnap()
          Case #PopMenuBar_MyInfo_StickyWindow,         #MenuBar_MyInfo_StickyWindow,         #KeyboardShortcut_StickyWindow              : ToggleStickyWindow()
          Case #PopMenuBar_MyInfo_TitleClock,           #MenuBar_MyInfo_TitleClock,           #KeyboardShortcut_TitleClock                : ToggleTitlebarClock()
            
          ; Help menu
            
          Case #PopMenuBar_MyInfo_AboutProgram,         #MenuBar_MyInfo_AboutProgram,         #KeyboardShortcut_AboutProgram              : AboutMyInfo()
          Case #PopMenuBar_MyInfo_KeyboardShortcuts,    #MenuBar_MyInfo_KeyboardShortcuts,    #KeyboardShortcut_KeyboardShortcuts         : KeyboardShortcuts()
          Case #PopMenuBar_MyInfo_ProgramHelp,          #MenuBar_MyInfo_ProgramHelp,          #KeyboardShortcut_ProgramHelp               : ShowHelp("MainForm")
          Case #PopMenuBar_MyInfo_ViewLog,              #MenuBar_MyInfo_ViewLog,              #KeyboardShortcut_ViewLog                   : ViewErrorLog()
            
          ; Basic searching
            
          Case #KeyboardShortcut_CheckEnter                                                                                               : CheckEnterGadget()
            
          ;----------------------------------------------------------------------------------------
          ; Find data form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SearchDataForm                                                                                           : SearchDataFormNow()
          Case #KeyboardShortcut_EscapeFind                                                                                               : CloseMyWindow(#Window_Find)

          ;----------------------------------------------------------------------------------------
          ; Category form shortcuts
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SaveCategory                                                                                             : SaveCategory()
          Case #KeyboardShortcut_HelpCategory                                                                                             : ShowHelp("Category")
          Case #KeyboardShortcut_ExitCategory,          #KeyboardShortcut_EscapeCategory                                                  : CloseMyWindow(#Window_Category)
            
          ;----------------------------------------------------------------------------------------
          ; Data editor shortcuts
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SaveData                                                                                                 : SaveThisData()
          Case #KeyboardShortcut_ExportData                                                                                               : ; ExportData()
          Case #KeyboardShortcut_ImportData                                                                                               : ; ImportData()
          Case #KeyboardShortcut_HelpData                                                                                                 : ShowHelp("DataForm")
          Case #KeyboardShortcut_ExitData,             #KeyboardShortcut_EscapeData                                                       : CloseMyWindow(#Window_Data)
          Case #KeyboardShortcut_SearchData                                                                                               : SearchDataForm()
            
          ;----------------------------------------------------------------------------------------
          ; Advanced search form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_ReturnSearch                                                                                             : AdvancedSearchNow()
          Case #KeyboardShortcut_RunSearch                                                                                                : AdvancedSearchNow()
          Case #KeyboardShortcut_HelpSearch                                                                                               : ShowHelp("SearchForm")
          Case #KeyboardShortcut_ExitSearch,          #KeyboardShortcut_EscapeSearch                                                      : CloseMyWindow(#Window_Search)

          ;----------------------------------------------------------------------------------------
          ; Owner list form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SaveOwnerlist                                                                                            : CloseMyWindow(#Window_OwnerList)
          Case #KeyboardShortcut_AddOwnerlist                                                                                             : AddOwner()
          Case #KeyboardShortcut_DeleteOwnerlist                                                                                          : DeleteOwner()
          Case #KeyboardShortcut_EditOwnerlist                                                                                            : EditOwner()
          Case #KeyboardShortcut_SyncOwnerlist                                                                                            : SyncOwnerlist()               
          Case #KeyboardShortcut_HelpOwnerlist                                                                                            : ShowHelp("OwnerListForm")
          Case #KeyboardShortcut_ExitOwnerlist,       #KeyboardShortcut_EscapeOwnerList                                                   : CloseMyWindow(#Window_OwnerList)
            
          ;----------------------------------------------------------------------------------------
          ; Owner editor form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_SaveOwner                                                                                                : SaveOwner()
          Case #KeyboardShortcut_HelpOwner                                                                                                : ShowHelp("OwnerForm")
          Case #KeyboardShortcut_ExitOwner,           #KeyboardShortcut_EscapeOwner                                                       : CloseMyWindow(#Window_Owner)

          ;----------------------------------------------------------------------------------------
          ; Print items form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_NowPrint                                                                                                 : ForceHtmPrint()
          Case #KeyboardShortcut_NowPreview                                                                                               : ForceHtmPreview()
          Case #KeyboardShortcut_ExitPrint,           #KeyboardShortcut_EscapePrint                                                       : CloseMyWindow(#Window_Print)
            
          ;----------------------------------------------------------------------------------------
          ; About program form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_EscapeAbout                                                                                              : CloseMyWindow(#Window_About)
            
          ;----------------------------------------------------------------------------------------
          ; Help display and edit form
          ;----------------------------------------------------------------------------------------
  
          Case #KeyboardShortcut_LoadHelp                                                                                                 : LoadHelp()
          Case #KeyboardShortcut_SaveHelp                                                                                                 : SaveHelp()
          Case #KeyboardShortcut_SearchHelp,          #KeyboardShortcut_SearchOnEnter                                                     : SearchHelp()
          Case #KeyboardShortcut_PrintHelp                                                                                                : PrintHelp()
          Case #KeyboardShortcut_EditHelp                                                                                                 : EditHelp()
          Case #KeyboardShortcut_ExitHelp,            #KeyboardShortcut_EscapeHelp                                                        : CloseMyWindow(#Window_Help)
            
          ;----------------------------------------------------------------------------------------
          ; Keyboard shortcut form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_EscapeShortcuts                                                                                          : CloseMyWindow(#Window_Shortcuts)  

          ;----------------------------------------------------------------------------------------
          ; Scan Document shortcuts form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_NextScan                                                                                                 : ScanNextDocumentPage()
          Case #KeyboardShortcut_FinishScan                                                                                               : SaveScannedDocumentPages()
          Case #KeyboardShortcut_HelpScan                                                                                                 : ShowHelp("ScanForm")
          Case #KeyboardShortcut_CancelScan                                                                                               : CloseMyWindow(#Window_Scan)
            
          ;----------------------------------------------------------------------------------------
          ; Error log shortcuts form
          ;----------------------------------------------------------------------------------------
            
          Case #KeyboardShortcut_ExitErrorlog                                                                                             : CloseMyWindow(#Window_Errorlog)
          Case #KeyboardShortcut_EscapeErrorlog                                                                                           : CloseMyWindow(#Window_Errorlog)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
            
          Case #PopMenubar_Details_CopyItem                                                                                               : CopyDataToClipboard()
          Case #PopMenuBar_Details_EditItem                                                                                               : EditOldData()
          Case #PopMenuBar_Details_PrintItem                                                                                              : PrintThisData()

        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; All form control events
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_Gadget
        
        Select GadgetID
            
          ;----------------------------------------------------------------------------------------
          ; Category list controls
          ;----------------------------------------------------------------------------------------
            
          Case #Gadget_MyInfo_Category
            Select EventType()
              Case #PB_EventType_LeftDoubleClick                                                                                          : EditCategory()
              Case #PB_EventType_RightClick                                                                                               : DisplayPopupMenu(#PopMenuBar_Category, WindowID(#Window_MyInfo))
              Case #PB_EventType_Change                                                                                                   : ShowCategory()
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Category form editor controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Category_Category                                                                                                  : MixedStringCase(#Gadget_Category_Category)
            
          Case #Gadget_Category_SaveCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Category_SaveCategory, "Hovered")                  : StatusBarButtonTip(#Window_Category, "SaveCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Category_SaveCategory, "Pressed")                  : SaveCategory()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Category_SaveCategory, "Normal")
            EndSelect
            
          Case #Gadget_Category_HelpCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Category_HelpCategory, "Hovered")                  : StatusBarButtonTip(#Window_Category, "HelpCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Category_HelpCategory, "Pressed")                  : ShowHelp("CategoryForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Category_HelpCategory, "Normal")
            EndSelect
            
          Case #Gadget_Category_ExitCategory
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Category_ExitCategory, "Hovered")                  : StatusBarButtonTip(#Window_Category, "ExitCategory")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Category_ExitCategory, "Pressed")                  : CloseMyWindow(#Window_Category)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Category_ExitCategory, "Normal")
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Title list controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_MyInfo_Titles
            Select EventType()
              Case #PB_EventType_LeftDoubleClick                                                                                          : EditOldData()
              Case #PB_EventType_RightClick                                                                                               : DisplayPopupMenu(#PopMenuBar_MyInfo, WindowID(#Window_MyInfo))
              Case #PB_EventType_Change                                                                                                   : ShowMyInfoData()
              Case #PB_EventType_DragStart                                                                                                : DragToCategory()
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Main form controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_MyInfo_Add
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Add, "Hovered")                             : StatusBarButtonTip(#Window_MyInfo, "AddItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Add, "Pressed")                             : AddNewData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Add, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Archive
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Archive, "Hovered")                         : StatusBarButtonTip(#Window_MyInfo, "ArchiveItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Archive, "Pressed")                         : ArchiveThisData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Archive, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Attach
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Attach, "Hovered")                          : StatusBarButtonTip(#Window_MyInfo, "AttachItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Attach, "Pressed")                          : AttachItemToData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Attach, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Copy
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Copy, "Hovered")                            : StatusBarButtonTip(#Window_MyInfo, "CopyItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Copy, "Pressed")                            : CopyDataToClipboard()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Copy, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Delete
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Delete, "Hovered")                          : StatusBarButtonTip(#Window_MyInfo, "DeleteItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Delete, "Pressed")                          : DeleteCurrentData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Delete, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Edit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Edit, "Hovered")                            : StatusBarButtonTip(#Window_MyInfo, "EditItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Edit, "Pressed")                            : EditOldData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Edit, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Export
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Export, "Hovered")                          : StatusBarButtonTip(#Window_MyInfo, "ExportItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Export, "Pressed")                          : ExportItemToDisk()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Export, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Favourite
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Favourite, "Hovered")                       : StatusBarButtonTip(#Window_MyInfo, "FavouriteItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Favourite, "Pressed")                       : MarkAsFavourite()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Favourite, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Import
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Import, "Hovered")                          : StatusBarButtonTip(#Window_MyInfo, "ImportItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Import, "Pressed")                          : ImportItemFromDisk()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Import, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Kill
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Kill, "Hovered")                            : StatusBarButtonTip(#Window_MyInfo, "KillItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Kill, "Pressed")                            : KillCurrentData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Kill, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Lock
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Lock, "Hovered")                            : StatusBarButtonTip(#Window_MyInfo, "LockItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Lock, "Pressed")                            : LockCurrentData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Lock, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Print
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Print, "Hovered")                           : StatusBarButtonTip(#Window_MyInfo, "PrintItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Print, "Pressed")                           : PrintThisData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Print, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Search
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Search, "Hovered")                          : StatusBarButtonTip(#Window_MyInfo, "SearchItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Search, "Pressed")                          : AdvancedSearch()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Search, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Help
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Help, "Hovered")                            : StatusBarButtonTip(#Window_MyInfo, "HelpItem")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Help, "Pressed")                            : ShowHelp("MainForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Help, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_Exit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Exit, "Hovered")                            : StatusBarButtonTip(#Window_MyInfo, "ExitProgram")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_MyInfo_Exit, "Pressed")                            : Program\QuitValue.i = #True
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_MyInfo_Exit, "Normal")
            EndSelect
            
          Case #Gadget_MyInfo_SearchLimit
            Select EventType()
              Case #PB_EventType_Change                                                                                                   : Program\SearchLimit = GetGadgetText(#Gadget_MyInfo_SearchLimit)
            EndSelect
            
          Case #Gadget_MyInfo_Searchstring
            If GetGadgetText(#Gadget_MyInfo_Searchstring) = #Empty$
              SetGadgetFont(#Gadget_MyInfo_Searchstring, FontID(Cue\SearchCueFont))
            Else
              SetGadgetFont(#Gadget_MyInfo_Searchstring, FontID(Cue\SearchNormalFont))
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; Data form controls
            ;--------------------------------------------------------------------------------------
          
          Case #Gadget_Data_Title                                                                                                         : StringFirstUpper(#Gadget_Data_Title)
          
          Case #Gadget_Data_Owner
            Select EventType()
              Case #PB_EventType_Change                                                                                                   : MixedComboCaseEx(#Gadget_Data_Owner)
            EndSelect
            
          Case #Gadget_Data_Details
            Select EventType()
              Case #PB_EventType_Change                                                                                                   : ; GetEditorDetails()
            EndSelect
            
          Case #Gadget_Data_SaveData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_SaveData, "Hovered")                          : StatusBarButtonTip(#Window_Data, "SaveData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_SaveData, "Pressed")                          : SaveThisData()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_SaveData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_ExportData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_ExportData, "Hovered")                        : StatusBarButtonTip(#Window_Data, "ExportData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_ExportData, "Pressed")                        : Editor_Save(#Gadget_Data_Details, #Empty$)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_ExportData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_ImportData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_ImportData, "Hovered")                        : StatusBarButtonTip(#Window_Data, "ImportData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_ImportData, "Pressed")                        : Editor_Load(#Gadget_Data_Details, #Empty$)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_ImportData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_SearchData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_SearchData, "Hovered")                        : StatusBarButtonTip(#Window_Data, "SearchData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_SearchData, "Pressed")                        : SearchDataForm()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_SearchData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_HelpData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_HelpData, "Hovered")                          : StatusBarButtonTip(#Window_Data, "HelpData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_HelpData, "Pressed")                          : ShowHelp("DataForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_HelpData, "Normal")   
            EndSelect
            
          Case #Gadget_Data_ExitData
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Data_ExitData, "Hovered")                          : StatusBarButtonTip(#Window_Data, "ExitData")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Data_ExitData, "Pressed")                          : CloseMyWindow(#Window_Data)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Data_ExitData, "Normal")   
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Find data on data form controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Find_Finddata
            If GetGadgetText(#Gadget_Find_Finddata) = #Empty$
              SetGadgetFont(#Gadget_Find_Finddata, FontID(Cue\SearchCueFont))
            Else
              SetGadgetFont(#Gadget_Find_Finddata, FontID(Cue\SearchNormalFont))
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; Advanced search form controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Search_RunSearch
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Search_RunSearch, "Hovered")                       : StatusBarButtonTip(#Window_Data, "RunSearch")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Search_RunSearch, "Pressed")                       : AdvancedSearchNow()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Search_RunSearch, "Normal")   
            EndSelect
            
          Case #Gadget_Search_HelpSearch
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Search_HelpSearch, "Hovered")                      : StatusBarButtonTip(#Window_Data, "HelpSearch")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Search_HelpSearch, "Pressed")                      : ShowHelp("SearchForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Search_HelpSearch, "Normal")   
            EndSelect
            
          Case #Gadget_Search_ExitSearch
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Search_ExitSearch, "Hovered")                      : StatusBarButtonTip(#Window_Data, "ExitSearch")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Search_ExitSearch, "Pressed")                      : CloseMyWindow(#Window_Search)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Search_ExitSearch, "Normal")   
            EndSelect
            
          Case #Gadget_Search_SearchText
            If GetGadgetText(#Gadget_Search_SearchText) = #Empty$
              SetGadgetFont(#Gadget_Search_SearchText, FontID(Cue\SearchCueFont))
            Else
              SetGadgetFont(#Gadget_Search_SearchText, FontID(Cue\SearchNormalFont))
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; OwnerList controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_OwnerList_Owners
            Select EventType()
              Case #PB_EventType_LeftDoubleClick                                                                                          : EditOwner()
              Case #PB_EventType_RightDoubleClick                                                                                         : AddOwner()
            EndSelect
            
          Case #Gadget_OwnerList_SaveOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_SaveOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "SaveOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_SaveOwnerlist, "Pressed")                : ; SaveOwnerlist()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_SaveOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_AddOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_AddOwnerlist, "Hovered")                 : StatusBarButtonTip(#Window_OwnerList, "AddOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_AddOwnerlist, "Pressed")                 : AddOwner()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_AddOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_DeleteOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_DeleteOwnerlist, "Hovered")              : StatusBarButtonTip(#Window_OwnerList, "DeleteOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_DeleteOwnerlist, "Pressed")              : DeleteOwner()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_DeleteOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_EditOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_EditOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "EditOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_EditOwnerlist, "Pressed")                : EditOwner()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_EditOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_SyncOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_SyncOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "SyncOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_SyncOwnerlist, "Pressed")                : SyncOwnerlist()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_SyncOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_HelpOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_HelpOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "HelpOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_HelpOwnerlist, "Pressed")                : ShowHelp("OwnerListForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_HelpOwnerlist, "Normal")
            EndSelect
            
          Case #Gadget_OwnerList_ExitOwnerlist
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_ExitOwnerlist, "Hovered")                : StatusBarButtonTip(#Window_OwnerList, "ExitOwnerlist")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_OwnerList_ExitOwnerlist, "Pressed")                : CloseMyWindow(#Window_OwnerList)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_OwnerList_ExitOwnerlist, "Normal")
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Owner editor controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Owner_OwnerName                : MixedStringCase(#Gadget_Owner_OwnerName)
            
          Case #Gadget_Owner_SaveOwner
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Owner_SaveOwner, "Hovered")                        : StatusBarButtonTip(#Window_OwnerList, "SaveOwner")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Owner_SaveOwner, "Pressed")                        : SaveOwner()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Owner_SaveOwner, "Normal")
            EndSelect
          Case #Gadget_Owner_HelpOwner
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Owner_HelpOwner, "Hovered")                        : StatusBarButtonTip(#Window_OwnerList, "HelpOwner")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Owner_HelpOwner, "Pressed")                        : ShowHelp("OwnerForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Owner_HelpOwner, "Normal")
            EndSelect
          Case #Gadget_Owner_ExitOwner
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Owner_ExitOwner, "Hovered")                        : StatusBarButtonTip(#Window_OwnerList, "ExitOwner")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Owner_ExitOwner, "Pressed")                        : CloseMyWindow(#Window_Owner)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Owner_ExitOwner, "Normal")
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; Help form controls
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Help_LoadHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_LoadHelp, "Hovered")                          : StatusBarButtonTip(#Window_Help, "LoadHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_LoadHelp, "Pressed")                          : LoadHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_LoadHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_SaveHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_SaveHelp, "Hovered")                          : StatusBarButtonTip(#Window_Help, "SaveHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_SaveHelp, "Pressed")                          : SaveHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_SaveHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_SearchHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_SearchHelp, "Hovered")                        : StatusBarButtonTip(#Window_Help, "SearchHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_SearchHelp, "Pressed")                        : SearchHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_SearchHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_PrintHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_PrintHelp, "Hovered")                         : StatusBarButtonTip(#Window_Help, "PrintHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_PrintHelp, "Pressed")                         : PrintHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_PrintHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_EditHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_EditHelp, "Hovered")                          : StatusBarButtonTip(#Window_Help, "EditHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_EditHelp, "Pressed")                          : EditHelp()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_EditHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_ExitHelp
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Help_ExitHelp, "Hovered")                          : StatusBarButtonTip(#Window_Help, "ExitHelp")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Help_ExitHelp, "Pressed")                          : CloseMyWindow(#Window_Help)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Help_ExitHelp, "Normal")
            EndSelect
            
          Case #Gadget_Help_FindHelp
            If GetGadgetText(#Gadget_Help_FindHelp) = #Empty$
              SetGadgetFont(#Gadget_Help_FindHelp, FontID(Cue\SearchCueFont))
            Else
              SetGadgetFont(#Gadget_Help_FindHelp, FontID(Cue\SearchNormalFont))
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Print_PrintNow
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintNow, "Hovered")                         : StatusBarButtonTip(#Window_print, "NowPrint")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Print_PrintNow, "Pressed")                         : ForceHtmPrint()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintNow, "Normal")
            EndSelect
            
          Case #Gadget_Print_PrintPreview
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintPreview, "Hovered")                     : StatusBarButtonTip(#Window_print, "NowPreview")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Print_PrintPreview, "Pressed")                     : ForceHtmPreview()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintPreview, "Normal")
            EndSelect
            
          Case #Gadget_Print_PrintExit
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintExit, "Hovered")                        : StatusBarButtonTip(#Window_print, "ExitPrint")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Print_PrintExit, "Pressed")                        : CloseMyWindow(#Window_Print)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Print_PrintExit, "Normal")
            EndSelect

            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Case #Gadget_Scan_NextScan
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Scan_NextScan, "Hovered")                          : StatusBarButtonTip(#Window_scan, "NextScan")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Scan_NextScan, "Pressed")                          : ScanNextDocumentPage()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Scan_NextScan, "Normal")
            EndSelect
            
          Case #Gadget_Scan_FinishScan
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Scan_FinishScan, "Hovered")                        : StatusBarButtonTip(#Window_scan, "FinishScan")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Scan_FinishScan, "Pressed")                        : SaveScannedDocumentPages()
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Scan_FinishScan, "Normal")
            EndSelect
            
          Case #Gadget_Scan_HelpScan
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Scan_HelpScan, "Hovered")                          : StatusBarButtonTip(#Window_scan, "HelpScan")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Scan_HelpScan, "Pressed")                          : ShowHelp("ScanForm")
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Scan_HelpScan, "Normal")
            EndSelect
            
          Case #Gadget_Scan_CancelScan
            Select EventType()
              Case #HoverEvent_EnterGadget            : SetHoverIcons(GadgetID, #Image_Scan_CancelScan, "Hovered")                        : StatusBarButtonTip(#Window_print, "ExitScan")
              Case #PB_EventType_LeftClick            : SetHoverIcons(GadgetID, #Image_Scan_CancelScan, "Pressed")                        : CloseMyWindow(#Window_Scan)
              Case #HoverEvent_LeaveGadget            : SetHoverIcons(GadgetID, #Image_Scan_CancelScan, "Normal")
            EndSelect
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
        EndSelect
        
        ;------------------------------------------------------------------------------------------
        ; Unhide the program window when the user clicks the icon in the tray
        ;------------------------------------------------------------------------------------------
        
      Case #PB_Event_SysTray                                                                                                              : ShowProgramWindow()
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
    EndSelect
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Until Program\QuitValue.i
  
  ;------------------------------------------------------------------------------------------------
  ; Save the program startup preferences
  ;------------------------------------------------------------------------------------------------
  
  UpdateString.s                + 
  "UPDATE Preferences SET "     + 
  "SearchLimit = '"             + 
  Program\SearchLimit           + 
  "', "                         + 
  "LastSearch = '"              + 
  RepQuote(Program\LastSearch)  + 
  "' "                          + 
  "WHERE Recordid = 1"
  
  If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) = #DatabaseUpdateFail
    MessageRequester("Options Save Error", "Could not save the updated options into the database. " + DatabaseError(), #PB_MessageRequester_Ok)
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Force the error log to be flushed to disk
  ;------------------------------------------------------------------------------------------------
  
  WriteErrorLog(ModuleName.s, MessageContent.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CloseWindow(#Window_MyInfo)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndIf

;--------------------------------------------------------------------------------------------------
; 
;--------------------------------------------------------------------------------------------------

End

; For a combobox in the data form add these constants to get the ownerdrawn fonts to show..
; , #CBS_OWNERDRAWFIXED | #CBS_HASSTRINGS)
; Or use FluidByte's own gadget creation routine
; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 517
; FirstLine = 497
; EnableAsm
; EnableThread
; EnableXP
; DPIAware
; EnableOnError
; UseIcon = Images\_16x16\Keeper.ico
; Executable = MyInfo3.exe
; CommandLine = /Register Miki Bolvary
; CompileSourceDirectory
; EnableCompileCount = 766
; EnableBuildCount = 8
; EnableExeConstant