;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Extended balloon tooltip with images support by using the O/S's theming engine
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Import "Uxtheme.lib"                                                                                   ; 
  SetWindowTheme(Window.i, Body.p-unicode, Title.p-unicode)                                             ; 
EndImport                                                                                              ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Need a unicode aware version of the API directory creator for database directory, temporary directory and maybe others
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Import "shell32.lib"                                                                                   ; Import 32 bit shell library
  SHCreateDirectory(*hwnd, pszPath.p-unicode)                                                           ; Grab the function that you want
EndImport                                                                                              ; End function import

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Use the SQLite database environment for data
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

UseSQLiteDatabase()                                                                                     ; Tell compiler we are using SQLite support

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Use SHA3 file fingerprinting for unique attachments
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

UseSHA3Fingerprint()                                                                                    ; Use SHA3 for document comparison fingerprinting

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Use the MD5 fingerprint for password security
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

UseMD5Fingerprint()                                                                                     ; Use MD5 fingerprinting for password security

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Find out if there is a working desktop environment
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

ExamineDesktops()                                                                                       ; Will be used for toolbar hiding later

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Setup any picture decoders for any graphics used
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

UseJPEG2000ImageDecoder()                                                                               ; PureBasic native image decoder
UseJPEGImageDecoder()                                                                                   ; PureBasic native image decoder
UseTGAImageDecoder()                                                                                    ; PureBasic native image decoder
UseTIFFImageDecoder()                                                                                   ; PureBasic native image decoder
UsePNGImageDecoder()                                                                                    ; PureBasic native image decoder

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Various gadget column definitions
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#OwnerTitleColumn               = 0                                                                     ; 
#OwnerIconColumn                = 1                                                                     ; 
#OwnerItemsColumn               = 2                                                                     ; 
#OwnerRecordColumn              = 3                                                                     ; 

#CategoryTitleColumn            = 0                                                                     ; 
#CategoryItemsColumn            = 1                                                                     ; 
#CategoryIconColumn             = 2                                                                     ; 
#CategoryRecordColumn           = 3                                                                     ; 

#TitleColumn                    = 0
;#InformationColumn              = ?                                                                    ; 
#CategoryColumn                 = 1                                                                     ; 
#ArchivedColumn                 = 2                                                                     ; 
#FavouriteColumn                = 3                                                                     ; 
#LockedColumn                   = 4                                                                     ; 
#DeletedColumn                  = 5                                                                     ; 
#UpdatedColumn                  = 6                                                                     ; 
#OwnerColumn                    = 7                                                                     ; 
#AttachmentsColumn              = 8                                                                     ; 
#RecordColumn                   = 9                                                                     ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Program constants that don't need to change. Wordier to allow easier error tracking
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#ListIconHeadingArea            = -1                                                                    ; 

#AtTheEndOfTheList              = -1                                                                    ; 
#AtTheListHeading               = -1                                                                    ; 

#NoErrorLogEntries              =  0                                                                    ; 

#NoFontLoaded                   =  0                                                                    ; 

#NoItems                        =  0                                                                    ; 
#FirstItem                      =  0                                                                    ; 

#NoWindowId                     =  0                                                                    ; 

#NothingFound                   =  0                                                                    ; 
#NothingSelected                = -1                                                                    ; 

#NoDataFound                    =  0                                                                    ; 
#NoBlobFound                    =  0                                                                    ; 
#NoPictureHandle                =  0                                                                    ; 
#NoPictureFound                 = -1                                                                    ; 
#NoDocumentFound                = -1                                                                    ; 
#NoPictureLoaded                =  0                                                                    ; 
#NoPictureResized               =  0                                                                    ; 

#NoColumnIcon                   =  0                                                                    ; 
#NoData                         =  0                                                                    ; 
#NoCurrentLine                  = -1                                                                    ; Make sure no line can be selected accidentally
#NoRecordNumber                 = #Empty$                                                               ; 

#NoCurrentShortcut              =  0                                                                    ; 

#DatabaseNotOpen                =  0                                                                    ; 
#DatabaseQueryFail              =  0                                                                    ; 
#DatabaseUpdateFail             =  0                                                                    ; 
#DatabaseQueryEmpty             =  0                                                                    ; 

#NoDatabaseRow                  =  0                                                                    ; 

#DateNotActive                  =  0                                                                    ; 

#NoFileHandle                   =  0                                                                    ; 
#NotEndOfFile                   =  0                                                                    ; 
#FileIsEmpty                    =  0                                                                    ; 
#FileNotDecompressed            = -1                                                                    ; 
#NoFileDeleted                  =  0                                                                    ; 

#FileDoesNotExist               = -1                                                                    ; 
#FileIsDirectory                = -2                                                                    ; 
#FileNotCopied                  =  0                                                                    ; 

#DirectoryNotCreated            =  0                                                                    ; 

#NoPrintFileHandle              =  0                                                                    ; 
#NoImportFileHandle             =  0                                                                    ; 
#NoExportFileHandle             =  0                                                                    ; 

#NoMenuCreated                  =  0                                                                    ; 

#NoStringFound                  =  0                                                                    ; 

#NoThreadRunning                =  0                                                                    ; 

#Fish                           = "<°)))o><²³  "                                                        ; Beware the fish!!

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Display fonts and effects for the master listincongadget
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#FontStrikeoutYes               = 0                                                                     ; 
#FontStrikeoutNo                = 1                                                                     ; 

#FontUnderlineYes               = 0                                                                     ; 
#FontUnderlineNo                = 1                                                                     ; 

#FontBoldYes                    = 0                                                                     ; 
#FontBoldNo                     = 1                                                                     ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; My personal constants for author, copyright etc
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

#Author                         = "Miklos G Bolvary, "                                                    ; Author's name
#CopyRight                      = "MGB Technical Services 2018 "                                        ; Copyright holder
#Basename                       = "MyInfo "                                                             ; Base name for initialisation file and database
#Version                        = "v3.00."                                                              ; Program version
#Program                        = #Basename + #Version                                                  ; Copyright string
#SystrayNote                    = "Hello, " + #Program + " is hiding here"                              ; System tray note

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; All program flags and variables
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure ProgramData
  QuitValue.i                                                                                           ; Program quit status flag
  
  FirstTime.i                                                                                           ; Program first start
  WindowMutex.i                                                                                         ; Single window flag
  LastWindow.s                                                                                          ; The last window opened
  LastChildWindow.s                                                                                     ; The last child window opened
  
  ; Program password security etc
  
  TrayState.i                                                                                           ; Hidden to the tray or not
  
  LockState.i                                                                                           ; Is the program locked or not
  MD5FingerPrint.s                                                                                      ; The generated MD5 fingerprint of the password
  
  NewPassword.s                                                                                         ; Keep track of new password
  OldPassword.s                                                                                         ; Old comparison password
  
  ; Constants for printing fonts
  
  PageHeading.i                                                                                         ; Main page headings
  ListHeading.i                                                                                         ; List item headings
  
  ; Last string search performed
  
  LastSearch.s                                                                                          ; Last search string used
  SearchLimit.s                                                                                         ; Limit the amount of returned records
  
  CurrentLine.i                                                                                         ; The currently selected line
  ReFocusLine.i                                                                                         ; The line in the list to reselect
  CurrentRecord.s                                                                                       ; The current record number selected
  CurrentTitle.s                                                                                        ; The current title highlighted
  CurrentCategory.s                                                                                     ; The current category highlighted
  
  ; Balloon tooltip parameters
  
  BalloonFontId.i                                                                                       ; Balloon tooltip font
  BalloonWindowId.i                                                                                     ; Current balloon window
  
  ; Formwide font changes
  
  ChangeFont.s                                                                                          ; Persistent font chosen by the user
  
  ; Semaphores for dealing with underline etc
  
  Locked.i                                                                                              ; Record lock state
  Deleted.i                                                                                             ; Record deleted state
  Favourite.i                                                                                           ; Record favourite state
  
  ; Various program directories
  
  CurrentDrive.s                                                                                        ; Currentworking drive
  CurrentDirectory.s                                                                                    ; Current working directory
  
  ConfigDirectory.s                                                                                     ; Configuration files
  BackupDirectory.s                                                                                     ; Set system files backup directory
  DatabaseDirectory.s                                                                                   ; Local database directory
  DocumentDirectory.s                                                                                   ; The local Documents directory
  HelpDirectory.s                                                                                       ; The local help files directory
  PictureDirectory.s                                                                                    ; The local pictures directory
  TemporaryDirectory.s                                                                                  ; Temporary files directory
  
  ; Database name and handle
  
  DatabaseName.s                                                                                        ; The full path and name of the database
  DatabaseHandle.i                                                                                      ; The database handle from the file system
  
  ; Various program icons
  
  CategoryIcons.s                                                                                       ; User choice category icons
  LocationIcons.s                                                                                       ; User choice location icons
  OwnerIcons.s                                                                                          ; User choice owner icons
  
  ; Date specific
  
  CurrentDate.s                                                                                         ; Current local working data
  
  ; Compiler and build counts
  
  CompileCounters.s                                                                                     ; Current program build number
  
  ; Web print file specifics
  
  WebPrintFile.s                                                                                        ; Path and name of the web template file
  WebTemplate.s                                                                                         ; Name and directory of the web template print file
  WebFileId.i                                                                                           ; File id of the web template print file
  PrintIt.i                                                                                             ; Print job ready state
  
  ; Error file directives
  
  ErrorFile.s                                                                                           ; Program error log file
  ErrorHeader.i                                                                                         ; Has the error header been written yet?
  ErrorLogExists.i                                                                                      ; Has the error log been created this program run?
  
  ; Colouring of unsupported objects
  
  StaticBack.i                                                                                          ; CheckBox, Optiongadget background colours with callback
  
  AlternateRow.i                                                                                        ; Used to toggle alternate row colouring
  
  ; Help file display and editing
  
  CurrentHelpFileEditMode.i                                                                             ; Are we in edito or read only mode in the help screen
  CurrentHelpFileName.s                                                                                 ; What is the full path and name of the current help file
EndStructure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Make the program data structure global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Program.ProgramData                                                                              ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; First run startup flags
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\FirstTime           = #False                                                                    ; First run of this program
Program\QuitValue           = #False                                                                    ; No exit at start

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; All program directories
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\CurrentDirectory    = GetCurrentDirectory()                                                     ; Get current active directory
Program\CurrentDrive        = Left(Program\CurrentDirectory, 3)                                         ; Get the drive letter

Program\BackupDirectory     = Program\CurrentDirectory  + "Store\Backup\"                               ; Set system files backup directory
Program\ConfigDirectory     = Program\CurrentDirectory  + "Store\Config\"                               ; Configuration files
Program\DatabaseDirectory   = Program\CurrentDirectory  + "Store\Database\"                             ; Set working database directory
Program\DocumentDirectory   = Program\CurrentDirectory  + "Store\Documents\"                            ; Set working Document directory
Program\HelpDirectory       = Program\CurrentDirectory  + "Store\Helpfiles\"                            ; Set working help files directory
Program\PictureDirectory    = Program\CurrentDirectory  + "Store\Pictures\"                             ; Set working pictures directory
Program\TemporaryDirectory  = Program\CurrentDirectory  + "Store\Temporary\"                            ; Temporary data, export and more

Program\CategoryIcons       = Program\CurrentDirectory  + "Store\Icons\Category\"                       ; User choice category icons
Program\LocationIcons       = Program\CurrentDirectory  + "Store\Icons\Location\"                       ; User choice location icons
Program\OwnerIcons          = Program\CurrentDirectory  + "Store\Icons\Owner\"                          ; User choice owner icons

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

MakeSureDirectoryPathExists(Program\BackupDirectory)                                                    ; Create the system files backup directory
MakeSureDirectoryPathExists(Program\ConfigDirectory)                                                    ; Configuration files
MakeSureDirectoryPathExists(Program\DatabaseDirectory)                                                  ; Create the program's working directories if you can 
MakeSureDirectoryPathExists(Program\DocumentDirectory)                                                  ; Create working Document directory
MakeSureDirectoryPathExists(Program\HelpDirectory)                                                      ; Create the program's help files directory if you can 
MakeSureDirectoryPathExists(Program\TemporaryDirectory)                                                 ; Create application local temporary directory

MakeSureDirectoryPathExists(Program\CategoryIcons)                                                      ; User choice category icons
MakeSureDirectoryPathExists(Program\LocationIcons)                                                      ; User choice location icons
MakeSureDirectoryPathExists(Program\OwnerIcons)                                                         ; User choice owner icons

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\ErrorFile                = Program\TemporaryDirectory + Trim(#Basename) + "_Error.Log"            
Program\ErrorHeader              = #False                                                               ; Error file handle to start with

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\DatabaseName             = Program\DatabaseDirectory + Trim(#Basename) +  ".sqlite"             ; Default program database name

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\CompileCounters          = Str(#PB_Editor_CompileCount) + "." + Str(#PB_Editor_BuildCount) + "b"; Add to program version

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; The web print template for record printing
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\WebPrintFile        = Program\TemporaryDirectory + #Basename + ".Htm"                           ; Print file that gets loaded as a template
Program\WebTemplate         = "file://"       + Program\WebPrintFile                                    ; Web template for printing functions

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Setup the current systemd ata variable
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\CurrentDate         = FormatDate("%dd/%mm/%yyyy", Date())                                       ; Get the current system date without the time component

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Error file headers, name and directory
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\ErrorFile           = Program\TemporaryDirectory + #Basename + #Version + "_Error.Log"          ; Program error log file
Program\ErrorHeader         = #False                                                                    ; Error file handle to start with

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Colour any controls that PureBasic doesn't handle by itself
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\StaticBack          = CreateSolidBrush_($BFBFBF)                                                ; Static controls background colours

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure SearchData                                                                                   ; 
  SearchWindowType.i                                                                                    ; Search window last SQL Search type
  SearchWindowField.i                                                                                   ; Search window last SQL Search field
  SearchWindowText.s                                                                                    ; Last Search window Search string used  
  SearchWindowSortField.i                                                                               ; Which field do we sort on
  SearchWindowSortDirection.i                                                                           ; What sort direction to take?
  SearchWindowQueryReturnLimit.i                                                                        ; How many records to return in a Search query
  SearchWindowQueryReturnSize.i                                                                         ; The size of the Search query allowed
  SearchWindowCloseMode.i                                                                               ; Search window close after return
  SearchWindowMode.i                                                                                    ; AND or OR Search mode
EndStructure                                                                                           ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Search.SearchData

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Various program toggles, not absolutes
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure ToggleData                                                                                   ; 
  BalloonTooltips.i                                                                                     ; Colourful balloon tooltips
  BalloonColour.i                                                                                       ; Random ballon colours each time a procedure is launched
  ColourBand.i                                                                                          ; Alternate row colouring toggle
  HideDetail.i                                                                                          ; Hide detail pain with asterisks
  MessageSave.i                                                                                         ; Hide or show messages after saving
  ShowToolbar.i                                                                                         ; Show or hide the main toolbar
  ScreenSnap.i                                                                                          ; Snap form window to screen borders
  StickyWindow.i                                                                                        ; Stick form window on top of all others
  TitleClock.i                                                                                          ; Show a real time clock on the form titlebar
 EndStructure                                                                                          ; 
  
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Make the toggle data structure global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Toggle.ToggleData                                                                                ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Messages that need to persist between gadgets. Not properly utilised as yet
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure QueueData                                                                                    ; 
  ItemsFound.i                                                                                          ; 
  CurrentCategory.s                                                                                     ; 
  CategoryItems.s                                                                                       ; 
EndStructure                                                                                          ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Make the queue structure global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Queue.QueueData                                                                                  ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Dearch cue prompt in text boxes
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure CueData
  SearchCueFont.i                                                                                       ; Searchbox cue font
  SearchNormalFont.i                                                                                    ; Searchbox normal font
  SearchCueText.s                                                                                       ; Search box prompt text
EndStructure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Search cue data structure made global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Cue.CueData                                                                                     ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Setup the search box cue fonts 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Cue\SearchCueFont       = LoadFont(#PB_Any,   "Georgia",       12, #PB_Font_Italic)                     ; Empty search cue font
Cue\SearchNormalFont    = LoadFont(#PB_Any,   "Comic Sans MS", 12, 0)                                   ; Filled cue box font
Cue\SearchCueText       = Space(256)                                                                    ; Set the cue text buffer

PokeS(@Cue\SearchCueText, "Search for what?..", -1, #PB_Unicode)                                        ; Fill the buffer with the cue text

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Tooltip structure data
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure ToolTipData                                                                                  ; If any tooltips setup, keep track of gadgets that have them so you can remove them if needed
  pbWindowNumber.i                                                                                      ; 
  pbHandleTip.i                                                                                         ; 
  pbGadgetID.i                                                                                          ; 
  pbGadgetNumber.i                                                                                      ; 
  pbIconHandle.i                                                                                        ; 
EndStructure                                                                                           ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Balloon structure members
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Balloon.TOOLINFO                                                                                 ; Balloon tooltips

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Tooltip structure data global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global NewList ToolTips.ToolTipData()                                                                 ; All tool tip handles and data here

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; The font to be used in the balloon tooltips
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\BalloonFontId       = LoadFont(#PB_Any, "Comic Sans MS", 10, #PB_Font_HighQuality | #PB_Font_Italic)

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Button glow effects Structure
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure GlowData                                                                                     ; 
  GlowColour.l                                                                                          ; 
  GlowRadius.i                                                                                          ; 
  ExtendCanvas.i                                                                                        ; 
EndStructure                                                                                           ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Glowing outline structure made global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Glow.GlowData                                                                                    ; Icon border glow effects

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Toolbar button glowing outline parameters at random 
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Dim GlowColours(13)                                                                              ; 

GlowColours(0)  = $0000FF                                                                               ; 
GlowColours(1)  = $00FF00                                                                               ; 
GlowColours(2)  = $00FFFF                                                                               ; 
GlowColours(3)  = $FF0000                                                                               ; 
GlowColours(4)  = $FF00FF                                                                               ; 
GlowColours(5)  = $FFFF00                                                                               ; 
GlowColours(6)  = $000080                                                                               ; 
GlowColours(7)  = $008000                                                                               ; 
GlowColours(8)  = $800000                                                                               ; 
GlowColours(9)  = $800080                                                                               ; 
GlowColours(10) = $808000                                                                               ; 
GlowColours(11) = $000000                                                                               ; 
GlowColours(12) = $FFFFFF                                                                               ; 

Glow\GlowColour   =  Random(GlowColours())                                                              ; 
Glow\GlowRadius   = 5                                                                                   ; 
Glow\ExtendCanvas = #False                                                                              ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Background colours for the balloon tooltips
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Dim BalloonBackground(14)

BalloonBackground(0)  = $0000FF                                                                               ; 
BalloonBackground(1)  = $00FF00                                                                               ; 
BalloonBackground(2)  = $00FFFF                                                                               ; 
BalloonBackground(3)  = $FF0000                                                                               ; 
BalloonBackground(4)  = $FF00FF                                                                               ; 
BalloonBackground(5)  = $FFFF00                                                                               ; 
BalloonBackground(6)  = $000080                                                                               ; 
BalloonBackground(7)  = $008000                                                                               ; 
BalloonBackground(8)  = $800000                                                                               ; 
BalloonBackground(9)  = $800080                                                                               ; 
BalloonBackground(10) = $808000                                                                               ; 
BalloonBackground(11) = $808080                                                                               ; 
BalloonBackground(12) = $C0C0C0                                                                               ; 
BalloonBackground(13) = $FFFFFF                                                                               ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Fonts for the MyInfo printing section
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Program\PageHeading  = LoadFont(#PB_Any, "Times New Roman", ycm(0.1),  #PB_Font_Bold)                   ; Bold

If Program\PageHeading = #NoFontLoaded                                                                  ; 
  MessageRequester("Page heading font missing", "Cannot load the print routine page heading font" +     ; 
  #CRLF$                                                                                          +     ; 
  "Program will be terminated", #PB_MessageRequester_Ok | #MB_ICONERROR)
  End                                                                                                   ; 
EndIf                                                                                                   ; 

Program\ListHeading  = LoadFont(#PB_Any, "Courier New",     ycm(0.1),  #PB_Font_Bold)                   ; Bold

If Program\ListHeading = #NoFontLoaded                                                                  ; 
  MessageRequester("Page heading font missing", "Cannot load the print routine list heading font" +     ; 
  #CRLF$                                                                                          +     ; 
  "Program will be terminated", #PB_MessageRequester_Ok | #MB_ICONERROR)                                ; 
  End                                                                                                   ; 
EndIf                                                                                                   ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; MyInfo data structure
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure MyInfoData                                                                                    ; Position   In display
  Title.s                                                                                                 ;  0          1
  Information.s                                                                                           ;  1          2
  Category.s                                                                                              ;  2          3
  Archived.s                                                                                              ;  3          4 
  Favourite.s                                                                                             ;  4          5
  Locked.s                                                                                                ;  5          6
  Deleted.s                                                                                               ;  6          7
  Updated.s                                                                                               ;  7          9
  Owner.s                                                                                                 ;  8          8
  Attachments.s                                                                                           ;  9         10
  Recordid.s                                                                                              ; 10         11
EndStructure                                                                                            ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; MyInfo data structure global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global MyInfo.MyInfoData                                                                                ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Error structure data
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure ErrorData                                                                                    ; Error data log
  ErrorTime.s                                                                                           ; 
  ErrorModule.s                                                                                         ; 
  ErrorMessage.s                                                                                        ; 
  ExtraInfo.s                                                                                           ; 
EndStructure                                                                                          ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Error structure data global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global NewList ErrorList.ErrorData()                                                                  ; List of error messages to be flushed to disk

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Category data structure
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure Categorydata                                                                                 ; 
  Currentline.i                                                                                         ; 
  Currentrecord.s                                                                                       ; 
  CurrentCategory.s                                                                                     ; 
  OldCategoryString.s                                                                                   ; 
  Categoryid.s                                                                                          ; 
  Category.s                                                                                            ; 
  Itemcount.s                                                                                           ; 
  Iconname.s                                                                                            ; 
EndStructure                                                                                          ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Category data structure global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Category.Categorydata                                                                           ; My stuff category structure data

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Owner data structure
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure Ownerdata                                                                                    ; 
  Currentline.i                                                                                         ; 
  Currentrecord.s                                                                                       ; 
  CurrentOwner.s                                                                                        ; 
  OldOwnerString.s                                                                                      ; 
  Ownerid.s                                                                                             ; 
  Owner.s                                                                                               ; 
  Itemcount.s                                                                                           ; 
  Iconname.s                                                                                            ; 
EndStructure                                                                                          ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Owner data structure global
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global Owner.OwnerData                                                                                 ; My stuff location structure data

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Setup day and month literal names
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Define DaysPerMonthFill.i                                                                               ; 

Global Dim NameOfDay.s(7)                                                                               ; Fill an array with the names of the days (Terry Hough I think)

  NameOfDay(0)      = "Sunday"                                                                           ; 
  NameOfDay(1)      = "Monday"                                                                           ; 
  NameOfDay(2)      = "Tuesday"                                                                          ; 
  NameOfDay(3)      = "Wednesday"                                                                        ; 
  NameOfDay(4)      = "Thursday"                                                                         ; 
  NameOfDay(5)      = "Friday"                                                                           ; 
  NameOfDay(6)      = "Saturday"                                                                         ; 

Global Dim DaysPerMonth(12)                                                                             ; Fill an array on how many days per month there are

  For DaysPerMonthFill.i = 0 To 11                                                                      ; 
    DaysPerMonth(DaysPerMonthFill.i) = 31                                                                ; 
  Next                                                                           ; 

  DaysPerMonth(1)   = 28                                                                                 ; 
  DaysPerMonth(3)   = 30                                                                                 ; 
  DaysPerMonth(5)   = 30                                                                                 ; 
  DaysPerMonth(8)   = 30                                                                                 ; 
  DaysPerMonth(10)  = 30                                                                                 ; 

Global Dim NameOfMonth.s(12)                                                                            ; Fill an array with the names of the months

  NameOfMonth(0)    = "January"                                                                         ; 
  NameOfMonth(1)    = "February"                                                                        ; 
  NameOfMonth(2)    = "March"                                                                           ; 
  NameOfMonth(3)    = "April"                                                                           ; 
  NameOfMonth(4)    = "May"                                                                             ; 
  NameOfMonth(5)    = "June"                                                                            ; 
  NameOfMonth(6)    = "July"                                                                            ; 
  NameOfMonth(7)    = "August"                                                                          ; 
  NameOfMonth(8)    = "September"                                                                       ; 
  NameOfMonth(9)    = "October"                                                                         ; 
  NameOfMonth(10)   = "November"                                                                        ; 
  NameOfMonth(11)   = "December"                                                                        ; 

Global Dim Years.s(19)                                                                                 ; Fill an array with the years

  Years(0)          = "2002"                                                                            ; 
  Years(1)          = "2003"                                                                            ; 
  Years(2)          = "2004"                                                                            ; 
  Years(3)          = "2005"                                                                            ; 
  Years(4)          = "2006"                                                                            ; 
  Years(5)          = "2007"                                                                            ; 
  Years(6)          = "2008"                                                                            ; 
  Years(7)          = "2009"                                                                            ; 
  Years(8)          = "2010"                                                                            ; 
  Years(9)          = "2011"                                                                            ; 
  Years(10)         = "2012"                                                                            ; 
  Years(11)         = "2013"                                                                            ; 
  Years(12)         = "2014"                                                                            ; 
  Years(13)         = "2015"                                                                            ; 
  Years(14)         = "2016"                                                                            ; 
  Years(15)         = "2017"                                                                            ; 
  Years(16)         = "2018"                                                                            ; 
  Years(17)         = "2019"                                                                            ; 
  Years(18)         = "2020"                                                                            ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; All balloon tool tip variables defined
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Structure TooltipTextData
  
  ;----------------------------------------------
  ; Main form menu definitions
  ;----------------------------------------------
  
  ; File menu
  
  BackupDatabase.s
  ExportDatabase.s
  ImportDatabase.s
  OpenAdatabase.s
  VacuumDatabase.s
  ExitProgram.s             ; Also a main form button
  
  ; Categories
  
  AddCategory.s
  CopyCategory.s
  DeleteCategory.s
  EditCategory.s
  ExportCategories.s
  ImportCategories.s
  SyncCategories.s
  
  ; Data
  
  AddItem.s                 ; Also a main form button
  ArchiveItem.s             ; Also a main form button
  AttachItem.s              ; Also a main form button
  CopyItem.s                ; Also a main form button
  DeleteItem.s              ; Also a main form button
  EditItem.s                ; Also a main form button
  ExportItem.s              ; Also a main form button
  FavouriteItem.s           ; Also a main form button
  ImportItem.s              ; Also a main form button
  KillItem.s                ; Also a main form button
  LockItem.s                ; Also a main form button
  PrintItem.s               ; Also a main form button
  ScanItem.s                ; 
  
  ; Utilities
  
  AdvancedSearch.s          ; Also a main form button
  SelectAllItems.s
  OwnerManagement.s
  ChangeFont.s
  
  ; Options
  
  BalloonTooltips.s
  BalloonColour.s
  ColourBand.s
  HideDetail.s
  MessageSave.s
  ShowToolbar.s
  ScreenSnap.s
  StickyWindow.s
  TitleClock.s
  
  ; Help
  
  AboutProgram.s
  KeyboardShortcuts.s
  ProgramHelp.s           ; Also a main form button
  ViewLog.s
  
  CheckEnter.s
  
  ;----------------------------------------------
  ; Category editor form
  ;----------------------------------------------
  
  SaveCategory.s
  HelpCategory.s
  ExitCategory.s
  EscapeCategory.s
  
  ;----------------------------------------------
  ; Data editor form
  ;----------------------------------------------
  
  SaveData.s
  ExportData.s
  ImportData.s
  SearchData.s
  HelpData.s
  ExitData.s
  EscapeData.s
  
  ;----------------------------------------------
  ; Find text form for Data form
  ;----------------------------------------------
  
  FindFirst.s
  Findnext.s
  
  ;----------------------------------------------
  ; Advanced search form
  ;----------------------------------------------
  
  RunSearch.s
  ReturnSearch.s
  HelpSearch.s
  ExitSearch.s
  EscapeSearch.s
  
  ;----------------------------------------------
  ; Owner list form
  ;----------------------------------------------
  
  SaveOwnerlist.s
  AddOwnerlist.s
  DeleteOwnerlist.s
  EditOwnerlist.s
  SyncOwnerlist.s
  HelpOwnerlist.s
  ExitOwnerlist.s
  EscapeOwnerlist.s
  
  ;----------------------------------------------
  ; Owner editor form
  ;----------------------------------------------
  
  SaveOwner.s
  HelpOwner.s
  ExitOwner.s
  EscapeOwner.s
  
  ;----------------------------------------------
  ; Data print form
  ;----------------------------------------------
  
  NowPrint.s
  NowPreview.s
  ExitPrint.s
  EscapePrint.s
  
  ;----------------------------------------------
  ; About form
  ;----------------------------------------------
  
  EscapeAbout.s
  
  ;----------------------------------------------
  ; Help form
  ;----------------------------------------------
  
  LoadHelp.s
  SaveHelp.s
  SearchHelp.s
  PrintHelp.s
  EditHelp.s
  ExitHelp.s
  EscapeHelp.s
  SearchOnEnter.s
  
  ;----------------------------------------------
  ; Keyboard shortcuts form
  ;----------------------------------------------
  
  EscapeShortcuts.s
  
  ;----------------------------------------------
  ; Security section (No buttons, only for completeness)
  ;----------------------------------------------
  
  EditPassword.s
  LockProgram.s
 
  ;----------------------------------------------
  ; Error log shortcuts form
  ;----------------------------------------------
  
  EscapeErrorlog.s
  ExitErrorlog.s
  
  ;----------------------------------------------
  ; Document scan form
  ;----------------------------------------------
  
  NextScan.s
  FinishScan.s
  HelpScan.s
  CancelScan.s
EndStructure

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; All balloon tooltip data structures as static lists from the structure above
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Global LongTooltip.TooltipTextData
Global ShortTooltip.TooltipTextData

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Short tooltip definitions
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; File menu

ShortTooltip\BackupDatabase.s     = "Backup database"
ShortTooltip\ExportDatabase.s     = "Export database"
ShortTooltip\ImportDatabase.s     = "Import database"
ShortTooltip\OpenAdatabase.s      = "Open database"
ShortTooltip\VacuumDatabase.s     = "Vacuum database"
ShortTooltip\ExitProgram.s        = "Exit program"

; Categories

ShortTooltip\AddCategory.s        = "Add category"
ShortTooltip\CopyCategory.s       = "Copy category"
ShortTooltip\DeleteCategory.s     = "Delete category"
ShortTooltip\EditCategory.s       = "Edit category"
ShortTooltip\ExportCategories.s   = "Export categories"
ShortTooltip\ImportCategories.s   = "Import categories"
ShortTooltip\SyncCategories.s     = "Sync categories"

; Data

ShortTooltip\AddItem.s            = "Add new item"
ShortTooltip\ArchiveItem.s        = "Archive item"   
ShortTooltip\AttachItem.s         = "Attach document"
ShortTooltip\CopyItem.s           = "Copy item"
ShortTooltip\DeleteItem.s         = "Delete item"
ShortTooltip\EditItem.s           = "Edit item"
ShortTooltip\ExportItem.s         = "Export item"
ShortTooltip\FavouriteItem.s      = "Favourite item"
ShortTooltip\ImportItem.s         = "Import item"
ShortTooltip\KillItem.s           = "Kill item"
ShortTooltip\LockItem.s           = "Lock item"
ShortTooltip\PrintItem.s          = "Print item"
ShortTooltip\Scanitem.s           = "Scan item"

; Utilities

ShortTooltip\AdvancedSearch.s     = "Advanced search"
ShortTooltip\SelectAllItems.s     = "Select all"
ShortTooltip\OwnerManagement.s    = "Owner management"
ShortTooltip\ChangeFont.s         = "Change fonts"

; Options

ShortTooltip\BalloonTooltips.s    = "Balloon tooltips"
ShortTooltip\BalloonColour.s      = "Balloon colours"
ShortTooltip\ColourBand.s         = "Colour banding"
ShortTooltip\HideDetail.s         = "Hide details"
ShortTooltip\MessageSave.s        = "Message after save"
ShortTooltip\ShowToolbar.s        = "Show toolbar"
ShortTooltip\ScreenSnap.s         = "Screen snap"
ShortTooltip\StickyWindow.s       = "Sticky window"
ShortTooltip\TitleClock.s         = "Title clock"

; Help

ShortTooltip\AboutProgram.s       = "About program"
ShortTooltip\KeyboardShortcuts.s  = "Keyboard shortcuts"
ShortTooltip\ProgramHelp.s        = "Program help"
ShortTooltip\ViewLog.s            = "View log file"            

ShortTooltip\CheckEnter.s         = "Start searching"

;----------------------------------------------
; Category editor form
;----------------------------------------------

ShortTooltip\SaveCategory.s       = "Save category"
ShortTooltip\HelpCategory.s       = "Help category"
ShortTooltip\ExitCategory.s       = "Exit category"
ShortTooltip\EscapeCategory.s     = "Exit category"

;----------------------------------------------
; Data editor form
;----------------------------------------------

ShortTooltip\SaveData.s           = "Save data"
ShortTooltip\ExportData.s         = "Export data"
ShortTooltip\ImportData.s         = "Import data"
ShortTooltip\SearchData.s         = "Find data"
ShortTooltip\HelpData.s           = "Help data"
ShortTooltip\ExitData.s           = "Exit data"
ShortTooltip\EscapeData.s         = "Exit data"

;----------------------------------------------
; Find text form for Data form
;----------------------------------------------

ShortTooltip\FindFirst.s          = "Find first"
ShortTooltip\Findnext.s           = "Find next"

;----------------------------------------------
; Advanced search form
;----------------------------------------------

ShortTooltip\RunSearch.s          = "Run search"
ShortTooltip\ReturnSearch.s       = "Run search"
ShortTooltip\HelpSearch.s         = "Help Search"
ShortTooltip\ExitSearch.s         = "Exit search"
ShortTooltip\EscapeSearch.s       = "Exit search"

;----------------------------------------------
; Owner list form
;----------------------------------------------

ShortTooltip\SaveOwnerlist.s      = "Save list"
ShortTooltip\AddOwnerlist.s       = "Add owner"
ShortTooltip\DeleteOwnerlist.s    = "Delete owner"
ShortTooltip\Editownerlist.s      = "Edit owner"
ShortTooltip\SyncOwnerlist.s      = "Sync owners"
ShortTooltip\HelpOwnerlist.s      = "Help list"
ShortTooltip\ExitOwnerlist.s      = "Exit list"
ShortTooltip\EscapeOwnerlist.s    = "Exit list"

;----------------------------------------------
; Owner editor form
;----------------------------------------------

ShortTooltip\SaveOwner.s          = "Save owner"
ShortTooltip\HelpOwner.s          = "Help owner"
ShortTooltip\ExitOwner.s          = "Exit owner"
ShortTooltip\EscapeOwner.s        = "Exit owner"

;----------------------------------------------
; Data print form
;----------------------------------------------

ShortTooltip\NowPrint.s           = "Print data now"
ShortTooltip\NowPreview           = "Preview the print"
ShortTooltip\ExitPrint.s          = "Exit print window"
ShortTooltip\EscapePrint.s        = "Exit print window"

;----------------------------------------------
; About form
;----------------------------------------------

ShortTooltip\EscapeAbout.s        = "Exit About"

;----------------------------------------------
; Help form
;----------------------------------------------

ShortTooltip\LoadHelp.s           = "Load help"
ShortTooltip\SaveHelp.s           = "Save help"
ShortTooltip\SearchHelp.s         = "Search help"
ShortTooltip\PrintHelp.s          = "Print help"
ShortTooltip\EditHelp.s           = "Edit help"
ShortTooltip\ExitHelp.s           = "Exit help"
ShortTooltip\EscapeHelp.s         = "Exit help"
ShortTooltip\SearchOnEnter.s      = "Search help"

;----------------------------------------------
; Keyboard shortcuts form
;----------------------------------------------

ShortTooltip\EscapeShortcuts.s    = "Exit shortcuts"

;----------------------------------------------
; Security section (No buttons, only for completeness)
;----------------------------------------------

ShortTooltip\EditPassword.s       = "Edit password"
ShortTooltip\LockProgram.s        = "Lock program"
  
;----------------------------------------------
; Error log shortcuts form
;----------------------------------------------

ShortTooltip\ExitErrorlog.s       = "Exit errorlog"
ShortTooltip\EscapeErrorlog.s     = "Escape errorlog"

;----------------------------------------------
; Document scan form
;----------------------------------------------

ShortTooltip\NextScan.s           = "Scan next"
ShortTooltip\FinishScan.s         = "Finish scan"
ShortTooltip\HelpScan.s           = "Help scan"
ShortTooltip\CancelScan.s         = "Cancel scan"

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Long tooltip definitions
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

; File menu

LongTooltip\BackupDatabase.s      = "Backup the database to disk"
LongTooltip\ExportDatabase.s      = "Export the database to disk"
LongTooltip\ImportDatabase.s      = "Import a database from disk"
LongTooltip\OpenAdatabase.s       = "Open another database"
LongTooltip\VacuumDatabase.s      = "Vacuum wasted space from the database"
LongTooltip\ExitProgram.s         = "Exit the program immediately"

; Categories

LongTooltip\AddCategory.s         = "Add a new category to the database"
LongTooltip\CopyCategory.s        = "Copy the seolected category to the clipboard"
LongTooltip\DeleteCategory.s      = "Delete the selected category"
LongTooltip\EditCategory.s        = "Edit the selected category"
LongTooltip\ExportCategories.s    = "Export all categories to a disk file"
LongTooltip\ImportCategories.s    = "Import categories from a disk file"
LongTooltip\SyncCategories.s      = "Resync the number of items in each category to the category list"

; Data

LongTooltip\AddItem.s             = "Add a new item of information"
LongTooltip\ArchiveItem.s         = "Archive this item for long term storage"
LongTooltip\AttachItem.s          = "Attach a document to this item record"
LongTooltip\CopyItem.s            = "Copy the current item to the clipboard"
LongTooltip\DeleteItem.s          = "Delete the currently selected item temporarily"
LongTooltip\EditItem.s            = "Edit the currently selected item"
LongTooltip\ExportItem.s          = "Export the selected item to disk"
LongTooltip\FavouriteItem.s       = "Mark this item as a favourite of yours"
LongTooltip\ImportItem.s          = "Import an item from disk as a new record"
LongTooltip\KillItem.s            = "Kill the selected item permanently"
LongTooltip\LockItem.s            = "Lock the currently selected item to prevent changes"
LongTooltip\PrintItem.s           = "Print the currently selected item"
LongTooltip\Scanitem.s            = "Scan document to add to current information"

; Utilities

LongTooltip\AdvancedSearch.s      = "Used advanced functions to find information"
LongTooltip\SelectAllItems.s      = "Select all items in the list"
LongTooltip\OwnerManagement.s     = "Manage the list of database owners"
LongTooltip\ChangeFont.s          = "Change all form fonts used"

; Options

LongTooltip\BalloonTooltips.s     = "Turn balloon tooltips on of off"
LongTooltip\BalloonColour.s       = "Chane the balloon tooltip colours at random or not"
LongTooltip\ColourBand.s          = "Alternate row colour banding in the list"
LongTooltip\HideDetail.s          = "Hide all information in the detail pane"
LongTooltip\MessageSave.s         = "Show message every time you save data"
LongTooltip\ShowToolbar.s         = "Show or hide the main toolbar"
LongTooltip\ScreenSnap.s          = "Snap the program to the screen borders"
LongTooltip\StickyWindow.s        = "Stick program window on top of all others"
LongTooltip\TitleClock.s          = "Add a live clock to the program titlebar"

; Help

LongTooltip\AboutProgram.s        = "Show information about this program"
LongTooltip\KeyboardShortcuts.s   = "Show complete list of program keyboard shortcuts"
LongTooltip\ProgramHelp.s         = "Show program help in any have been created"
LongTooltip\ViewLog.s             = "View the system log of error messages"

LongTooltip\CheckEnter.s          = "Start searching for matches to the search string"

;----------------------------------------------
; Category editor form
;----------------------------------------------

LongTooltip\SaveCategory.s        = "Save new or edited category"
LongTooltip\HelpCategory.s        = "Show help for category editor"
LongTooltip\ExitCategory.s        = "Exit the category editor window"
LongTooltip\EscapeCategory.s      = "Exit the category editor window"

;----------------------------------------------
; Data editor form
;----------------------------------------------

LongTooltip\SaveData.s            = "Save the new or edited data"
LongTooltip\ExportData.s          = "Export this data to disk"
LongTooltip\ImportData.s          = "Import data from disk into this form"
LongTooltip\SearchData.s          = "Search for data in this form"
LongTooltip\HelpData.s            = "Show help on using this form"
LongTooltip\ExitData.s            = "Exit this data form without saving"
LongTooltip\EscapeData.s          = "Exit this data form without saving"

;----------------------------------------------
; Find text form for Data form
;----------------------------------------------

LongTooltip\FindFirst.s           = "Find first in data form"
LongTooltip\Findnext.s            = "Find next match in data form"

;----------------------------------------------
; Advanced search form
;----------------------------------------------

LongTooltip\RunSearch.s           = "Start searching with the selected parameters"
LongTooltip\ReturnSearch.s        = "Start searching when user presses RETURN"
LongTooltip\HelpSearch.s          = "Show help on using search functions"
LongTooltip\ExitSearch.s          = "Exit this search form without doing anything"
LongTooltip\EscapeSearch.s        = "Exit this search form without doing anything"

;----------------------------------------------
; Owner list form
;----------------------------------------------

LongTooltip\SaveOwnerlist.s       = "Save the list of owners to the database"
LongTooltip\AddOwnerlist.s        = "Add a new owner to the database"
LongTooltip\Deleteownerlist.s     = "Delete the currently selected owner"
LongTooltip\EditOwnerlist.s       = "Edit the currently selected owner"
LongTooltip\Syncownerlist.s       = "Resync the number of items in each owner to the owner list"
LongTooltip\HelpOwnerlist.s       = "Show help on using the owner list form"
LongTooltip\ExitOwnerlist.s       = "Exit the owner editor form"
LongTooltip\EscapeOwnerlist       = "Exit the owner editor form"

;----------------------------------------------
; Owner editor form
;----------------------------------------------

LongTooltip\SaveOwner.s           = "Save the new or edited owner form"
LongTooltip\HelpOwner.s           = "Show help on using the owner editor form"
LongTooltip\ExitOwner.s           = "Exit the owner editor without saving anything"
LongTooltip\EscapeOwner.s         = "Exit the owner editor without saving anything"

;----------------------------------------------
; Data print form
;----------------------------------------------

LongTooltip\NowPrint.s            = "Print all selected MyInfo data now"
LongTooltip\NowPreview            = "Preview the selected print job"
LongTooltip\ExitPrint.s           = "Exit the job print window now"
LongTooltip\EscapePrint.s         = "Exit the job print window now"

;----------------------------------------------
; About form
;----------------------------------------------

LongTooltip\EscapeAbout.s         = "Exit the About form immediately"

;----------------------------------------------
; Help form
;----------------------------------------------

LongTooltip\LoadHelp.s           = "Load a help file from disk to edit"
LongTooltip\SaveHelp.s           = "Save the current help file to disk"
LongTooltip\SearchHelp.s         = "Search the currently displayed help file"
LongTooltip\PrintHelp.s          = "Print the currently displayed help file"
LongTooltip\EditHelp.s           = "Edit the currently displayed help file"
LongTooltip\ExitHelp.s           = "Exit the help file display form"
LongTooltip\EscapeHelp.s         = "Exit the help file display form"
LongTooltip\SearchOnEnter.s      = "Search the currently displayed help file"

;----------------------------------------------
; Keyboard shortcuts form
;----------------------------------------------

LongTooltip\EscapeShortcuts.s    = "Exit the shortcuts shortcuts display form"

;----------------------------------------------
; Security section (No buttons, only for completeness)
;----------------------------------------------

LongTooltip\EditPassword.s       = "Edit the program security password"
LongTooltip\LockProgram.s        = "Lock the program to the system tray"

;----------------------------------------------
; Error log shortcuts form
;----------------------------------------------

LongTooltip\ExitErrorlog.s       = "Exit the errorlog viewer form"
LongTooltip\EscapeErrorlog.s     = "Escape the errorlog viewer form"

;----------------------------------------------
; Document scan form
;----------------------------------------------

LongTooltip\NextScan.s           = "Scan next page of document"
LongTooltip\FinishScan.s         = "Finish the scan and save it to record"
LongTooltip\HelpScan.s           = "Show help on using the document scanner form"
LongTooltip\CancelScan.s         = "Cancel the document scanning process without saving"

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; All keyboard shortcut definitions
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;--------------------------------------------------------------------------------------------------
; Main form keyboard shortcuts
;--------------------------------------------------------------------------------------------------

; File menu

#ShortcutValue_BackupDatabase     = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_3
#ShortcutValue_ExportDatabase     = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_1
#ShortcutValue_ImportDatabase     = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_2
#ShortcutValue_OpenAdatabase      = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_5
#ShortcutValue_VacuumDatabase     = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_4
#ShortcutValue_ExitProgram        = #PB_Shortcut_Alt      | #PB_Shortcut_F4

; Categories

#ShortcutValue_AddCategory        = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_A
#ShortcutValue_CopyCategory       = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_C
#ShortcutValue_DeleteCategory     = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_D
#ShortcutValue_EditCategory       = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_E
#ShortcutValue_ExportCategories   = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_X
#ShortcutValue_ImportCategories   = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_I
#ShortcutValue_SyncCategories     = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_S

; Data

#ShortcutValue_AddItem            = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_A
#ShortcutValue_ArchiveItem        = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_R
#ShortcutValue_AttachItem         = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_Insert
#ShortcutValue_CopyItem           = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_C
#ShortcutValue_DeleteItem         = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_D
#ShortcutValue_EditItem           = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_E
#ShortcutValue_ExportItem         = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_X
#ShortcutValue_FavouriteItem      = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_F
#ShortcutValue_ImportItem         = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_I
#ShortcutValue_KillItem           = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_K
#ShortcutValue_LockItem           = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_L
#ShortcutValue_PrintItem          = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_P
#ShortcutValue_Scanitem           = #PB_Shortcut_Control  | #PB_Shortcut_Alt  | #PB_Shortcut_S

; Utilities

#ShortcutValue_AdvancedSearch     = #PB_Shortcut_Control  | #PB_Shortcut_A
#ShortcutValue_SelectAllItems     = #PB_Shortcut_Control  | #PB_Shortcut_S
#ShortcutValue_OwnerManagement    = #PB_Shortcut_Control  | #PB_Shortcut_O
#ShortcutValue_ChangeFont         = #PB_Shortcut_Control  | #PB_Shortcut_F

; Options

#ShortcutValue_BalloonTooltips    = #PB_Shortcut_F2
#ShortcutValue_BalloonColour      = #PB_Shortcut_F3
#ShortcutValue_ColourBand         = #PB_Shortcut_F4
#ShortcutValue_HideDetail         = #PB_Shortcut_F5
#ShortcutValue_MessageSave        = #PB_Shortcut_F6
#ShortcutValue_ShowToolbar        = #PB_Shortcut_F7
#ShortcutValue_ScreenSnap         = #PB_Shortcut_F8
#ShortcutValue_StickyWindow       = #PB_Shortcut_F9
#ShortcutValue_TitleClock         = #PB_Shortcut_F10

; Help

#ShortcutValue_AboutProgram       = #PB_Shortcut_Alt      | #PB_Shortcut_A
#ShortcutValue_KeyboardShortcuts  = #PB_Shortcut_Alt      | #PB_Shortcut_K
#ShortcutValue_ProgramHelp        = #PB_Shortcut_F1
#ShortcutValue_ViewLog            = #PB_Shortcut_Alt      | #PB_Shortcut_V

; Main form search

#ShortcutValue_CheckEnter         = #PB_Shortcut_Return

;--------------------------------------------------------------------------------------------------
; Find data form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_SearchDataForm     = #PB_Shortcut_Return
#ShortcutValue_EscapeFind         = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Category editor form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_SaveCategory       = #PB_Shortcut_Alt      | #PB_Shortcut_S
#ShortcutValue_HelpCategory       = #PB_Shortcut_F1
#ShortcutValue_ExitCategory       = #PB_Shortcut_Alt      | #PB_Shortcut_X
#ShortcutValue_EscapeCategory     = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Data editor form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_SaveData           = #PB_Shortcut_Alt      | #PB_Shortcut_Q
#ShortcutValue_ExportData         = #PB_Shortcut_Alt      | #PB_Shortcut_E
#ShortcutValue_ImportData         = #PB_Shortcut_Alt      | #PB_Shortcut_P
#ShortcutValue_SearchData         = #PB_Shortcut_Control  | #PB_Shortcut_F
#ShortcutValue_HelpData           = #PB_Shortcut_F1
#ShortcutValue_ExitData           = #PB_Shortcut_Alt      | #PB_Shortcut_X
#ShortcutValue_EscapeData         = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Find text form for Data form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_FindFirst          = #PB_Shortcut_Alt      | #PB_Shortcut_PageDown
#ShortcutValue_Findnext           = #PB_Shortcut_Alt      | #PB_Shortcut_End

;--------------------------------------------------------------------------------------------------
; Advanced search form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_RunSearch          = #PB_Shortcut_Alt      | #PB_Shortcut_R
#ShortcutValue_ReturnSearch       = #PB_Shortcut_Return
#ShortcutValue_HelpSearch         = #PB_Shortcut_F1
#ShortcutValue_ExitSearch         = #PB_Shortcut_Alt      | #PB_Shortcut_X
#ShortcutValue_EscapeSearch       = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Owner list form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_SaveOwnerlist      = #PB_Shortcut_Alt      | #PB_Shortcut_S
#ShortcutValue_AddOwnerlist       = #PB_Shortcut_Alt      | #PB_Shortcut_A
#ShortcutValue_Deleteownerlist    = #PB_Shortcut_Alt      | #PB_Shortcut_D
#ShortcutValue_EditOwnerlist      = #PB_Shortcut_Alt      | #PB_Shortcut_E
#ShortcutValue_SyncOwnerlist      = #PB_Shortcut_Alt      | #PB_Shortcut_S
#ShortcutValue_HelpOwnerlist      = #PB_Shortcut_F1
#ShortcutValue_Exitownerlist      = #PB_Shortcut_Alt      | #PB_Shortcut_X
#ShortcutValue_EscapeOwnerlist    = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Owner editor form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_SaveOwner          = #PB_Shortcut_Alt      | #PB_Shortcut_S
#ShortcutValue_HelpOwner          = #PB_Shortcut_F1
#ShortcutValue_ExitOwner          = #PB_Shortcut_Alt      | #PB_Shortcut_X
#ShortcutValue_EscapeOwner        = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; Data print form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_NowPrint           = #PB_Shortcut_Control  | #PB_Shortcut_P
#ShortcutValue_NowPreview         = #PB_Shortcut_Control  | #PB_Shortcut_V
#ShortcutValue_ExitPrint          = #PB_Shortcut_Alt      | #PB_Shortcut_X
#ShortcutValue_EscapePrint        = #PB_Shortcut_Escape

;--------------------------------------------------------------------------------------------------
; About form
;--------------------------------------------------------------------------------------------------

#ShortcutValue_EscapeAbout        = #PB_Shortcut_Escape

;----------------------------------------------
; Help form
;----------------------------------------------

#ShortcutValue_LoadHelp           = #PB_Shortcut_Control  | #PB_Shortcut_L
#ShortcutValue_SaveHelp           = #PB_Shortcut_Control  | #PB_Shortcut_S
#ShortcutValue_SearchHelp         = #PB_Shortcut_Control  | #PB_Shortcut_R
#ShortcutValue_PrintHelp          = #PB_Shortcut_Control  | #PB_Shortcut_P
#ShortcutValue_EditHelp           = #PB_Shortcut_Control  | #PB_Shortcut_E
#ShortcutValue_ExitHelp           = #PB_Shortcut_Alt      | #PB_Shortcut_X
#ShortcutValue_EscapeHelp         = #PB_Shortcut_Escape 

#ShortcutValue_SearchOnEnter      = #PB_Shortcut_Return

;----------------------------------------------
; Keyboard shortcuts form
;----------------------------------------------

#ShortcutValue_EscapeShortcuts    = #PB_Shortcut_Escape

;----------------------------------------------
; Security sections
;----------------------------------------------

#ShortcutValue_NewPassword_Return     = #PB_Shortcut_Return
#ShortcutValue_NewPassword_Escape     = #PB_Shortcut_Escape

#ShortCutValue_StartUpPassword_Return = #PB_Shortcut_Return
#ShortCutValue_StartUpPassword_Escape = #PB_Shortcut_Escape

#ShortcutValue_EditPassword_Return    = #PB_Shortcut_Return
#ShortcutValue_EditPassword_Escape    = #PB_Shortcut_Escape

#ShortcutValue_UnlockPassword_Return  = #PB_Shortcut_Return
#ShortcutValue_UnlockPassword_Escape  = #PB_Shortcut_Escape

;----------------------------------------------
; Security section (No buttons, only for completeness)
;----------------------------------------------

#ShortcutValue_EditPassword           = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_5
#ShortcutValue_LockProgram            = #PB_Shortcut_Shift    | #PB_Shortcut_Alt  | #PB_Shortcut_6

;----------------------------------------------
; Error log shortcuts form
;----------------------------------------------

#ShortcutValue_ExitErrorlog           = #PB_Shortcut_Alt      | #PB_Shortcut_X
#ShortcutValue_EscapeErrorlog         = #PB_Shortcut_Escape

;----------------------------------------------
; Document scan form
;----------------------------------------------

#ShortcutValue_NextScan               = #PB_Shortcut_Control  | #PB_Shortcut_N
#ShortcutValue_FinishScan             = #PB_Shortcut_Control  | #PB_Shortcut_S
#ShortcutValue_HelpScan               = #PB_Shortcut_F1
#ShortcutValue_CancelScan             = #PB_Shortcut_Control  | #PB_Shortcut_C

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Extra enumerations after the visual designer created ones
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Enumeration #GadgetIndex
  
  ;------------------------------------------------------------------------------------------------
  ;  Category bar popup menu
  ;------------------------------------------------------------------------------------------------
  
  #PopMenuBar_Category
  #PopMenuBar_Category_AddCategory                                                                    ; 
  #PopMenuBar_Category_CopyCategory                                                                   ; 
  #PopMenuBar_Category_DeleteCategory                                                                 ; 
  #PopMenuBar_Category_EditCategory                                                                   ; 
  #PopMenuBar_Category_ExportCategories                                                               ; 
  #PopMenuBar_Category_ImportCategories                                                               ; 
  #PopMenuBar_Category_SyncCategories                                                                 ; 
  
  ;------------------------------------------------------------------------------------------------
  ; Create the main program popupmenu
  ;------------------------------------------------------------------------------------------------  
  
  #PopMenuBar_MyInfo
  #PopMenuBar_MyInfo_BackupDatabase
  #PopMenuBar_MyInfo_ExportDatabase
  #PopMenuBar_MyInfo_ImportDatabase
  #PopMenuBar_MyInfo_OpenAdatabase
  #PopMenuBar_MyInfo_VacuumDatabase
  #PopMenuBar_MyInfo_ExitProgram
  #PopMenuBar_MyInfo_AddItem
  #PopMenuBar_MyInfo_ArchiveItem
  #PopMenuBar_MyInfo_AttachItem
  #PopMenuBar_MyInfo_CopyItem
  #PopMenuBar_MyInfo_DeleteItem
  #PopMenuBar_MyInfo_EditItem
  #PopMenuBar_MyInfo_ExportItem
  #PopMenuBar_MyInfo_FavouriteItem
  #PopMenuBar_MyInfo_ImportItem
  #PopMenuBar_MyInfo_KillItem
  #PopMenuBar_MyInfo_LockItem
  #PopMenuBar_MyInfo_PrintItem
  #PopMenubar_MyInfo_Scanitem
  #PopMenuBar_MyInfo_AdvancedSearch
  #PopMenuBar_MyInfo_SelectAllItems
  #PopMenuBar_MyInfo_OwnerManagement
  #PopMenuBar_MyInfo_ChangeFont
  #PopMenuBar_MyInfo_EditPassword
  #PopMenuBar_MyInfo_LockProgram
  #PopMenuBar_MyInfo_BalloonTooltips
  #PopMenuBar_MyInfo_BalloonColour
  #PopMenuBar_MyInfo_ColourBand
  #PopMenuBar_MyInfo_HideDetail
  #PopMenuBar_MyInfo_MessageSave
  #PopMenuBar_MyInfo_ShowToolbar
  #PopMenuBar_MyInfo_ScreenSnap
  #PopMenuBar_MyInfo_StickyWindow
  #PopMenuBar_MyInfo_TitleClock
  #PopMenuBar_MyInfo_AboutProgram
  #PopMenuBar_MyInfo_KeyboardShortcuts
  #PopMenuBar_MyInfo_ProgramHelp
  #PopMenuBar_MyInfo_ViewLog
  
  ; Detail pane menu
  
  #PopMenubar_Details
  #PopMenubar_Details_CopyItem
  #PopMenuBar_Details_EditItem
  #PopMenuBar_Details_PrintItem
  
  ; File menu
  
  #KeyboardShortcut_ExportDatabase
  #KeyboardShortcut_ImportDatabase
  #KeyboardShortcut_BackupDatabase
  #KeyboardShortcut_OpenAdatabase
  #KeyboardShortcut_VacuumDatabase
  #KeyboardShortcut_ExitProgram
  
  ; Categories
  
  #KeyboardShortcut_AddCategory
  #KeyboardShortcut_CopyCategory
  #KeyboardShortcut_DeleteCategory
  #KeyboardShortcut_EditCategory
  #KeyboardShortcut_ExportCategories
  #KeyboardShortcut_ImportCategories
  #KeyboardShortcut_SyncCategories
  
  ; Data
  
  #KeyboardShortcut_AddItem
  #KeyboardShortcut_ArchiveItem
  #KeyboardShortcut_AttachItem
  #KeyboardShortcut_CopyItem
  #KeyboardShortcut_DeleteItem
  #KeyboardShortcut_EditItem
  #KeyboardShortcut_ExportItem
  #KeyboardShortcut_FavouriteItem
  #KeyboardShortcut_ImportItem
  #KeyboardShortcut_KillItem
  #KeyboardShortcut_LockItem
  #KeyboardShortcut_PrintItem
  #KeyboardShortcut_ScanItem
  
  ; Utilities
  
  #KeyboardShortcut_AdvancedSearch
  #KeyboardShortcut_SelectAllItems
  #KeyboardShortcut_OwnerManagement
  #KeyboardShortcut_ChangeFont
  
  ; Options
  
  #KeyboardShortcut_BalloonTooltips
  #KeyboardShortcut_BalloonColour
  #KeyboardShortcut_ColourBand
  #KeyboardShortcut_HideDetail
  #KeyboardShortcut_MessageSave
  #KeyboardShortcut_ShowToolbar
  #KeyboardShortcut_ScreenSnap
  #KeyboardShortcut_StickyWindow
  #KeyboardShortcut_TitleClock
  
  ; Help
  
  #KeyboardShortcut_AboutProgram
  #KeyboardShortcut_KeyboardShortcuts
  #KeyboardShortcut_ProgramHelp
  #KeyboardShortcut_ViewLog
  
  ; Main form search
  
  #KeyboardShortcut_CheckEnter
  
  ;----------------------------------------------
  ; Find data form
  ;----------------------------------------------
  
  #KeyboardShortcut_SearchDataForm
  #KeyboardShortcut_EscapeFind
  
  ;----------------------------------------------
  ; Category editor form
  ;----------------------------------------------
  
  #KeyboardShortcut_SaveCategory
  #KeyboardShortcut_HelpCategory
  #KeyboardShortcut_ExitCategory
  #KeyboardShortcut_EscapeCategory
  
  ;----------------------------------------------
  ; Data editor form
  ;----------------------------------------------
  
  #KeyboardShortcut_SaveData
  #KeyboardShortcut_ExportData
  #KeyboardShortcut_ImportData
  #KeyboardShortcut_SearchData
  #KeyboardShortcut_HelpData
  #KeyboardShortcut_ExitData
  #KeyboardShortcut_EscapeData
  
  ;-----------------------------------------------
  ; Find text form for Data form
  ;-----------------------------------------------
  
  #KeyboardShortcut_FindFirst
  #KeyboardShortcut_Findnext
  
  ;----------------------------------------------
  ; Advanced search form
  ;----------------------------------------------
  
  #KeyboardShortcut_RunSearch
  #KeyboardShortcut_ReturnSearch
  #KeyboardShortcut_HelpSearch
  #KeyboardShortcut_ExitSearch
  #KeyboardShortcut_EscapeSearch
  
  ;----------------------------------------------
  ; Owner list form
  ;----------------------------------------------
  
  #KeyboardShortcut_SaveOwnerlist
  #KeyboardShortcut_AddOwnerlist
  #KeyboardShortcut_DeleteOwnerlist
  #KeyboardShortcut_EditOwnerlist
  #KeyboardShortcut_SyncOwnerlist
  #KeyboardShortcut_HelpOwnerlist
  #KeyboardShortcut_ExitOwnerlist
  #KeyboardShortcut_EscapeOwnerList
  
  ;----------------------------------------------
  ; Owner editor form
  ;----------------------------------------------
  
  #KeyboardShortcut_SaveOwner
  #KeyboardShortcut_HelpOwner
  #KeyboardShortcut_ExitOwner
  #KeyboardShortcut_EscapeOwner
  
  ;----------------------------------------------
  ; Data print form
  ;----------------------------------------------
  
  #KeyboardShortcut_NowPrint
  #KeyboardShortcut_NowPreview
  #KeyboardShortcut_ExitPrint
  #KeyboardShortcut_EscapePrint
  
  ;--------------------------------------------------------------------------------------------------
  ; About form
  ;--------------------------------------------------------------------------------------------------
  
  #KeyboardShortcut_EscapeAbout
  
  ;--------------------------------------------------------------------------------------------------
  ; Help display and edit form
  ;--------------------------------------------------------------------------------------------------
  
  #KeyboardShortcut_LoadHelp
  #KeyboardShortcut_SaveHelp
  #KeyboardShortcut_SearchHelp
  #KeyboardShortcut_PrintHelp
  #KeyboardShortcut_EditHelp
  #KeyboardShortcut_ExitHelp
  #KeyboardShortcut_EscapeHelp
  #KeyboardShortcut_SearchOnEnter
  
  ;----------------------------------------------
  ; Keyboard shortcuts form
  ;----------------------------------------------
  
  #KeyboardShortcut_EscapeShortcuts
  
  ;----------------------------------------------
  ; Security sections
  ;----------------------------------------------
  
  #KeyboardShortcut_NewPassword_Return
  #KeyboardShortcut_NewPassword_Escape
  
  #KeyboardShortcut_StartUpPassword_Return
  #KeyboardShortcut_StartUpPassword_Escape
  
  #KeyboardShortcut_EditPassword_Return
  #KeyboardShortcut_EditPassword_Escape
  
  #KeyboardShortcut_UnlockPassword_Return
  #KeyboardShortcut_UnlockPassword_Escape
  
  ;----------------------------------------------
  ; Security section (No buttons, only for completeness)
  ;----------------------------------------------
  
  #KeyboardShortcut_EditPassword
  #KeyboardShortcut_LockProgram
  
  ;----------------------------------------------
  ; Error log shortcuts form
  ;----------------------------------------------
  
  #KeyboardShortcut_ExitErrorlog
  #KeyboardShortcut_EscapeErrorlog
  
  ;----------------------------------------------
  ; Document scan form
  ;----------------------------------------------
  
  #KeyboardShortcut_NextScan
  #KeyboardShortcut_FinishScan
  #KeyboardShortcut_HelpScan
  #KeyboardShortcut_CancelScan
  
  ;----------------------------------------------
  ; System tray
  ;----------------------------------------------
  
  #Systray_Tray
  
  ;----------------------------------------------
  ; Title bar clock timer with enumerated constant
  ;----------------------------------------------
  
  #TitleBarClockTimer

EndEnumeration

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Extra image constants, follows on from the visual designer created code
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Enumeration #ImageIndex                                                                            ; Follow on from visual designer created constants

  ;-----------------------------------------
  ; 16 x 16
  ;-----------------------------------------
  
  #Image_ProgramIcon                                                                                ; 
  
  #Image_Shortcuts                                                                                  ; 
  
  #Image_Add                                                                                        ; 
  #Image_Delete                                                                                     ; 
  #Image_Edit                                                                                       ; 
  #Image_Enter                                                                                      ; 
  #Image_Escape                                                                                     ; 
  #Image_Exit                                                                                       ; 
  #Image_Export                                                                                     ; 
  #Image_First                                                                                      ; 
  #Image_Help                                                                                       ; 
  #Image_Import                                                                                     ; 
  #Image_Load                                                                                       ; 
  #Image_Next                                                                                       ; 
  #Image_Preview                                                                                    ; 
  #Image_Print                                                                                      ; 
  #Image_Run                                                                                        ; 
  #Image_Save                                                                                       ; 
  #Image_Search                                                                                     ; 
  
  #Image_ListAll                                                                                    ; All
  #Image_ListNormal                                                                                 ; Normal category
  #Image_ListEmpty                                                                                  ; Empty title
  #Image_ListArchived                                                                               ; Archived item
  #Image_ListFavourite                                                                              ; Favourite item
  #Image_ListLocked                                                                                 ; Locked item
  #Image_ListDeleted                                                                                ; Deleted item
  #Image_ListCategory                                                                               ; Normal category
  #Image_ListNocategory                                                                             ; No category
  #Image_ListOwner                                                                                  ; Normal owner
  #Image_ListNoowner                                                                                ; No owner
  
  #Image_ComboLocked                                                                                ; 
  #Image_ComboUnlocked                                                                              ; 
  
  #Image_GenericBlank                                                                               ; 
  
  #Image_OwnerName                                                                                  ; 
  
  #Image_DataFields                                                                                 ; 
  
  #Image_ComboAll                                                                                   ; 
  #Image_ComboSql                                                                                   ; 
EndEnumeration

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Load images into memory from the datasection references, follows on from the visual designer created code
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

;-----------------------------------------
; 16 x 16
;-----------------------------------------

CatchImage(#Image_ProgramIcon,                  ?_Image_ProgramIcon)                                ; 

CatchImage(#Image_Shortcuts,                    ?_Image_Shortcuts)                                  ; 

CatchImage(#Image_Add,                          ?_Image_Add)                                        ; 
CatchImage(#Image_Delete,                       ?_Image_Delete)                                     ; 
CatchImage(#Image_Edit,                         ?_Image_Edit)                                       ; 
CatchImage(#Image_Enter,                        ?_Image_Enter)                                      ; 
CatchImage(#Image_Escape,                       ?_Image_Escape)                                     ; 
CatchImage(#Image_Exit,                         ?_Image_Exit)                                       ; 
CatchImage(#Image_Export,                       ?_Image_Export)                                     ; 
CatchImage(#Image_First,                        ?_Image_First)                                      ; 
CatchImage(#Image_Help,                         ?_Image_Help)                                       ; 
CatchImage(#Image_Import,                       ?_Image_Import)                                     ; 
CatchImage(#Image_Load,                         ?_Image_Load)                                       ; 
CatchImage(#Image_Next,                         ?_Image_Next)                                       ; 
CatchImage(#Image_Preview,                      ?_Image_Preview)                                    ; 
CatchImage(#Image_Print,                        ?_Image_Print)                                      ; 
CatchImage(#Image_Run,                          ?_Image_Run)                                        ; 
CatchImage(#Image_Save,                         ?_Image_Save)                                       ; 
CatchImage(#Image_Search,                       ?_Image_Search)                                     ; 
  
CatchImage(#Image_ListAll,                      ?_Image_ListAll)                                    ; 
CatchImage(#Image_ListNormal,                   ?_Image_ListNormal)                                 ; 
CatchImage(#Image_ListEmpty,                    ?_Image_ListEmpty)                                  ; Empty title
CatchImage(#Image_ListArchived,                 ?_Image_ListArchived)                               ; Archived item
CatchImage(#Image_ListFavourite,                ?_Image_ListFavourite)                              ; 
CatchImage(#Image_ListLocked,                   ?_Image_ListLocked)                                 ; 
CatchImage(#Image_ListDeleted,                  ?_Image_ListDeleted)                                ; 
CatchImage(#Image_ListCategory,                 ?_Image_ListCategory)                               ; 
CatchImage(#Image_ListNocategory,               ?_Image_ListNocategory)                             ; No category
CatchImage(#Image_ListOwner,                    ?_Image_ListOwner)                                  ; 
CatchImage(#Image_ListNoowner,                  ?_Image_ListNoowner)                                ; No owner

CatchImage(#Image_ComboLocked,                  ?_Image_ComboLocked)                                ; 
CatchImage(#Image_ComboUnlocked,                ?_Image_ComboUnlocked)                              ; 

CatchImage(#Image_GenericBlank,                 ?_Image_GenericBlank)                               ; 

CatchImage(#Image_OwnerName,                    ?_Image_OwnerName)                                  ; 

CatchImage(#Image_DataFields,                   ?_Image_DataFields)                                 ; 

CatchImage(#Image_ComboAll,                     ?_Image_ComboAll)                                   ; 
CatchImage(#Image_ComboSql,                     ?_Image_ComboSql)                                   ; 

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Datasection information
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

DataSection
  
  ;-----------------------------------------
  ; Text files
  ;-----------------------------------------
  
  _About:                                   : IncludeBinary  "Store\HelpFiles\About.rtf"            ; 
  
  ;-----------------------------------------
  ; 16 x 16
  ;-----------------------------------------
  
  _Image_ProgramIcon:                       : IncludeBinary  "Images\_16x16\Password.ico"           ; 
  
  _Image_Shortcuts:                         : IncludeBinary  "Images\_16x16\Keyboard.ico"           ; 
  
  _Image_Add:                               : IncludeBinary  "Images\_16x16\Add.ico"                ; 
  _Image_Delete:                            : IncludeBinary  "Images\_16x16\Delete.ico"             ; 
  _Image_Edit:                              : IncludeBinary  "Images\_16x16\Edit.ico"               ; 
  _Image_Enter:                             : IncludeBinary  "Images\_16x16\Enter.ico"              ; 
  _Image_Escape:                            : IncludeBinary  "Images\_16x16\Escape.ico"             ; 
  _Image_Exit:                              : IncludeBinary  "Images\_16x16\Exit.ico"               ; 
  _Image_Export:                            : IncludeBinary  "Images\_16x16\Export.ico"             ; 
  _Image_First:                             : IncludeBinary  "Images\_16x16\First.ico"              ; 
  _Image_Help:                              : IncludeBinary  "Images\_16x16\Help.ico"               ; 
  _Image_Import:                            : IncludeBinary  "Images\_16x16\Import.ico"             ; 
  _Image_Load:                              : IncludeBinary  "Images\_16x16\Load.ico"               ; 
  _Image_Next:                              : IncludeBinary  "Images\_16x16\Next.ico"               ; 
  _Image_Preview:                           : IncludeBinary  "Images\_16x16\Preview.ico"            ; 
  _Image_Print:                             : IncludeBinary  "Images\_16x16\Print.ico"              ; 
  _Image_Run:                               : IncludeBinary  "Images\_16x16\Run.ico"                ; 
  _Image_Save:                              : IncludeBinary  "Images\_16x16\Save.ico"               ; 
  _Image_Search:                            : IncludeBinary  "Images\_16x16\Search.ico"             ; 

  _Image_ListAll:                           : IncludeBinary  "Images\_16x16\All.ico"                ; 
  _Image_ListNormal:                        : IncludeBinary  "Images\_16x16\Doctype.ico"            ; 
  _Image_ListEmpty:                         : IncludeBinary  "Images\_16x16\Empty.ico"              ; 
  _Image_ListArchived:                      : IncludeBinary  "Images\_16x16\Archive.ico"            ; 
  _Image_ListFavourite:                     : IncludeBinary  "Images\_16x16\Favourite.ico"          ; 
  _Image_ListLocked:                        : IncludeBinary  "Images\_16x16\Locked.ico"             ; 
  _Image_ListDeleted:                       : IncludeBinary  "Images\_16x16\Deleted.ico"            ; 
  _Image_ListCategory:                      : IncludeBinary  "Images\_16x16\Category.ico"           ; 
  _Image_ListNocategory:                    : IncludeBinary  "Images\_16x16\About.ico"              ; 
  _Image_ListOwner:                         : IncludeBinary  "Images\_16x16\Man.ico"                ; 
  _Image_ListNoowner:                       : IncludeBinary  "Images\_16x16\Friend.ico"             ; 
  
  _Image_ComboLocked:                       : IncludeBinary  "Images\_16x16\Locked.ico"             ; 
  _Image_ComboUnlocked:                     : IncludeBinary  "Images\_16x16\Unlocked.ico"           ; 
  
  _Image_GenericBlank:                      : IncludeBinary  "Images\_16x16\Blank.ico"              ; 
  
  _Image_OwnerName:                         : IncludeBinary  "Images\_16x16\Owner.ico"              ; 
  
  _Image_DataFields:                        : IncludeBinary  "Images\_16x16\Field.ico"              ; 
  
  _Image_ComboAll:                          : IncludeBinary  "Images\_16x16\All.ico"                ; 
  _Image_ComboSql:                          : IncludeBinary  "Images\_16x16\Sql.ico"                ; 
  
  BeginSearchTypes:
  
  Data.s  "Sounds like"                                                                              ; 
  Data.s  "Equal to"                                                                                 ; 
  Data.s  "Does not equal"                                                                           ; 
  Data.s  "Greater than"                                                                             ; 
  Data.s  "Greater than or equal to"                                                                 ; 
  Data.s  "Less than"                                                                                ; 
  Data.s  "Less than or equal to"                                                                    ; 
  Data.s  "Starts with"                                                                              ; 
  Data.s  "Ends with"                                                                                ; 
  Data.s  "_EndSearchTypes_"                                                                         ; 

  BeginSqlFields:
  
  Data.s  "Title"                                                                                    ; 
  Data.s  "Information"                                                                              ; 
  Data.s  "Category"                                                                                 ; 
  Data.s  "Favourite"                                                                                ; 
  Data.s  "Locked"                                                                                   ; 
  Data.s  "Deleted"                                                                                  ; 
  Data.s  "Owner"                                                                                    ; 
  Data.s  "Updated"                                                                                  ; 
  Data.s  "Record"                                                                                   ; 
  Data.s  "_EndSqlFields_"                                                                           ; 
  
  BeginFontSizes:
  
  Data.s  "8"                                                                                        ; 
  Data.s  "9"                                                                                        ; 
  Data.s "10"                                                                                        ; 
  Data.s "11"                                                                                        ;                                                                               ; 
  Data.s "12"                                                                                        ; 
  Data.s "14"                                                                                        ; 
  Data.s "16"                                                                                        ; 
  Data.s "18"                                                                                        ; 
  Data.s "20"                                                                                        ; 
  Data.s "22"                                                                                        ; 
  Data.s "24"                                                                                        ; 
  Data.s "26"                                                                                        ; 
  Data.s "28"                                                                                        ; 
  Data.s "36"                                                                                        ; 
  Data.s "48"                                                                                        ; 
  Data.s "72"                                                                                        ; 
  Data.s  "_EndFontSizes_"                                                                           ; 
  
  BeginCharacterArea:                                                                                ; 

  Data.s "Arabic"                                                                                    ; 
  Data.s "Baltic"                                                                                    ; 
  Data.s "Central European"                                                                          ; 
  Data.s "Cyrillic"                                                                                  ; 
  Data.s "Greek"                                                                                     ; 
  Data.s "Hebrew"                                                                                    ; 
  Data.s "Turkish"                                                                                   ; 
  Data.s "Vietnamese"                                                                                ; 
  Data.s "Western"                                                                                   ; 
  Data.s  "_EndCharacterArea_"                                                                       ; 
  
  _MGB_HtmlTop:                                                                                      ;
  
  Data.s "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN'>"
  Data.s "<html>"
  Data.s "<head>"
  Data.s "  <title>MGB Technical Services - MyInfo Info database</title>"
  Data.s "  <meta name='GENERATOR' content='MGB Technical Services NotePiddle v1.0'>"
  Data.s "</head>"
  Data.s "<body alink='red' bgcolor='white' link='blue' text='black' vlink='purple'>"
  Data.s  "_MGB_HtmlTop_END_"
  
  _MGB_HtmlMiddle:                                                                                   ;
  
  Data.s "<table style='text-align: left; width: 640px;' border='0' cellpadding='2' cellspacing='2'>"
  Data.s "<tbody><tr><td>MGB_Title</td></tr><tr><td>MGB_Information</td></tr></tbody></table><br></body></html>"
  Data.s  "_MGB_HtmlMiddle_END_"
  
  _MGB_HtmlBottom:                                                                                   ; 
  
  Data.s "</body>"
  Data.s "</html>"
  Data.s  "_MGB_HtmlBottom_END_"
EndDataSection

; IDE Options = PureBasic 5.62 (Windows - x86)
; CursorPosition = 611
; FirstLine = 596
; EnableAsm
; EnableXP
; CompileSourceDirectory
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant